void PreviewQuickFeed(int PassedID)
{ 
  //Loads the Thumbnails into the Preview Graphics array which is displayed
  println("PreviewQuickFeed() "+PassedID);
  PreviewBuffer.beginDraw();
  PreviewBuffer.image(CachedThumbnails[PassedID], 0, 0, MatrixHeight, MatrixWidth);
  PreviewBuffer.endDraw();
  PreviewColorEffects(PassedID); //fill color Effects to PreviewBuffer
  DisplayThumbnail = PassedID;  
  DisplayPreview = true;
} //end PreviewQuickFeed()

//====================================================================================================

void SetControlStateFunc(Movie m, Button[] b, int controlState)
{
  println("SetControlStateFunc "+controlState);

  b[0].Selected = false;
  b[1].Selected = false;  
  b[2].Selected = false;  

  switch(controlState)
  {
  case 0: //Play
    try {
      m.loop();
    }
    catch(Exception e) {
    }
    b[0].Selected = true;
    b[0].display();
    break;
  case 1: //pause
    try {
      m.play(); //will display the first frame when open a paused QuickFeed, but will not remember where it was paused
      //     m.jump(0);
      //   m.read();
      m.pause();
    }
    catch(Exception e) {
    }
    b[1].Selected = true;
    b[1].display();
    break;
  case 2: //stop
    try {
      m.stop();
    }
    catch(Exception e) {
    }
    b[2].Selected = true;
    b[2].display();    
    break;
  }//end switch
  b[0].display();
  b[1].display();
  b[2].display();
} //end func

void SetEffectStateFunc(Button[] b, int effectNum)
{
  println("SetEffectStateFunc "+effectNum);

  b[5].Selected = false;
  b[11].Selected = false;  

  switch(effectNum)
  {
    //0 is none
  case 1:
    b[5].Selected = true; //invert
    break;
  case 2:
    b[11].Selected = true; //contrast
    break;    
  case 3:
    b[5].Selected = true; //invert
    b[11].Selected = true;  //contrast    
    break;
  }

  b[5].display();
  b[11].display();
} //end func

void SetColorStateFunc(Button[] b, int colorEffectNum)
{
  b[6].Selected = false;
  b[7].Selected = false;  
  b[9].Selected = false;   
  b[10].Selected = false;   

  switch(colorEffectNum)
  {
    //0 is none
  case 1:
    b[6].Selected = true;
    break;
  case 2:
    b[7].Selected = true;
    break;    
  case 3:
    b[9].Selected = true;
    break; 
  case 4:
    b[10].Selected = true;
    break;
  }

  if (b == FeedAButtons)
  {
    QuickFeeds[FeedASelQuick].SliderRed = CommonSliders[0].Value;
    QuickFeeds[FeedASelQuick].SliderGreen = CommonSliders[1].Value;
    QuickFeeds[FeedASelQuick].SliderBlue =CommonSliders[2].Value;
    CommonSliders[0].display();
    CommonSliders[1].display();    
    CommonSliders[2].display();
  }
  else
  {
    QuickFeeds[FeedBSelQuick].SliderRed = CommonSliders[3].Value;
    QuickFeeds[FeedBSelQuick].SliderGreen = CommonSliders[4].Value;
    QuickFeeds[FeedBSelQuick].SliderBlue = CommonSliders[5].Value;  
    CommonSliders[3].display();
    CommonSliders[4].display();
    CommonSliders[5].display();
  }
  b[6].display();
  b[7].display();
  b[9].display();
  b[10].display();
} //end func


void LoadQuickFeed(Movie m, QuickFeed qf)
{ 
  //All QuickFeed Loads come through here, regardless of method

  //Have to set a flag for Feed A or B now, before the object is disposed, checking m after that won't work right
  if (m == myMovieA) FeedFlag = true; 
  else FeedFlag = false;

  if (qf.Method == 0)
  {
    println("Method 0, Loading: "+Matrix.matrixAbsoluteFootagePath+qf.FileName);    
    if (m == myMovieA)
    {
      try {
        myMovieA.stop();
        myMovieA.dispose(); //tested as not necassary to prevent CPU usage bloating
      }
      catch(Exception e) {
        println("FeedA Movie Null, stop() not executed");
      }
      try {   
        myMovieA = new Movie(this, Matrix.matrixAbsoluteFootagePath+qf.FileName);
      }
      catch(Exception e) {
        myMovieA = new Movie(this, "testbars.png");
        println("Load Exception FeedA");
      }
      FeedAGenerating = false; 
      arrayCopy(cNotUsedLabels, GenSliderLabelsA); //make the generated sliders say Not Used
      SetControlStateFunc(myMovieA, FeedAButtons, qf.ControlState);
    } //end MovieA
    else //start MovieB
    {
      try { //could merge  the try and catch to stop and dispose
        myMovieB.stop();
        myMovieB.dispose();
      }
      catch(Exception e) {
        println("FeedB Movie Null, stop() not executed");
      }

      try { 
        myMovieB = new Movie(this, Matrix.matrixAbsoluteFootagePath+qf.FileName);
      }
      catch(Exception e) {
        myMovieB = new Movie(this, "testbars.png");
        println("Load Exception FeedB ");
      }
      FeedBGenerating = false;
      arrayCopy(cNotUsedLabels, GenSliderLabelsB); //make the generated sliders say Not Used      
      SetControlStateFunc(myMovieB, FeedBButtons, qf.ControlState);
    }
  }
  else if (qf.Method == 2) //Image for now
  {  
    PImage tImg = loadImage(""+Matrix.matrixAbsoluteFootagePath+qf.FileName+"");    
    if (FeedFlag == true)
    {    
      GraphicsBufferA.beginDraw();
      GraphicsBufferA.image(tImg, 0, 0);
      GraphicsBufferA.endDraw();
    }
    else
    {
      GraphicsBufferB.beginDraw();
      GraphicsBufferB.image(tImg, 0, 0);
      GraphicsBufferB.endDraw();
    }

    qf.ControlState = 1; //pause it
  }
  else
  {
    //not a Movie or Image it is generated
    println("Generated");


    if (m == myMovieA) 
    {
    FrameFirstRunA = true;    //forst time DrawGenerated is ran it will allow the initialization switch() to run	
      FeedAGenerating = true;
      FrameMethodA = qf.Method; 
      DataFrameFeedA = 0;
      DrawGenerated(GraphicsBufferA);//this will setup the generated content


      SetControlStateFunc(myMovieA, FeedAButtons, qf.ControlState);

      try {
        myMovieA.stop();
        myMovieA.dispose();
      }
      catch(Exception e)
      {
        println("FeedA Movie Null, stop() not executed");
      }
    }
    else
    {
	  FrameFirstRunB = true;    //forst time DrawGenerated is ran it will allow the initialization switch() to run
      FeedBGenerating = true;
      FrameMethodB = qf.Method; 
      DataFrameFeedB = 0;      
      DrawGenerated(GraphicsBufferB); //this will setup the generated content  

      SetControlStateFunc(myMovieB, FeedBButtons, qf.ControlState);
      try {
        myMovieB.stop();
        myMovieB.dispose();
      }
      catch(Exception e)
      {
        println("FeedB Movie Null, stop() not executed");
      }
    }
  }

  //============== ALL METHODS RUN THIS ====================================
  if (FeedFlag == true)
  {
    println("Load FeedA, Speed: "+qf.Speed);
    if (qf.Speed > 0) CommonSliders[6].Value = round((qf.Speed * 10)+cDefaultSpeed);
    else CommonSliders[6].Value = round(cDefaultSpeed - ( (qf.Speed*-1) * 10));

    CommonSliders[0].Value = qf.SliderRed; //displayed in SetColorState
    CommonSliders[1].Value = qf.SliderGreen;
    CommonSliders[2].Value = qf.SliderBlue;
    CommonSliders[8].Value = qf.ContrastValue;   

    CommonSliders[6].display();      
    CommonSliders[8].display();   
    RedrawSpeeds();
    
    SetColorStateFunc(FeedAButtons, qf.ColorState); //sets the colorMode and button state based on variable
    SetEffectStateFunc(FeedAButtons, qf.EffectState);   //sets effect Mode and button states based on variable
  }
  else
  {
    println("Load FeedB, Speed: "+qf.Speed);
    if (qf.Speed > 0) CommonSliders[7].Value = round((qf.Speed * 10)+cDefaultSpeed);
    else CommonSliders[7].Value = round(cDefaultSpeed - ( (qf.Speed*-1) * 10));  

    CommonSliders[3].Value = qf.SliderRed;
    CommonSliders[4].Value = qf.SliderGreen;
    CommonSliders[5].Value = qf.SliderBlue;
    CommonSliders[9].Value = qf.ContrastValue;       

    CommonSliders[7].display();
    CommonSliders[9].display(); 
    RedrawSpeeds();

    SetColorStateFunc(FeedBButtons, qf.ColorState);
    SetEffectStateFunc(FeedBButtons, qf.EffectState);
  }
} //end LoadQuickFeed()


void stop()
{
  myMovieA.stop();
  myMovieB.stop(); 
  myMovieA.dispose();
  myMovieB.dispose();  
  myPort.stop();
  try {
    TCPclient.dispose();
    //   UDPclient.dispose(); //not stop, dispose or close
  }
  catch(Exception e)
  {
  }
  myBus.stop();
}

/*
//UNCOMMENT TO ENABLE FULLSCREEN
 boolean sketchFullScreen() {
 return true;
 }
 */