
int IdentifyBufferID(PGraphics passedBuf)
{
	if (passedBuf == GraphicsBufferA) return 0;
	else if (passedBuf == GraphicsBufferB) return 1;
	//2 more......

	return 0;
}

void SetGenSliderText(String[] passedStr, PGraphics passedBuf)
{
	switch(IdentifyBufferID(passedBuf))
	{
	case 0:
		arrayCopy(passedStr, GenSliderLabelsA);
		break;
	case 1:
		arrayCopy(passedStr, GenSliderLabelsB);
		break;
	}//end switch

} //end func

//=============================================================================================================

class ggObjText
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	int textNested = 0; 
	int textPosition = 0;


	void ggObjText()
	{
		ggName = "Text Scroll"; //force name
		ggIDnumber = 4;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		selBuffer.fill(255);
		selBuffer.noStroke();
		
		SetGenSliderText(cTextLabels, passedBuf);
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		selBuffer.beginDraw();
		//some defaults
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);


		selBuffer.background(0);
		HoldGenSlider3 = int(MatrixHeight*((float)HoldGenSlider3 / 255));
		HoldGenSlider2 = HoldGenSlider2/16;
		String holdStr;

		if (selBuffer == GraphicsBufferA)  holdStr = QuickFeeds[FeedASelQuick].UserID;
		else if (selBuffer == GraphicsBufferB) holdStr = QuickFeeds[FeedBSelQuick].UserID;
		else holdStr = QuickFeeds[DisplayThumbnail].UserID; 

		
		if (HoldGenSlider1 == 0) HoldGenSlider1 = 1; //fixes preview generation for now

		selBuffer.textSize(ceil((float)(MatrixHeight*((float)HoldGenSlider1/255))));

		if (textNested >= HoldGenSlider2)     
		{
			textNested = 0;

			if (ReverseFlag == true)
			{
				if (textPosition > MatrixWidth)  textPosition = int(-textWidth(holdStr));
				else textPosition += 1;
			}
			else
			{
				if (textPosition < -textWidth(holdStr)) textPosition = MatrixWidth;
				else textPosition -= 1;
			}
		}
		textNested++;
		selBuffer.text(holdStr, textPosition, HoldGenSlider3);   
		selBuffer.endDraw();		
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================
class ggObjImage
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;


	void ggObjImage()
	{
		ggName = "Image"; //force name
		ggIDnumber = 2;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjDATFile
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method

	void ggObjDATFile()
	{
		ggName = "DAT File"; //force name
		ggIDnumber = 3;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		
		SetGenSliderText(cNotUsedLabels, passedBuf);
		
		try 
		{ //try to load from selected .dat file, but if not found create empty array  
			if (selBuffer == GraphicsBufferA)
			{
				ByteBufferA = new byte[1]; //shrink just in case
				ByteBufferA = loadBytes(Matrix.matrixAbsoluteFootagePath+QuickFeeds[FeedASelQuick].FileName);
				println(".dat file  method setup A: "+ByteBufferA.length);
			}
			else {  
				ByteBufferB = new byte[1]; //shrink just in case
				ByteBufferB =  loadBytes(Matrix.matrixAbsoluteFootagePath+QuickFeeds[FeedBSelQuick].FileName);
				println(".dat file  method setup B: "+ByteBufferB.length);
			}
		}
		catch(Exception e)
		{
			if (selBuffer == GraphicsBufferA)
			{
				ByteBufferA = new byte[1]; //shrink just in case
				ByteBufferA = new byte[MaxChannels];
			}
			else
			{
				ByteBufferB = new byte[1]; //shrink just in case
				ByteBufferB = new byte[MaxChannels];
			}
		}    
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		LoadVideoDataFrame(selBuffer);	
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjStarField
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int reps = 255; //starfield
	float [] ypos = new float[reps]; //starfield
	float [] xpos = new float[reps]; //starfield
	int instance = 0; //starfield
	int refreshPoint = 100; //starfield


	void ggObjStarField()
	{
		ggName = "Star Field"; //force name
		ggIDnumber = 101;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cStarFieldLabels, passedBuf);
		
		selBuffer.fill(255);
		selBuffer.rectMode(CENTER);  
		selBuffer.ellipseMode(CENTER);     
		for (instance = 0; instance < reps; instance ++) 
		{
			xpos[instance] = int(random(-(MatrixWidth/2), (MatrixWidth/2)));
			ypos[instance] = int(random(-(MatrixHeight/2), (MatrixHeight/2)));
		}  	//end for()
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		//Where was this from??
		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.pushMatrix();
		selBuffer.translate(MatrixWidth/2, MatrixHeight/2);
		for (instance = 0; instance < HoldGenSlider4; instance ++) {
			selBuffer.stroke(255, instance);

			selBuffer.strokeWeight(1);  //would like to control this as well but its not worth additional effort

			int sSize = round(HoldGenSlider2 / 8);
			if (sSize == 0) sSize = 1;

			if (HoldGenSlider3 > 128) selBuffer.fill(0, 0, 0, 0);
			else  selBuffer.fill(255);

			if (HoldGenSlider1 < 85)  selBuffer.point(int(xpos[instance]), int(ypos[instance]));
			else if (HoldGenSlider1 < 170) selBuffer.ellipse(int(xpos[instance]), int(ypos[instance]), sSize, sSize);
			else selBuffer.rect(int(xpos[instance]), int(ypos[instance]), sSize, sSize);

			xpos[instance]= xpos[instance]+(xpos[instance])/100.0;
			ypos[instance]= ypos[instance]+(ypos[instance])/100.0;

			if ((xpos[instance] < -MatrixWidth) || (xpos[instance] > MatrixWidth) ||
					(ypos[instance] < -MatrixHeight) || ( ypos[instance] > MatrixHeight)) 
			{
				xpos[instance] = random(-refreshPoint, refreshPoint);
				ypos[instance] = random(-refreshPoint, refreshPoint);
			}
		}
		selBuffer.popMatrix(); 
		selBuffer.endDraw();		
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjSpinningSquare
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int TempRotation = 45; //spinning cube
	int TempScale = 10; //spinning cube
	int ScaleEndPoint =20; //spinning cube

	void ggObjSpinningSquare()
	{
		ggName = "Spinning Square"; //force name
		ggIDnumber = 102;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cSpinningSquare, passedBuf);	
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		selBuffer.rectMode(CENTER);  
		selBuffer.colorMode(HSB, 255);

		if (HoldGenSlider1 == 0)     selBuffer.fill(0, 0, 255);
		else  selBuffer.fill(HoldGenSlider1, 255, 255);

		if (HoldGenSlider2 == 0)     selBuffer.stroke(0, 0, 255);
		else  selBuffer.stroke(HoldGenSlider2, 255, 255);

		selBuffer.strokeWeight(round(HoldGenSlider3/32));           
		selBuffer.background(0);    
		selBuffer.pushMatrix();
		selBuffer.translate(MatrixWidth/2, MatrixHeight/2);
		selBuffer.rotate(radians(TempRotation));
		selBuffer.scale((float)TempScale/100);
		//    selBuffer.rectMode(CENTER);      //Mysteriously stopped working and would only do (CORNERS) so I calculate it below instead
		//    selBuffer.rect(-(HoldGenSlider4/2), -(HoldGenSlider4/2), HoldGenSlider4, HoldGenSlider4);    //switch these two lines for the one below if it is fixed in future Processing Releases
		selBuffer.rect(-(HoldGenSlider4/2)+(HoldGenSlider4/2), -(HoldGenSlider4/2)+(HoldGenSlider4/2), HoldGenSlider4, HoldGenSlider4);
		selBuffer.popMatrix();

		if (ReverseFlag == true) TempRotation+=10;
		else TempRotation-=10;

		if (TempRotation >= 360) TempRotation = 0;
		else if (TempRotation < 0) TempRotation = 360 + TempRotation;

		if (TempScale != ScaleEndPoint) 
		{
			if (ScaleEndPoint > TempScale) TempScale = TempScale + 1;
			else TempScale = TempScale - 1;
		} 
		else if (ScaleEndPoint == TempScale) 
		{
			ScaleEndPoint = int(random(0, MatrixWidth*10)); //CHANGERD FROM 200, CHECK!!
		} 
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText


//=============================================================================================================

class ggObjRipples
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	float genCircleX1 = 0; //circle ripple generation
	float genCircleX2 = 0;
	float genCircleX3 = 0;

	void ggObjRipples()
	{
		ggName = "Ripples"; //force name
		ggIDnumber = 103;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cRipplesLabels, passedBuf);

		genCircleX1 =0.0;
		genCircleX2 = 0.45;
		genCircleX3 = 0.95;
		selBuffer.fill(0, 0, 0, 0); //fill transparent
		selBuffer.ellipseMode(CENTER);
		selBuffer.rectMode(CENTER);    
		selBuffer.stroke(255);
		
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
	//	selBuffer.rectMode(CENTER);       
		selBuffer.strokeWeight(1);
		//end defaults

    selBuffer.background(0);  
    selBuffer.strokeWeight(HoldGenSlider2/32);
        
    if (HoldGenSlider1 <128)  
    {
      selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX1, 25*genCircleX1);      
      selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX2, 25*genCircleX2);           
      selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX3, 25*genCircleX3);
    }
    else 
    {
      selBuffer.rect(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX1, 25*genCircleX1);      
      selBuffer.rect(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX2, 25*genCircleX2);           
      selBuffer.rect(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX3, 25*genCircleX3);
    }

    if (ReverseFlag == false)    
    {
      genCircleX1 +=0.05;
      genCircleX2 +=0.05;
      genCircleX3 +=0.05;
      if (genCircleX1 >= 1) genCircleX1 = 0;
      if (genCircleX2 >= 1) genCircleX2 = 0;
      if (genCircleX3 >= 1) genCircleX3 = 0;
    }
    else
    {
      genCircleX1 -=0.05;
      genCircleX2 -=0.05;
      genCircleX3 -=0.05;
      if (genCircleX1 <= 0) genCircleX1 = 1 + genCircleX1;
      if (genCircleX2 <= 0) genCircleX2 = 1 + genCircleX2;
      if (genCircleX3 <= 0) genCircleX3 = 1 + genCircleX3;
    }



		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjMetaBalls
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int numBlobs = 8; //metaballs
	int blobSize = 100;   //metaballs
	Blob b[] = new Blob[25];//metaballs
	int TempMetalBalls = 0; //metaballs temp

	void ggObjMetaBalls()
	{
		ggName = "Meta Balls"; //force name
		ggIDnumber = 104;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cMetaBallsLabels, passedBuf);	
		
		for (int i=0; i< 25; i++) { //create blob objects
			b[i] = new Blob(random(MatrixWidth), random(MatrixHeight), random(-1, 1), random(-1, 1));
		}  
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		/* Taken from OpenProcessing.org and modified to suit    
	/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/10275*@* */
		/* !do not delete the line above, required for linking your tweak if you re-upload */
		/**
	* Rick Companje's version of the Metaball demo
	* Heavily insprired by Metaball Demo Effect by luis2048. 
	*/
		float frequency = (float)HoldGenSlider3 / 255;
		numBlobs = round(HoldGenSlider1/10);
		blobSize = round(HoldGenSlider2*10);

		TempMetalBalls++; //variable for the color cycling
		if (TempMetalBalls > 127) TempMetalBalls = 0;

		for (int q=0; q < numBlobs; ++q) {
			b[q].update();
		}

		//colorMode, 0 is color cycle, 1 is white, 2 is red, 3 green, 4 blue, 5 yellow, 6 purple, 7 turquoise,
		int MetaColorMode = round(HoldGenSlider4 / 32);
		int red = 255;
		int green = 255;
		int blue = 255;

		//reduntant other than switching between color cycle and white since all the colors could be done with the color effects
		switch(MetaColorMode)
		{
		case 0:
			red = round(sin(frequency*TempMetalBalls+ 0) * 255);
			green = round(sin(frequency*TempMetalBalls + 2) * 255);
			blue =round(sin(frequency*TempMetalBalls + 4) * 255);   
			break;
		case 1:
			//stays at 255
			break;
		case 2: //red
			red = 255;
			green = 0;
			blue = 0;
			break;  
		case 3: //green
			red = 0;
			green = 255;
			blue = 0;
			break;    
		case 4: //blue
			red = 0;
			green = 0;
			blue = 255;
			break;    
		case 5: //yellow
			red = 255;
			green = 255;
			blue = 0;
			break;  
		case 6: //purple
			red = 255;
			green = 0;
			blue = 255;
			break;   
		case 7: //turquoise
			red = 0;
			green = 255;
			blue = 255;
			break;
		}

		// Output into a buffered image for reuse
		selBuffer.loadPixels();    
		for (int y=0; y<MatrixHeight; y++) {
			for (int x=0; x<MatrixWidth; x++) {
				int m = 1;
				for (int i=0; i < numBlobs; i++) {
					// Increase this number to make your blobs bigger
					m += blobSize/(b[i].bx[x] + b[i].by[y] + 1); //was 20k
				}
				selBuffer.pixels[x+y*MatrixWidth] =color(round((((float)red/255)*(m-x))/2), round((((float)green/255)*(m-x))/2), round((((float)blue/255)*(m-x))/2));
			}
		}
		selBuffer.updatePixels();
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjPlasma
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int[][] waves = new int[1000][3]; // sine waves
	int[] luma = new int[1024]; // brightness curve
	int[][][] pos = new int[3][2][3]; // positions RGB,XY,123
	float[][][] velocity = new float[3][2][3]; // velocity RGB,XY,123
	int[][][] cWaves = new int[300][3][2]; // pos,RGB,XY
	int ix;
	int iy;
	int iz;

	void ggObjPlasma()
	{
		ggName = "Plasma"; //force name
		ggIDnumber = 105;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);	
		
		/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/7035*@* */
		/* !do not delete the line above, required for linking your tweak if you re-upload */
		// PLASMA - Will Birtchnel 2010

		// randomize positions
		for (ix=0;ix<3;ix++) {
			for (iy=0;iy<2;iy++) {
				for (iz=0;iz<3;iz++) {
					pos[iz][iy][ix]=int(random(512));
					velocity[iz][iy][ix]=random(-3, 3);
				}
			}
		}

		// make sine waves
		for (ix=0;ix<100;ix++) {
			waves[ix][0]= (int)(100+ (sin(ix*TWO_PI/MatrixWidth)*100));
			waves[ix][1]= (int)(50+  (sin(ix*2*TWO_PI/MatrixWidth)*50));
			waves[ix][2]= (int)(25+  (sin(ix*3*TWO_PI/MatrixWidth)*25));
		}

		// make luma wave
		for (ix=0;ix<1024;ix++) {
			iy=ix;
			while ( (iy>255)||(iy<0)) {
				if (iy>255) iy=511-iy;
				if (iy<0) iy=abs(iy);
			}
			if (iy>201) iy=((iy*4)-(201*3));
			iy=(int)((iy*255)/((255*4)-(201*3)));
			luma[ix]=iy;
		}	
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		// PLASMA - Will Birtchnel 2010
		//From http://www.openprocessing.org/sketch/7035
		// update velocity
		for (ix=0;ix<3;ix++) {
			for (iy=0;iy<2;iy++) {
				for (iz=0;iz<3;iz++) {
					velocity[iz][iy][ix]+=random(-0.1, 0.1); 
					if (velocity[iz][iy][ix]>(3-ix)) velocity[iz][iy][ix]=(3-ix);
					if (velocity[iz][iy][ix]<(-3+ix)) velocity[iz][iy][ix]=(-3+ix);
				}
			}
		} 
		// update positions
		for (ix=0;ix<3;ix++) {
			for (iy=0;iy<2;iy++) {
				for (iz=0;iz<3;iz++) {
					pos[iz][iy][ix]+=int(velocity[iz][iy][ix]); 
					if (pos[iz][iy][ix]>=MatrixWidth) pos[iz][iy][ix]-=MatrixWidth*2;
					if (pos[iz][iy][ix]<0) pos[iz][iy][ix]+=MatrixWidth*2;
				}
			}
		}   
		// make composite waves
		for (ix=0;ix<MatrixWidth;ix++) {  
			for (iy=0;iy<3;iy++) {
				for (iz=0;iz<2;iz++) {
					cWaves[ix][iy][iz]= waves[ix+pos[iy][iz][0]][0]  + waves[ix+pos[iy][iz][1]][1] + waves[ix+pos[iy][iz][2]][2];
				}
			}
		}
		//draw pixels
		selBuffer.loadPixels();
		for (iy = 0; iy < MatrixHeight; iy++) {
			int xOff=iy*MatrixWidth;
			for (ix = 0; ix < MatrixWidth; ix++) {       
				selBuffer.pixels[xOff+ix]=(luma[cWaves[ix][0][0]+cWaves[iy][0][1]]<<16)+(luma[cWaves[ix][1][0]+cWaves[iy][1][1]]<<8)+luma[cWaves[ix][2][0]+cWaves[iy][2][1]];
			}
			selBuffer.updatePixels();
		}
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjSpiral
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	float rotation;// = 0; //for spiral
	float hue;//=0; //for spiral coloring
	//float FadeOutFactor;// = 0;


	void ggObjSpiral()
	{
		ggName = "Spiral"; //force name
		ggIDnumber = 106;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cSpiralLabels, passedBuf);
		selBuffer.colorMode(HSB, 100);
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		// Learning Processing - Daniel Shiffman
		// http://www.learningprocessing.com
		// Exercise 13-5: Using Example 13-5, draw a spiral path.   
		int chord = 1;  //spacing between LEDs
		float thetaMax = round((HoldGenSlider1/25) * 2 * PI); //up to 10 coils
		float awayStep = 0; 
		int LocalColorMode = round((HoldGenSlider3/84)); //0 - 3
		float SpiralFadeOutFactor = (float)HoldGenSlider4 / 255;

		DecayBuffer(SpiralFadeOutFactor, selBuffer); //run Decay Function
		selBuffer.colorMode(RGB, 255);
		selBuffer.colorMode(HSB, 100);
		selBuffer.strokeWeight(1);

		if (MatrixWidth > MatrixHeight)  awayStep = (MatrixWidth/2) / thetaMax;
		else awayStep = (MatrixHeight/2) / thetaMax;

		for (float theta = chord / awayStep; theta <= thetaMax; ) 
		{
			float away = awayStep * theta;    // How far away from center
			float around = theta + rotation;    // How far around the center.
			// Convert 'around' and 'away' to X and Y.
			int xpos = (int)round((MatrixWidth/2) + cos( around ) * away);
			int ypos = (int)round((MatrixHeight/2) + sin( around ) * away);

			switch(LocalColorMode) 
			{
			default:// 0 or 3 or 4 
				selBuffer.stroke(0, 0, 100); //HSB color white
				break;
			case 1:
				selBuffer.stroke(hue, 100, 100);  //use hue    
				break;
			case 2:
				hue+=(float)HoldGenSlider2 / 64;
				if (hue>=100) {
					hue=hue-100;
				}    
				selBuffer.stroke(hue, 100, 100);  //use hue    
				break;
			}
			selBuffer.point(xpos, ypos); 
			theta += chord / away;
		}//end for()

		if (LocalColorMode == 1)
		{
			hue+=(float)HoldGenSlider2 / 64; //cycle through
			if (hue>=100) {
				hue=hue-100;
			}
		}
		else if (LocalColorMode == 2)  hue=0; //reset if in colormode offset

		if (ReverseFlag == true) rotation += 0.5; //rotate spiral
		else rotation -= 0.5; //rotate spiral
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjFallingBlocks
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int[] fallingBlocksArray;// = new int[1]; //for falling blocks
	float FallingBlocksFadeOutFactor;


	void ggObjFallingBlocks()
	{
		ggName = "Falling Blocks"; //force name
		ggIDnumber = 109;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cFallingBlocks, passedBuf);

		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.fill(255);  
		selBuffer.stroke(255);   


		fallingBlocksArray = new int[MatrixHeight];


		//randomly fill stating up to MatrixHeight
		for (int i = 0; i != MatrixWidth; i++)   fallingBlocksArray[i] = (int)random(0, MatrixHeight);
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		FallingBlocksFadeOutFactor = (float)HoldGenSlider3 / 255; //calculates the decay factor
		DecayBuffer(FallingBlocksFadeOutFactor, selBuffer); //run Decay Function

//println("===="+MatrixHeight+" : "+MatrixWidth

		if (ReverseFlag == true)
		{
			if ((HoldGenSlider4/128) == 0)
			{ //fall Up
				for (int i = 0;i != MatrixWidth; i++)   
				{
					fallingBlocksArray[i]--;
					if (fallingBlocksArray[i] < 0) fallingBlocksArray[i] =  (int)random((HoldGenSlider2*2)+MatrixHeight, MatrixHeight+1);
					selBuffer.rect(i, fallingBlocksArray[i], HoldGenSlider1/16, HoldGenSlider1/16);
				} //end for()
			} //end if()
			else
			{ //fall to the left
				for (int i = 0;i != MatrixHeight; i++) 
				{
					fallingBlocksArray[i]--;
					if (fallingBlocksArray[i] < 0) fallingBlocksArray[i] =  (int)random((HoldGenSlider2*2), MatrixWidth-1);
					selBuffer.rect(fallingBlocksArray[i], i, HoldGenSlider1/16, HoldGenSlider1/16);
				} //end for()
			}//end else
		} //end reverse if()
		else
		{ 
			if ((HoldGenSlider4/128) == 0)
			{ //Fall down
				for (int i = 0;i != MatrixWidth; i++) 
				{
					fallingBlocksArray[i]++;
					if (fallingBlocksArray[i] > MatrixHeight) fallingBlocksArray[i] =  (int)random(-(HoldGenSlider2*2), -1);
					selBuffer.rect(i, fallingBlocksArray[i], HoldGenSlider1/16, HoldGenSlider1/16);
				} //for()
			}
			else
			{ //fall to the right
				for (int i = 0;i != MatrixHeight; i++) 
				{
					fallingBlocksArray[i]++;
					if (fallingBlocksArray[i] > MatrixWidth) fallingBlocksArray[i] =  (int)random(-(HoldGenSlider2*2), -1);
					selBuffer.rect(fallingBlocksArray[i], i, HoldGenSlider1/16, HoldGenSlider1/16);
				} //for()
			}
		}  
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjTestStepThrough
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method

	void ggObjTestStepThrough()
	{
		ggName = "Test Step Through"; //force name
		ggIDnumber = 123;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);

		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.fill(255);  
		StepThroughVar = 0;
	} //end ggInitilaize()

	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		selBuffer.background(0);
		selBuffer.set(PatchCoordX[StepThroughVar], PatchCoordY[StepThroughVar], color(255));
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText