class ButtonSq extends Button {
  // Variables are inherited from the parent.
  // We could also add variables unique to the Square class if we so desire

  ButtonSq(String Label, int xpos, int ypos, int bWidth, int bHeight, color ColBG, color ColHL, color ColOut, boolean Toggle, boolean Selected, boolean Focused)
  {
    // If the parent constructor takes arguments then super() needs to pass in those arguments.
    super(Label, xpos, ypos, bWidth, bHeight, ColBG, ColHL, ColOut, Toggle, Selected, Focused);
  }

  void displaySq(int PassedID)
  {
    strokeWeight(2);

    if(Matrix.softwareEnableThumbnails == true)
    {
      PreviewBuffer.beginDraw();
      PreviewBuffer.image(CachedThumbnails[PassedID], 0, 0, MatrixWidth, MatrixHeight);
      PreviewBuffer.endDraw();
      PreviewColorEffects(PassedID); //fill color Effects to PreviewBuffer
      image(PreviewBuffer, xpos, ypos, bWidth, bHeight);

      noFill();
      if (Selected==true)
      {
        stroke(ColHL); 
        fill(ColHL, 128);
      }
      else if (Focused == true)
      {
        stroke(cFocusedColor); 
        fill(cFocusedColor, 128);
      }
      else       
      {
        stroke(ColBG);
      }
      rect(xpos, ypos, bWidth, bHeight); //display overlay color with stroke
    }//end if()
    else
    {
      stroke(ColOut);

      if (Selected==true)  fill(ColHL);
      else if (Focused == true)   fill(cFocusedColor);
      else  fill(ColBG);
     
      rect(xpos, ypos, bWidth, bHeight);
    }

    noStroke();    
    //adjust stroke to on higlight and invert text color
    textSize((bHeight/1.75));
    fill(0);   
    text(Label, xpos+((bWidth - textWidth(Label))/2)+2, ypos+((bHeight-(textAscent()+textDescent()))/2)+2, bWidth, bHeight);        
    fill(255);
    text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/2), bWidth, bHeight);

    if (Toggle==false) Selected = false;
  }
}


//Copied From:
/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/10275*@* */
/* !do not delete the line above, required for linking your tweak if you re-upload */
/**
 * Rick Companje's version of the Metaball demo
 * Heavily insprired by Metaball Demo Effect by luis2048. 
 */

class Blob {
  float x, y;
  float vx, vy; 
  int[] bx, by;

  Blob(float x, float y, float vx, float vy) {
    this.x = x;
    this.y = y;
    this.vx = vx;
    this.vy = vy;
    this.bx = new int[MatrixWidth];
    this.by = new int[MatrixHeight];
  }

  void update() {
    x+=vx;
    y+=vy;

    if (x<0 || x>MatrixWidth) vx=-vx;
    if (y<0 || y>MatrixHeight) vy=-vy;

    for (int i=0; i<MatrixWidth; i++) bx[i] = int(sq(x-i));
    for (int i=0; i<MatrixHeight; i++) by[i] = int(sq(y-i));
  }
}

//================== End Copied ==============

class QuickFeed
{
  String UserID;
  int Method;
  String FileName;
  float Speed;
  int SliderRed;
  int SliderGreen;
  int SliderBlue;
  int OffsetX;
  int OffsetY;
  int ColorState; //0 regular, 
  int ControlState; //0 is play, 1 is pause, 2 is stop
  int EffectState; //0 regular, 1 invert, 2 contrast, 3 invert+contrast  
  int ContrastValue;
  int GenSlider1;
  int GenSlider2;
  int GenSlider3;
  int GenSlider4;
  /*
Methods:
   0 = Load Video
   1 = Capture Device
   
   Color State:
   0 = None
   1= Tint?? Check these
   2 = Filter??
   */

  QuickFeed(String iUserID, int iMethod, String iFileName, float iSpeed, int iSliderRed, int iSliderGreen, int iSliderBlue, int iOffsetX, int iOffsetY, 
  int iColorState, int iControlState, int iEffectState, int iContrastValue, int iGenSlider1, int iGenSlider2, int iGenSlider3, int iGenSlider4)
  {
    UserID = iUserID;
    Method = iMethod;
    FileName = iFileName;
    Speed = iSpeed;
    SliderRed = iSliderRed;
    SliderGreen = iSliderGreen;
    SliderBlue = iSliderBlue;
    OffsetX = iOffsetX;
    OffsetY = iOffsetY;
    ColorState = iColorState;
    EffectState = iEffectState;   
    ControlState = iControlState;
    ContrastValue = iContrastValue;
    GenSlider1 = iGenSlider1;
    GenSlider2 = iGenSlider2;
    GenSlider3 = iGenSlider3;
    GenSlider4 = iGenSlider4;
  }
}//end class

//============================================================================================

class GUIMenu
{
  String Label;
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int bWidth;
  int bHeight;
  int MenuID;
  boolean Opened;

  GUIMenu(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iMenuID, boolean iOpened)
  {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    MenuID = iMenuID;    
    Opened = iOpened;
  }

  void display()
  {
    switch(MenuID)
    {
    case 0: //no menu

      break;
    case 1: //OffsetMenu
      image(OffsetMenuBG, xpos, ypos);    
      break;        
    case 2: //Main Menu
      this.displayBG();        
      fill(cMenuBGColor); 
      stroke(cMenuFontColor);
      strokeWeight(1);
      rectMode(CENTER);
      rect(xpos+360, ypos+90, 80, 15);
      rect(xpos+360, ypos+105, 80, 15);     
      rect(xpos+360, ypos+120, 80, 15);
      rect(xpos+360, ypos+135, 80, 15);   
      rect(xpos+360, ypos+150, 80, 15);          
      rectMode(CORNER);    

      fill(cMenuFontColor);
      textSize(16);
      text(this.Label+":", xpos+10, ypos+20);

      for (int i = 0; i !=MainMenuButtons.length;i++) MainMenuButtons[i].display();

      textSize(12);
      fill(0); 
      textAlign(CENTER);
      text("GUI Size:\n640x480\n800x600\n1024x768\n1400x1050\nSet in Config", xpos+360, ypos+80);

      int strSize =Matrix.matrixAbsoluteFootagePath.length();
      String tempString = Matrix.matrixAbsoluteFootagePath;
      if (strSize > 18)  tempString = Matrix.matrixAbsoluteFootagePath.substring(0, 10) + "......"+Matrix.matrixAbsoluteFootagePath.substring(strSize-12);

      textAlign(LEFT);
      fill(cMenuFontColor);    
      text("Footage Path: "+tempString, xpos+10, ypos+80);
      text("Patch File: "+Matrix.matrixPatchFileName, xpos+10, ypos+100);        
      text("QuickFeed File: "+Matrix.matrixQuickFeedFileName, xpos+10, ypos+120);     
      text("Automatic File: "+Matrix.matrixAutomaticFileName, xpos+10, ypos+140);              
      text("Communication: ", xpos+10, ypos+160);        
      textSize(12);      
      text("Set Port Number & Baud Rate or\nServer IP & Server Port in device config file", xpos+40, ypos+180);             

      if (Matrix.softwareMIDIenable == true)
      {
        for (int i = 0; i != MIDIMenuButtons.length;i++)  MIDIMenuButtons[i].display();
      }
      break;    
    case 3: //Configure Menu
      this.displayBG();
      text(this.Label, xpos, 20+ypos);
      break;    
    case 4: //gen menu A
      this.displayBG();   
      textSize(16);
      for (int i = 0; i !=GenerationSliders.length;i++) //display each of the genration sliders, with the info above them
      {
        GenerationSliders[i].display();
        fill(cMenuFontColor);  
        text(GenSliderLabelsA[i]+":", GenerationSliders[i].xpos, GenerationSliders[i].ypos-(GenerationSliders[i].ypos/100));
      }
      break;
    case 5: //gen menu B
      this.displayBG();   
      textSize(16);
      for (int i = 0; i !=GenerationSliders.length;i++) 
      {
        GenerationSliders[i].display();
        fill(cMenuFontColor);  
        text(GenSliderLabelsB[i]+":", GenerationSliders[i].xpos, GenerationSliders[i].ypos-(GenerationSliders[i].ypos/100));
      }
      break;
    }
  }

  void displayBG()
  {
    stroke(cMenuStrokeColor);
    strokeWeight(2);
    fill(cMenuColor);
    rectMode(CORNER);
    rect(xpos, ypos, bWidth, bHeight, 10);
    noStroke();
  }

  void Toggle()
  {
    println("GUIMenu.Toggle()" + MenuID);

    if (Opened == true) 
    {
      GUIMenus[OpenMenuID].Opened=false;
      OpenMenuID = 0;
      Opened = false; 
      return;
    }
    else 
    {
      GUIMenus[OpenMenuID].Opened=false;
      Opened =! Opened;
      OpenMenuID = MenuID;
    }
  }

  boolean over() 
  { //checks of the mouse is over the slider, doesn't have to be on the handle
    int mX = round(mouseX / SF);
    int mY = round(mouseY / SF);      
  
    if ( mX >= xpos && mX <= xpos+bWidth && mY >= ypos && mY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
}//end class

//==================================================================

class PixelDisplay
{
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int bWidth;
  int bHeight;

  PixelDisplay(int ixpos, int iypos, int ibWidth, int ibHeight)//, color iTheColor)
  {
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
  }

  void display()
  {
    rect(xpos, ypos, bWidth, bHeight);
  }
}//end class

//==========================================
class Button
{
  String Label;
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int bWidth;
  int bHeight;
  color ColBG;
  color ColHL;
  color ColOut;  
  boolean Toggle;
  boolean Selected;
  boolean Focused;

  Button(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, color iColBG, color iColHL, color iColOut, boolean iToggle, boolean iSelected, boolean iFocused)
  {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    ColBG = iColBG;
    ColHL = iColHL;
    ColOut = iColOut;
    Toggle = iToggle;
    Selected = iSelected;
    Focused = iFocused;
  }

  void display()
  {
    strokeWeight(1);
    stroke(ColOut);

    if (Selected==true) fill(ColHL); 
    else if (Focused == true)   fill(cFocusedColor); 
    else fill(ColBG);

    rect(xpos, ypos, bWidth, bHeight, bHeight/6);  

    fill(cButtonTextColor);
    textSize((bHeight/1.75));
    text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5), bWidth, bHeight);
    noStroke();

    if (Toggle==false) Selected = false; //if not suppose to toggle, unhighlight
  }

  boolean over() 
  {
    int mX = round(mouseX / SF);
    int mY = round(mouseY / SF);    

    if ( mX >= xpos && mX <= xpos+bWidth && mY >= ypos && mY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
} 

//=====================================================================================

class SliderBar
{
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int slWidth; // single bar slWidthth
  int slHeight; // rect height
  int Value; 
  int Minimum; 
  int Maximum;
  color BgColor;
  color slHandleColor;
  color slSelectColor; 
  color slStrokeColor;
  boolean CircleHandle;  //ture circle, false rectangle
  boolean HorizVertToggle;
  int  SetNumber;
  

  //gotta move the int variables into float variables
  float temp1=slWidth;
  float temp2=Maximum;
  float temp3=Value;
  float temp4=Minimum;
  float MathVar=0;

  SliderBar(int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, color iBgColor, color islHandleColor, color islSelectColor, color islStrokeColor, boolean iCircleHandle, boolean iHorizVertToggle, int  iSetNumber)   
  {   
    xpos = ixp;
    ypos = iyp;  
    slWidth = iw;
    slHeight = ih;
    Value=iValue;
    Maximum=iMax;
    Minimum=iMin;
    BgColor=iBgColor;
    slHandleColor=islHandleColor;
    slSelectColor=islSelectColor;
    slStrokeColor=islStrokeColor;
    CircleHandle=iCircleHandle;     
    HorizVertToggle=iHorizVertToggle;
    SetNumber = iSetNumber;
  }

  void move(int uX, int uY) 
  {
    //this function handles position of the slider's handle
    temp1 = slWidth;   
    temp3 = Value;
    temp4 = Minimum;

    MathVar = (((uX-xpos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
    MathVar = Maximum - (MathVar*(Maximum-Minimum));       //relative to slider position

    if (MathVar > Maximum) { //check so it doesn't drag off the end
      MathVar=Maximum;
    }
    if (MathVar < Minimum) { //check so it doesn't drag off the end
      MathVar=Minimum;
    }  
    Value=int(MathVar); //set the value based on mouse movement
  }

  void display() 
  {
    if (this == MainMixerSlider || this == IntensitySliderA || this == IntensitySliderB)
    {
      temp1=slWidth-(slWidth/20);
      temp2=Maximum;  //move variables into float
      temp3=Value;    //or do they don't compute correctly
      temp4 = Minimum;
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 

      if (this == IntensitySliderA || this == IntensitySliderB) 
      {
        fill(cBackgroundColor);
        noStroke();
        rect(xpos-(slWidth/20), ypos-(slWidth/40), slWidth+(slWidth/8), slHeight+(slHeight/2)); 

        image(IntensityBG, xpos-(slWidth/20), ypos, slWidth+(slWidth/10), IntensityBG.height);
        image(MixerHandle, (xpos+MathVar), ypos-(slHeight/8), MixerHandle.width, MixerHandle.height/2);  
        return;
      }
      else   fill(cBackgroundColor);

      rect(xpos-(slWidth/20), ypos-(slWidth/35), slWidth+(slWidth/8), slHeight+(slHeight/3));

      image(MainMixerBG, xpos-(slWidth/20), ypos, slWidth+(slWidth/10), slHeight); //slHeight and width already scaledu sing SF
      image(MixerHandle, (xpos+MathVar), ypos-(slHeight/6), MixerHandle.width, MixerHandle.height);  
      return;
    }

    stroke(slStrokeColor);
    strokeWeight(1);

    //circle handles are displayed differently so there are if/else statements to set it correctly
    fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
    rect(xpos, ypos, slWidth, slHeight);   

    if (CircleHandle==true) temp1 = slWidth - slHeight;
    else temp1=slWidth-(slWidth/20);

    temp2=Maximum;  //move variables into float
    temp3=Value;    //or do they don't compute correctly
    temp4 = Minimum;

    float MathVar;

    if (CircleHandle==true)
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2;
    else  
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 

    fill(color(slSelectColor)); //draws the Selcolor over the selected area
    rect(xpos, ypos, MathVar, slHeight);

    fill(slHandleColor); //places the slider handle
    if (CircleHandle==true)   ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-1, slHeight-1); //Circle instead of rectangle
    else   rect((xpos+MathVar), ypos, slWidth/20, slHeight); //and comment this line for circle
  }


   void setValue(int passedVal)
  {
    Value = passedVal;
    println(Value);
    if (Value > Maximum) { //check so it doesn't drag off the end
      Value = Maximum;
    }
    if (Value < Minimum) { //check so it doesn't drag off the end
      Value=Minimum;
    }
  }//end setValue() 


  void selectSlider()
  {
  SliderPointer = this;
  GlobalDragging = true;
  }//end selectSlider



  boolean over() 
  {
    int mX = round(mouseX / SF);
    int mY = round(mouseY / SF);    
    
    if (mX >= xpos && mX <= xpos+slWidth && mY >= ypos && mY <= ypos+slHeight) 
    {          
      return true;
    } 
    else {
      return false;
    }
  }
}

//=========================================
/*
class VertSliderBar
 {
 int xpos; // rect xposition  
 int ypos ; // rect yposition
 int slWidth; // single bar slWidthth
 int slHeight; // rect height
 int Value; 
 int Minimum; 
 int Maximum;
 color BgColor;
 color HandleColor;
 color SelectColor; 
 color StrokeColor;
 boolean CircleHandle;  
 boolean Dragging;
 
 
 //local variables 
 boolean over = false;
 
 //gotta move the int variables into float variables
 float temp1=slWidth;
 float temp2=Maximum;
 float temp3=Value;
 float temp4=Minimum;
 float MathVar=0;
 
 
 VertSliderBar(int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, color iBgColor, color iHandleColor, color iSelectColor, color iStrokeColor, boolean iCircleHandle, boolean iDragging) 
 {   
 xpos = ixp;
 ypos = iyp;  
 slWidth = iw;
 slHeight = ih;
 Value=iValue;
 Maximum=iMax;
 Minimum=iMin;
 BgColor=iBgColor;
 HandleColor=iHandleColor;
 SelectColor=iSelectColor;
 StrokeColor=iStrokeColor;
 CircleHandle=iCircleHandle;     
 Dragging=iDragging;
 }
 
 void move () //VERTICLE
 {
 //this function handles position of the slider's handle
 
 temp1 = slHeight;   
 temp3 = Value;
 temp4 = Minimum;
 
 MathVar = (((mouseY-ypos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
 //relative to slider position
 MathVar = Maximum - (MathVar*(Maximum-Minimum));   
 
 if (MathVar > Maximum) { //check so it doesn't drag off the end
 MathVar=Maximum;
 }
 
 if (MathVar < Minimum) { //check so it doesn't drag off the end
 MathVar=Minimum;
 }  
 
 Value=int(MathVar); //set the value based on mouse movement
 }
 
 void move(int uX, int uY) 
 {
 //this function handles position of the slider's handle
 
 temp1 = slWidth;   
 temp3 = Value;
 temp4 = Minimum;
 
 MathVar = (((uX-xpos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
 //relative to slider position
 MathVar = Maximum - (MathVar*(Maximum-Minimum));   
 
 if (MathVar > Maximum) { //check so it doesn't drag off the end
 MathVar=Maximum;
 }
 
 if (MathVar < Minimum) { //check so it doesn't drag off the end
 MathVar=Minimum;
 }  
 
 Value=int(MathVar); //set the value based on mouse movement
 }
 
 
 
 void display() //VERTICLE
 {
 stroke(StrokeColor);
 strokeWeight(1);
 
 //circle handles are displayed differently so there are if/else statements to set it correctly
 
 fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
 rect(xpos, ypos, slWidth, slHeight);   
 
 temp1 = slHeight - slWidth;
 
 temp2= Maximum;  //move variables into float
 temp3= Value;    //or do they don't compute correctly
 temp4 = Minimum;
 
 float MathVar;
 MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slWidth/2;
 fill(color(SelectColor)); //draws the Selcolor over the selected area
 rect(xpos, ypos, slWidth, MathVar);
 fill(HandleColor); //places the slider handle
 ellipse(xpos+(slWidth/2), ypos+MathVar, slWidth, slWidth); //Circle instead of rectangle
 }
 
 boolean over() 
 { //checks of the mouse is over the slider, doesn't have to be on the handle
  int mX = round(mouseX / SF);
  int mY = round(mouseY / SF);    

 if ( mX >= xpos && mX <= xpos+slWidth && mY >= ypos && mY <= ypos+slHeight) 
 {      
 Dragging=true;
 over = true;
 return true;
 } 
 else {
 over = false;
 return false;
 }
 }
 }
 */