import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.video.*; 
import processing.serial.*; 
import javax.swing.ImageIcon; 
import themidibus.*; 
import ddf.minim.*; 
import de.humatic.dsj.*; 
import java.awt.image.BufferedImage; 
import processing.net.*; 
import netP5.*; 

import de.humatic.dsj.*; 
import de.humatic.dsj.com.*; 
import de.humatic.dsj.edit.*; 
import de.humatic.dsj.ext.*; 
import de.humatic.dsj.rc.*; 
import de.humatic.dsj.sbe.*; 
import de.humatic.dsj.sink.*; 
import de.humatic.dsj.sink.sa.*; 
import de.humatic.dsj.src.*; 
import de.humatic.dsj.src.rtmp.*; 
import de.humatic.dsj.src.rtp.*; 
import de.humatic.dsj.util.*; 
import de.humatic.dsj.xml.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class NLEDMatrix extends PApplet {

/*
This program is free software: you can redistribute it and/or modify
 it under the terms of the Attribution 4.0 International as published by
 Creative Commons.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 
 You should have received a copy of the  Attribution 4.0 International as published by
 Creative Commons or visit http://creativecommons.org/licenses/by/4.0/legalcode
 
 Original Author: Jeffrey Nygaard
 Company: Northern Lights Electronic Design, LLC
 Contact: JNygaard@NLEDShop.com
 Date Updated: October 28, 2015
 Webpage: www.NLEDShop.com/nledmatrix
 Written in Processing v3.0 - www.Processing.org
 Software Version: 2b
 
 3rd Party Libraries Utilized:
 netP5 - http://www.sojamo.de/libraries/oscP5/
 Minim - http://code.compartmental.net/tools/minim/
 TheMIDIbus - http://www.smallbutdigital.com/themidibus.php
 DirectShow - http://www.humatic.de/htools/dsj.htm
 
 This software is offered for free and is open-source. You may use it for your commercial projects as described in the license. You may modify
 it to suit you, and share your code if you wish, as long as you give attribution and release it under the same license. It is encouraged to submit 
 improvements and bug fixes so they can be added to the main release version.
 
 Compatible High Quality, LED Controllers for WS2801, WS2803, WS2811, WS2812, WS2812B, LDP8806, along with standard LEDs, and LED Strip  
 are available for purchase from the store. In addition to data interface controllers, a selection of stand-alone with powerful fimrware will soon be
 available.
 
 Please utilize and enjoy the software however you like. Please support the development and improvements, a quite a bit of time has been spent
 producing this software for all to use and modify as they like. If you are able to, please donate or purchase a controller from the store.
 
 I am always interested in developing new devices and software, helping people on their projects, and maybe doing some collabs
 Please contact me at the address above. This is the initial release, and is still pretty rough and documentation isn't completed. Please contact 
 Jnygaard@NLEDshop.com with any questions, bug reports, feature requests, critiques, anything at all, I want to hear about it.
 
 //============================================================================================================
 
 Intro:
 Originally this was going to be a very simple program that converted a movie file into serial data and send it out using a custom patch. But it grew and
 grew into the current behemoth, over time I have added nearly every feature I can think of, or thought was reasonable enough to support. I want
 this software to be available to everyone, to use how they like. Building custom hardware interfaces should be easy enough and is encouraged.
 But please if posting projects online or to social media, please give a link back to the original software. And if you find it very useful you can 
 donate to future development or purchase a controller from Northern Lights Electronic Design.
 
 Description:
 NLED Matrix is a Java based application used for mixing and controlling video content and to output it to a custom DIY LED Matrix or matrices, which can
 be of any shape and size. NLED-Matrix supports pixel patching, which allows the user to create the order in which the software outputs the data to the LED
 Pixels. That means any shape of LED matrix, any layout, any color order, with any type of control scheme can be made to work with the software. It allows
 two feeds of video data, either from a file such as .MOV, from an image, from a external video feed, or from any of the numerous generated content. The 
 mixed video feed can be sent over Serial(USB Adapter, or RS-485 adapter), TCP, or UDP.  
 
 Video feed sources can be video files(AVI, MPG, MOV, and others), one of the several generated content(Meta balls, Spiral, star field, plasma, 
 sound reactive sine, sound reactive bars), custom .dat  files(text files containing the video data, videos converted using a different Processing
 program), DShow input(camera feed, such as screen grabber on Milkdrop or other visualizer)
 
 More generated feeds will be written and added in the future. If you have any you would like to get added in to NLED-Matrix, contact the author.
 
 There are a few options available to transmit the data, such as the basic Serial, to connect to something such as an USB to Serial Adapter, or a
 USB Enabled Microcontroller. Or even directly to most Arduino boards. And it supports TCP or UDP communication of a network or internet. Tested it
 with TCP and UDP connections to an X-Bee Wifi, worked well enough.
 
 //============================================================================================================
 
 DShow/Web Cam Input/screen capture notes
	- use Many Cam, window mode. Screen caputre Milkdrop
		- milkdrop wouldn't stop freezing, tried to caputre full window, didn't work, reverted to window and it worked just fine after that....
                - tried again and confrim that milkdrop would freeze if many cam was running, did options set to full screen
	- zoom in with many cam and turn off the logo watermark
	- For MAC and Linux users, you will have to comment out/delete all the Direct Show code, its all labled
 
 
 Good Mildrop 2 Presets for low res displays:
	Light in the sky, martin-deep blue, martin-glass corridor, Orb-Acid Cycle, Orb-Acid Cycle Gas Giant, Orb-Acid Lamp,Orb-Dark Omen,
		redi jedi-i don't think, long name - machine code, psychotic flower gelatine burst, BrainStain-Blackwidow, Eos+Phat mergent factors-krash's beat detection
		flexi-predator prey spirals, Geiss-Cosmic Dust 2, Goody-Need, Goody-Need Desire Remix, MStress & Zylot - Acid UFO
		flexi-opeartion fatcap II, EOS & Geiss glowsticks v2 03 music shifter edit
 
 Revisions 2a to 2b
 
   - had accidently broke intensity control trying to fix something else, fixed now.
  
 
 
 Revisions 1a to 2a
	 
	 - Ported to processing 3.0
		- open() changed to launch()
		- frame.setresizable() to surface.setResizable()
		- size() to surface.setSize()
	 
	- new config file, any version 1a files will have to  be ported to 2a format
		- dropped COM2 config, added NLED Aurora CMD option

	- Generation functions are now classes, so multiple of the same one can be ran at the same time

	- Quickfeed IDs have been altered, quickfeed files will need updating
	 
	- Made generated feeds into objects so two can be ran at the same time, also easier to follow

	- Moved all matrix configurations to "Matrix" object rather than numerous variables

	- Adjusted how the window is resized due to changes within processing and the generated feeds objects
	 
	- Reset Buttons(A&B) now properly reset the speed, color effects, contrast, invert etc. 
	 
	- Changed how intensity(via the 2 sliders, with lock button) is displayed. No longer is the previews affected by it, but the output data will be.
		Also added percentage values to the lower corners of A & B previews.
	 
	- Changed all the generated method ID numbers, updated the javascript/html generator 
	 
  
Known Issues:

	- not loading slider text values correctly, but still work - which ones?

	- DAT file not compatible with more than 2 feeds, also it freezes
		- need to try it in native resolution see if it still freezes, seems to run several times first though

	
 OLD NOTES:

	 Automatic Mode Works but needs work,
	 Per Line: Fader starting Position - Feed ID - QuickFeed Variable - Draw Counts - Fade Speed(1000 instant, 1+ = increment on draw)
	 
	 Load Files Fill Variables -> set Fader Position -> set FeedID to QuickFeedVar -> Load it ->Set AutoSequenceRunning -> Start decf DrawCounter -> when reaches 0 ->
	 Start Auto Blend -> every Draw add 0.001 for every 1(out of 1000) of speed eg: Fade Speed is 50, add 0.05 -> once it reaches 1 or 0(depending on FeedID)
	 -> Start Over
	 
 
Future Upgrades:
	 
	 - add animation for images, scrolling?? sliding
		- how???? Gen options, random X, random Y, Speed, ???	 
	 
	 - RGBW pixels will not work with current code since it frequently relies on color() and pixel[] variables, not sure how to proceed on that, along
	 with not having access to a RGBW pixel array for testing. But framework is in for the most part, I made most functions compatible for the future
	 
	 - Each feed can be two feeds mixed already, so say a mask layer and color layer
	 
	 - Automatic Mode, it is bare bones right now, needs some work. But is functioning.
	 
	 - Be able to change Auto Fade speed - now a defined constant 
	 
	 - Ensure letter cases are stripped when loading and comparing filenames, hate being that specific
	 
	 - SendData() - Nonstandard RGB data order other than GRB aren't written, but would be simple enough
	 
	 - Add frame rate slider or textfield to menu, so can be changed on the fly
	 
	 - With Graphics Buffers  various blendModes() and filter() could be used on them
	 
 */
 
 
 //as of version 2a, requires library version 1(not 1.01)




 
//Message from TheMIDIBus Author: Mac users may want to install mmj, a Mac OS X universal binary java MIDI subsystem - or an equivalent third party MIDI subsystem - because the apple implementation 
//	is lacking support for a number of advanced MIDI features. Mmj is recommended because it works, it's free and it's almost open source (CC licence). Please check README.md for more information.
//	If you do use MMJ you will want to set MidiBus.sendTimestamps(boolean sendTimestamps) to false, otherwise messages won't be sent.


//import ddf.minim.analysis.*;
 //for sound reactivity, opens line-in. Should work on all OS

//this will work on windows only Mac and Linux, comment out these two libraries and find the 4 other code sections to comment out
 //for DShow feed input, 
 //used for DShow feed input

//loads network communication libraries
 	//used for UDP communication
	        //used for TCP communication

//================================= END IMPORTS ==================================

final int ColButtonsBG = color(60, 60, 60);
final int ColButtonsHL = color(170, 0, 0);
final int ColButtonsOut = color(0, 100, 255); //selected/highlighted color for buttons
final int cFocusedColor = color(0, 0, 255); //focus color for quickfeed button
final int cBackgroundColor = color(200); //background of the software

final int cSliderHLColor = color(100, 100, 100);
final int cSliderBGColor = color(255);
final int cBlendButtStroke = color(145, 40, 150);
final int cSliderHndlColor = color(140, 20, 20);
final int cButtonTextColor = color(255);

final int cAutomaticStroke = color(45, 50, 145);
final int cAutomaticHL = color(0, 100, 50);

final int cMenuStrokeColor = color(0, 0, 255);
final int cMenuColor = color(160); //background color of the menus
final int cMenuButtonsStroke = color(0, 100, 50);
final int cMenuBGColor = color(200);
final int cMenuFontColor = color(0);
final int cSliderStrokeColor = color(0);

final int cDefaultSpeed = 110;
final int cDefaultSpeedX1 = 110;
final int cMaxQuickFeeds = 60;
final int cDefaultAutoFadeSpeed = 100;


final String[] cMetaBallsLabels = {
  "Ball Amt", "Blob Size", "Frequency", "Color Mode"
};
final String[] cSpiralLabels = {
  "Coils", "Offset Color", "ColorMode", "Trails"
};
final String[] cStarFieldLabels = {
  "Shape", "Star Size", "Fill/Stroke", "Amount"
};
final String[] cRipplesLabels = {
  "Shape", "Weight", "Not Used", "Not Used"
};
final String[] cSpinningSquare = {
  "Fill Color", "Stroke Color", "Stroke Weight", "Base Size"
};
final String[] cTextLabels = {
  "Text Size", "Speed", "Y Position", "Modifier"
};
final String[] cFallingBlocks = {
  "Size", "Spacing", "Decay", "Direction"
};
final String[] cSineWave = {
  "Amplitute", "Decay", "Width", "None"
};

final String[] cReactiveBars = {
  "Amplitute", "Width", "Decay", "Spacing"
};

final String[] cNotUsedLabels = {
  "Not Used", "Not Used", "Not Used", "Not Used"
};

final int cTempGUI2X = 150;
final int cTempGUI2Y = 250;

//==================== END CONSTANTS/FINALS == START VARIABLES ================================================

//System Variables
int[] PatchCoordX = new int[1];
int[] PatchCoordY = new int[1];
int[] BufferA = new int[1];
int[] BufferB = new int[1];
int[] MixedBuffer = new int[1];

int[] PrevBufferA = new int[1];
int[] PrevBufferB = new int[1];


byte[] TransmissionArray = new byte[1]; //resized when the device patch file is loaded

int[] ReceivedSerialControl = new int[12];
int[] PrevReceivedSerialControl = new int[12];

//holds .DAT data bytes
byte[] ByteBufferA = new byte[1]; //resized based on Matrix Size
byte[] ByteBufferB = new byte[1]; //resized based on Matrix Size
int DataFrameFeedA = 0; //for .dat file frame counter
int DataFrameFeedB = 0; //for .dat file frame counter


ArrayList strs = new ArrayList(); //used for file saving and loading

//User Configs
int MatrixWidth = 22; //Set in Config file
int MatrixHeight = 22; //Set in Config file
int MaxChannels = (MatrixWidth * MatrixHeight) * 3; //calculation for RGB Pixels, alter if not using RGB(single color or RGBW or something)
int MaxPixels = 170; //set in BuildCustom from the patch coordinate file
int PatchedChannels = 510; //filed in BuildCustom(), is PixelAmount * 3(not MatrixHeight * MatrixWidth) actual displayed pixels based on patch

int TargetFrameRate = 30; //user set in config, based on available bandwidth and other factors

int Xdifference = 0; //calculated using the patch coordinates
int Ydifference = 0;  //also used for external frame size

int FeedASelQuick = 2; //starting quickfeed IDs
int FeedBSelQuick = 3;

int PrevFocusA = 0;
int PrevFocusB = 0;

float SpeedA = 1;
float SpeedB = 1;

float  MixerValue = 0.5f; // 0 is A, 1 is B
float  IntensityValueA =1;
float  IntensityValueB =1;

int BlendingMode = 0;
int CommunicationType = 0;
int LoadFileMethod = 0; //used in the FileLoad Switch()

boolean FeedFlag = false; //true is A, false is B
boolean FrameFirstRunA = true;
boolean FrameFirstRunB = true;
boolean AutomaticMode = false;
boolean FeedAGenerating = false;
boolean FeedBGenerating = false;
boolean GlobalDragging = false; //sliders
boolean CommunicationConnected = false;
boolean InitializedWindowSize = false;
boolean HandleSerialFlag = false;


int  PixelDataType = 0; //0 RGB, 1 RGBW, 2 GRB ..... 7 Single Color use Red, 8 use green, 9 use blue, 5 GRB, 6 BGR, 7 RBG

	//String PatchFileName = "";
	//String QuickFeedsFileName = "";
	//String AbsoluteFootagePath = "";
	//String AutomaticFileName = "";
	
String DeviceFileID = "";
String SelectedFile = "";

//Communication Variables
	//int ServerPort = 9750; //2616 is HEX
	//String ServerIP = "192.168.1.100";

boolean FramedSerialFlag = false; //also used for serial control
boolean DTRState = false; //used for polling the serial control device

int RecievedCounter = 0; //used for Serial Input control
	//boolean ConfigPreviewEnable = true;
	//boolean ConfigDisplayThumbnails = false;
	//int ConfigCOM1 = 0; //user selected COM Port, set in config.ini
	//int MIDIControlPort = 0;  //user selected set in config.ini
	//int SerialControlPort = 0;  //user selected set in config.ini
int TransmissionStatusCounter = 0; //used for indicating transmission, green circle bottom of the screen
	//int TransmissionBaud = 500000; //user selected set in config.ini
int HoldMiliSec = 0;  //
int inByte = -1;    // Incoming serial data

//GUI Variables
boolean UpdateWorkspace = true;
boolean LockIntensity = false;
boolean DisplayPreview = false;


int FeedAQuickPage = 0; //4 pages, 0 - 3
int FeedBQuickPage = 0;

int OpenMenuID = 0;
String portName = "None";

int PrevHeight = height;  //used to monitor if the grid window's size is changed
int PrevWidth = width;
float SF = 1; //scale factor

int SelectedSlider = 0;
int SelectedSliderSet = 0;

int DisplayThumbnail = 0;



int MIDIchan = 0;
int MIDInumber = 0; 
int MIDIvalue = 0;
boolean HandleMIDICC = false;
boolean HandleMIDINO = false;

//used throughout for many functions
int myColor = color(0);
float myRed  = 0;
float myGreen = 0;//moving variables out of loop should make it faster
float myBlue = 0;

//AUTOmatic mode variables
int DrawCount = 0;
int BlendSpeed = 1; //for auto-fade and automatic mode
boolean FeedID =  false;
int AutoLines = 1; //starts at 1, as line 0 is comments
boolean AutoSequenceRunning = false;
boolean TransitionFlag = false; //Auto-Fade & Automatic Variable
boolean ReverseFlag = false; //play .dat files in reverse

//Generation Vars
//system
int FrameMethod = 0; //discontinue these!!!!!!!!!!!!!!!!
int FrameMethodA = 0;
int FrameMethodB = 0;

int StepThroughVar = 0; //stays global

//Generation system variables
int HoldGenSlider1 = 0;
int HoldGenSlider2 = 0;
int HoldGenSlider3 = 0;
int HoldGenSlider4 = 0;

String[] GenSliderLabelsA = {
  "A", "B", "C", "D"
};
String[] GenSliderLabelsB = {
  "A", "B", "C", "D"
};
//String[] TempLabelArray = {"Not Used","Not Used","Not Used","Not Used"};
//END

PImage MixerHandle, OffsetMenuBG, IntensityBG, TestBars, MainMixerBG;
PGraphics GraphicsBufferA, GraphicsBufferB, buf, PreviewBuffer;

PGraphics[] CachedThumbnails = new PGraphics[60];

DCapture captureDSObj; //capture device object for DShow Input, MAC and LINUX comment out

AudioInput AudioIn; //used for LineIn
Minim minim; //dunno

Client TCPclient; // Declare a client for Processing Net library
UdpClient UDPclient; //declare UDP for netP5 library, TCP IP will not work right

Serial myPort;      // The serial port

MidiBus myBus; // The MidiBus

Movie myMovieA; //Feed A movie Object
Movie myMovieB;  //Feed B movie Object
Movie m;  //temp movie object for functions, don't really need to declare it here but seems to work better
Movie PreviewMovie; //Temp movie object for generating Previews and such

Button[] FeedAButtons;
ButtonSq[] QuickAButtons;

Button[] FeedBButtons;
ButtonSq[] QuickBButtons;

Button[] CommonButtons;
Button[] BlendButtons;
Button[] OffsetButtons;

Button[] MainMenuButtons;
Button[] MIDIMenuButtons;

SliderBar[] CommonSliders;
SliderBar[] GenerationSliders;

SliderBar MainMixerSlider;
SliderBar IntensitySliderA;
SliderBar IntensitySliderB;

SliderBar SliderPointer;

PixelDisplay[] FeedAPixels;
PixelDisplay[] FeedBPixels;
PixelDisplay[] MixedPixels;

QuickFeed[] QuickFeeds;

GUIMenu[] GUIMenus;

MatrixObj Matrix;

//generated objects
ggObjText[] genGraphicText;
ggObjImage[] genGraphicImage;
ggObjDATFile[] genGraphicDATFile;
ggObjSpinningSquare[] genGraphicSpinningSquare;
ggObjStarField[] genGraphicStarField;
ggObjRipples[] genGraphicRipples;
ggObjMetaBalls[] genGraphicMetaBalls;
ggObjPlasma[] genGraphicPlasma;

ggObjSpiral[] genGraphicSpiral;
ggObjFallingBlocks[] genGraphicFallingBlocks;
ggObjTestStepThrough[] genGraphicTestStepThrough;
 
ggObjAudioCircles[] genGraphicAudioCircles;
ggObjAudioSine[] genGraphicAudioSine;
ggObjAudioBars[] genGraphicAudioBars;
 
 
//==================== END INITIALIZATION ============================


public void setup()
{
  if (InitializedWindowSize == false) 
  {
    // size(800, 600); //default
    LoadConfigFile(); //load user config.ini   
    textFont( loadFont("Gisha-Bold-32.vlw"), 24);
    ImageIcon titlebaricon = new ImageIcon(loadBytes("favicon.gif"));
    frame.setIconImage(titlebaricon.getImage());
    surface.setTitle("NLED Matrix - v2b - www.NLEDShop.com/nledmatrix - Northern Lights Electronic Design, LLC");
    
    surface.setResizable(true);
	
	
   minim = new Minim(this);
  // use the getLineIn method of the Minim object to get an AudioInput
  AudioIn = minim.getLineIn(Minim.MONO, 512);
  AudioIn.enableMonitoring();
  // uncomment this line to *hear* what is being monitored, in addition to seeing it
  AudioIn.mute();
  
  }

  background(cBackgroundColor);
  frameRate(TargetFrameRate); //draw monitors a feedback loop of sorts to maintain the Target Frame rate

  PrevHeight = height;  //used to monitor if the grid window's size is changed so objects can be redeclared
  PrevWidth = width;   

  GraphicsBufferA = createGraphics(MatrixWidth, MatrixHeight);
  GraphicsBufferB  = createGraphics(MatrixWidth, MatrixHeight);
  PreviewBuffer = createGraphics(MatrixWidth, MatrixHeight);

  PreviewBuffer.beginDraw(); //need to intialize this right away to prevent an error
  PreviewBuffer.rect(0, 0, 20, 20);
  PreviewBuffer.endDraw();

  //MaxChannels = (MatrixWidth * MatrixHeight) * 3;

  println("Setup() GUI ScaleFactor="+SF);

  //=========================== Init Objects =====================================
  GUIMenus = new GUIMenu[6];
  GUIMenus[0]= new GUIMenu("NoMenu", 0, 0, 800, 600, 0, false);    
  GUIMenus[1]= new GUIMenu("Offset Menu", 300, 300, 200, 200, 1, false);  
  GUIMenus[2]= new GUIMenu("Main Menu", 150, 250, 500, 200, 2, false);   
  GUIMenus[3]= new GUIMenu("ConfigureMenu", 150, 250, 500, 200, 3, false);  
  GUIMenus[4]= new GUIMenu("GenMenuA", 280, 400, 240, 100, 4, false);   
  GUIMenus[5]= new GUIMenu("GenMenuB", 280, 400, 240, 100, 5, false);  

  BlendButtons = new Button[7];
  BlendButtons[0] = new Button("Blend", 365, 340, 70, 25, ColButtonsBG, ColButtonsHL, cBlendButtStroke, true, true, false);
  BlendButtons[1] = new Button("Multiply A B", 280, 370, 90, 25, ColButtonsBG, ColButtonsHL, cBlendButtStroke, true, false, false);
  BlendButtons[2] = new Button("Multiply B A", 430, 370, 90, 25, ColButtonsBG, ColButtonsHL, cBlendButtStroke, true, false, false);      
  BlendButtons[3] = new Button("Minim.", 280, 400, 70, 25, ColButtonsBG, ColButtonsHL, cBlendButtStroke, true, false, false);
  BlendButtons[4] = new Button("Maxim.", 450, 400, 70, 25, ColButtonsBG, ColButtonsHL, cBlendButtStroke, true, false, false);
  BlendButtons[5] = new Button("Add A to B", 280, 340, 80, 25, ColButtonsBG, ColButtonsHL, cBlendButtStroke, true, false, false);
  BlendButtons[6] = new Button("Add B to A", 440, 340, 80, 25, ColButtonsBG, ColButtonsHL, cBlendButtStroke, true, false, false);

  CommonButtons = new Button[11];
  CommonButtons[0] = new Button("A", 280, 310, 40, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  CommonButtons[1] = new Button("B", 480, 310, 40, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  CommonButtons[2] = new Button("Auto Fade", 355, 310, 90, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  CommonButtons[3] = new Button("Automatic", 360, 400, 80, 25, ColButtonsBG, cAutomaticHL, cAutomaticStroke, true, false, false);
  CommonButtons[4] = new Button("Lock", 485, 450, 40, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);

  CommonButtons[5] = new Button("Save", 270, 545, 50, 25, ColButtonsBG, ColButtonsHL, cMenuButtonsStroke, false, false, false);
  CommonButtons[6] = new Button("Load", 330, 545, 50, 25, ColButtonsBG, ColButtonsHL, cMenuButtonsStroke, false, false, false);
  CommonButtons[7] = new Button("Menu", 475, 545, 60, 25, ColButtonsBG, ColButtonsHL, cMenuButtonsStroke, true, false, false);
  CommonButtons[8] = new Button("Configure", 390, 545, 75, 25, ColButtonsBG, ColButtonsHL, cMenuButtonsStroke, true, false, false);

  CommonButtons[9] = new Button("Gen. Options A", 270, 510, 120, 25, ColButtonsBG, ColButtonsHL, cMenuButtonsStroke, true, false, false);
  CommonButtons[10] = new Button("Gen. Options B", 415, 510, 120, 25, ColButtonsBG, ColButtonsHL, cMenuButtonsStroke, true, false, false);

  OffsetButtons = new Button[5];
  OffsetButtons[0] = new Button("Up", (GUIMenus[1].xpos+75), (GUIMenus[1].ypos+15), 55, 55, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  OffsetButtons[1] = new Button("Down", (GUIMenus[1].xpos+75), (GUIMenus[1].ypos+130), 55, 55, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  OffsetButtons[2] = new Button("Right", (GUIMenus[1].xpos+130), (GUIMenus[1].ypos+75), 55, 55, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  OffsetButtons[3] = new Button("Left", (GUIMenus[1].xpos+15), (GUIMenus[1].ypos+75), 55, 55, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  OffsetButtons[4] = new Button("Reset", (GUIMenus[1].xpos+75), (GUIMenus[1].ypos+75), 50, 50, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);

  FeedAButtons = new Button[14];
  FeedAButtons[0] = new Button("Play", 10, 250, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedAButtons[1] = new Button("Pause", 70, 250, 60, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedAButtons[2] = new Button("Stop", 140, 250, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedAButtons[3] = new Button("Load", 200, 250, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  FeedAButtons[4] = new Button("Reset", 10, 285, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  FeedAButtons[5] = new Button("Invert", 10, 405, 55, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedAButtons[6] = new Button("Tint", 10, 370, 55, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedAButtons[7] = new Button("Color Max", 75, 370, 80, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedAButtons[8] = new Button("Offset", 10, 320, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedAButtons[9] = new Button("Color Scale", 165, 370, 90, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
  FeedAButtons[10] = new Button("Color Min", 75, 405, 80, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
  FeedAButtons[11] = new Button("Contrast", 165, 405, 90, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
  FeedAButtons[12] = new Button("Pg Up", 10, 445, 50, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  FeedAButtons[13] = new Button("Pg Dwn", 65, 445, 50, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);

  QuickAButtons = new ButtonSq[60];
  int q = 0;
  for (int i=0; i != 15; i++)
  {
    if (i < 5)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+(i*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (i > 4 && i < 10)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((i-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((i-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  } 
  q = 0;
  for (int i=15; i != 30; i++)
  {
    if (q < 5)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+(q*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (q > 4 && q < 10)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((q-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((q-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
    q++;
  } 
  q = 0;
  for (int i=30; i != 45; i++)
  {
    if (q < 5)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+(q*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (q > 4 && q < 10)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((q-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((q-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
    q++;
  } 
  q = 0;
  for (int i=45; i != 60; i++)
  {
    if (q < 5)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+(q*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (q > 4 && q < 10)  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((q-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickAButtons[i] = new ButtonSq("Q"+(i+1), (10+((q-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
    q++;
  }    

  //======================================================================

  QuickBButtons = new ButtonSq[60];
  q = 0;
  for (int i=0; i != 15; i++)
  {
    if (i < 5)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+(i*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (i > 4 && i < 10)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((i-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((i-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  } 
  q = 0;
  for (int i=15; i != 30; i++)
  {
    if (q < 5)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+(q*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (q > 4 && q < 10)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((q-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((q-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
    q++;
  } 
  q = 0;
  for (int i=30; i != 45; i++)
  {
    if (q < 5)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+(q*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (q > 4 && q < 10)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((q-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((q-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
    q++;
  } 
  q = 0;
  for (int i=45; i != 60; i++)
  {
    if (q < 5)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+(q*50)), 475, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else if (q > 4 && q < 10)  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((q-5)*50)), 515, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
    else  QuickBButtons[i] = new ButtonSq("Q"+(i+1), (550+((q-10)*50)), 555, 45, 35, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
    q++;
  }   

  //========================================

  QuickAButtons[FeedASelQuick].Selected = true;
  QuickBButtons[FeedBSelQuick].Selected = true;

  FeedBButtons = new Button[14];
  FeedBButtons[0] = new Button("Play", 550, 250, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedBButtons[1] = new Button("Pause", 610, 250, 60, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedBButtons[2] = new Button("Stop", 680, 250, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedBButtons[3] = new Button("Load", 740, 250, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  FeedBButtons[4] = new Button("Reset", 550, 285, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  FeedBButtons[5] = new Button("Invert", 550, 405, 55, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedBButtons[6] = new Button("Tint", 550, 370, 55, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedBButtons[7] = new Button("Color Max", 615, 370, 80, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedBButtons[8] = new Button("Offset", 550, 320, 50, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  FeedBButtons[9] = new Button("Color Scale", 705, 370, 90, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
  FeedBButtons[10] = new Button("Color Min", 615, 405, 80, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
  FeedBButtons[11] = new Button("Contrast", 705, 405, 90, 25, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);  
  FeedBButtons[12] = new Button("Pg Up", 550, 445, 50, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  FeedBButtons[13] = new Button("Pg Dwn", 605, 445, 50, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);

  //===================== START MENU OBJECTS =====================

  int tXpos = GUIMenus[2].xpos;//main menu location
  int tYpos = GUIMenus[2].ypos;

  MainMenuButtons = new Button[13];
  MainMenuButtons[0] = new Button("Save Device Config", 100+tXpos, 10+tYpos, 120, 20, ColButtonsBG, ColButtonsHL, ColButtonsHL, false, false, false);
  MainMenuButtons[1] = new Button("Load Device Config", 230+tXpos, 10+tYpos, 120, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  MainMenuButtons[2] = new Button("Enable Serial Control", 10+tXpos, 40+tYpos, 130, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  MainMenuButtons[3] = new Button("Enable DShow Feed", 150+tXpos, 40+tYpos, 120, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  MainMenuButtons[4] = new Button("Large Previews", 290+tXpos, 40+tYpos, 90, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  MainMenuButtons[5] = new Button("Enable MIDI", 390+tXpos, 40+tYpos, 90, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);

  MainMenuButtons[6] = new Button("None", 110+tXpos, 145+tYpos, 40, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  MainMenuButtons[7] = new Button("Serial", 160+tXpos, 145+tYpos, 40, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  MainMenuButtons[8] = new Button("TCP", 210+tXpos, 145+tYpos, 40, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  MainMenuButtons[9] = new Button("UDP", 260+tXpos, 145+tYpos, 40, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, true, false, false);
  MainMenuButtons[10] = new Button("EULA", 450+tXpos, 10+tYpos, 40, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  MainMenuButtons[11] = new Button("Rebuild Thumbnails", 300+tXpos, 170+tYpos, 120, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);
  MainMenuButtons[12] = new Button("Website", 360+tXpos, 10+tYpos, 60, 20, ColButtonsBG, ColButtonsHL, ColButtonsOut, false, false, false);

  //set Intial button states
  MainMenuButtons[2].Selected = Matrix.softwareSerialConEnable;
  MainMenuButtons[3].Selected = Matrix.softwareEnableDSVideoFeed;
  MainMenuButtons[4].Selected = Matrix.softwareLrgPreviewEnable;
  MainMenuButtons[5].Selected = Matrix.softwareMIDIenable;
  MainMenuButtons[6+Matrix.matrixCommMethod].Selected = true;

  //============== START SLIDERS ========================================

  MainMixerSlider = new SliderBar(290, 260, 220, 40, 50, 0, 100, color(255), color(0), color(200, 200, 200), color(0), true, false, 0); //mixer
  IntensitySliderA =  new SliderBar(290, 440, 180, 20, 100, 0, 100, color(255), color(0), color(200, 200, 200), color(0), false, false, 1); //intesity
  IntensitySliderB =  new SliderBar(290, 470, 180, 20, 100, 0, 100, color(255), color(0), color(200, 200, 200), color(0), false, false, 2); //intesity

  CommonSliders = new SliderBar[10];
  CommonSliders[0] = new SliderBar(130, 305, 120, 16, 255, 0, 255, color(255), color(0), color(255, 0, 0), cSliderStrokeColor, true, false, 3); //Feed A Red
  CommonSliders[1] = new SliderBar(130, 325, 120, 16, 255, 0, 255, color(255), color(0), color(0, 255, 0), cSliderStrokeColor, true, false, 3); //Feed A Green
  CommonSliders[2] = new SliderBar(130, 345, 120, 16, 255, 0, 255, color(255), color(0), color(0, 0, 255), cSliderStrokeColor, true, false, 3); //Feed A Blue
  //Feed B Color
  CommonSliders[3] = new SliderBar(670, 305, 120, 16, 255, 0, 255, color(255), color(0), color(255, 0, 0), cSliderStrokeColor, true, false, 3); //Feed A Red
  CommonSliders[4] = new SliderBar(670, 325, 120, 16, 255, 0, 255, color(255), color(0), color(0, 255, 0), cSliderStrokeColor, true, false, 3); //Feed A Green
  CommonSliders[5] = new SliderBar(670, 345, 120, 16, 255, 0, 255, color(255), color(0), color(0, 0, 255), cSliderStrokeColor, true, false, 3); //Feed A Blue
  //speed
  CommonSliders[6] = new SliderBar(140, 285, 110, 14, cDefaultSpeed, 0, 200, cSliderBGColor, cSliderHndlColor, cSliderHLColor, color(0), false, false, 3); //Feed A Speed
  CommonSliders[7] = new SliderBar(680, 285, 110, 14, cDefaultSpeed, 0, 200, cSliderBGColor, cSliderHndlColor, cSliderHLColor, color(0), false, false, 3); //Feed B Speed
  //contrast
  CommonSliders[8] = new SliderBar(135, 450, 120, 14, 0, 0, 255, cSliderBGColor, cSliderHndlColor, cSliderHLColor, cSliderStrokeColor, false, false, 3); //Feed A Contrast
  CommonSliders[9] = new SliderBar(670, 450, 120, 14, 0, 0, 255, cSliderBGColor, cSliderHndlColor, cSliderHLColor, cSliderStrokeColor, false, false, 3); //Feed B Contrast

  GenerationSliders = new SliderBar[4];
  GenerationSliders[0] = new SliderBar(290, 430, 90, 16, 1, 0, 255, cSliderBGColor, cSliderHndlColor, cSliderHLColor, cSliderStrokeColor, false, false, 4);
  GenerationSliders[1] = new SliderBar(420, 430, 90, 16, 1, 0, 255, cSliderBGColor, cSliderHndlColor, cSliderHLColor, cSliderStrokeColor, false, false, 4);
  GenerationSliders[2] = new SliderBar(290, 470, 90, 16, 1, 0, 255, cSliderBGColor, cSliderHndlColor, cSliderHLColor, cSliderStrokeColor, false, false, 4);
  GenerationSliders[3] = new SliderBar(420, 470, 90, 16, 1, 0, 255, cSliderBGColor, cSliderHndlColor, cSliderHLColor, cSliderStrokeColor, false, false, 4);

  SliderPointer = new SliderBar(0, 0, 0, 0, 0, 0, 0, color(0), color(0), color(0), color(0), true, false, 255); //Pointer for Keyboard control of sliders

  //========================= END SLIDERS ===================================================

  FeedAPixels= new PixelDisplay[(MatrixWidth * MatrixHeight)];
  FeedBPixels= new PixelDisplay[(MatrixWidth * MatrixHeight)];
  MixedPixels= new PixelDisplay[(MatrixWidth * MatrixHeight)];   //were all 340

   
	if (InitializedWindowSize == false) 
	{
	//load generation objects 
	genGraphicText = new ggObjText[4];
	genGraphicImage = new ggObjImage[4]; 
	genGraphicDATFile = new ggObjDATFile[4];
	genGraphicSpinningSquare = new ggObjSpinningSquare[4];
	genGraphicStarField = new ggObjStarField[4];
	genGraphicRipples = new ggObjRipples[4];
	genGraphicMetaBalls = new ggObjMetaBalls[4];
	genGraphicPlasma = new ggObjPlasma[4];
	genGraphicSpiral = new ggObjSpiral[4];
	genGraphicFallingBlocks = new ggObjFallingBlocks[4];
	genGraphicTestStepThrough = new ggObjTestStepThrough[4]; 

	genGraphicAudioCircles = new ggObjAudioCircles[4]; 
	genGraphicAudioSine = new ggObjAudioSine[4]; 
	genGraphicAudioBars = new ggObjAudioBars[4]; 
	//end 
	}
	 
  BuildCustom(); //build Pixel Displays and load coordinate file into arrays

  QuickFeeds = new QuickFeed[60];
  LoadQuickFeedsFile(); //Loads QuickFeeds

  MixerHandle = loadImage("mixerhandle.png");  
  OffsetMenuBG = loadImage("offsetmenu.png");
  IntensityBG = loadImage("intensitybg.png");
  TestBars = loadImage("testbars.jpg");
  MainMixerBG = loadImage("mainmixerbg.png");

  //======================================================================

  OpenConnection(); //opens communcation based on Matrix.matrixCommMethod variable

  //======================================================================

  if (Matrix.softwareSerialConEnable == true)
  {
    try {
      println(Serial.list());
      portName = Serial.list()[Matrix.softwareSerialConPort];
      myPort = new Serial(this, portName, Matrix.softwareSerialConBaud);    
      println("Connected to: "+portName);
    }
    catch(Exception e)
    {
      println("Serial Control COM Port Error");
    }
  }

  //=============================================================

  if (Matrix.softwareMIDIenable == true && myBus == null)
  {
    InitializeMIDI(true);
    InitializeMIDI(false);
  }

  if (InitializedWindowSize == false)
  {
    myMovieA = new Movie(this, "");
    myMovieB = new Movie(this, "");
    myMovieA.frameRate(30);
    myMovieB.frameRate(30);
    myMovieA.loop(); 
    myMovieB.loop();     
    LoadQuickFeed(myMovieA, QuickFeeds[FeedASelQuick]);
    LoadQuickFeed(myMovieB, QuickFeeds[FeedBSelQuick]);
  }

  SetControlStateFunc(myMovieA, FeedAButtons, QuickFeeds[FeedASelQuick].ControlState);
  SetControlStateFunc(myMovieB, FeedBButtons, QuickFeeds[FeedBSelQuick].ControlState);  

  //ADDED =========================================

  if(Matrix.softwareAuroraCMD)
  {
  try {
  myPort.write("N"); 
  myPort.write("L");  
  myPort.write("E");   
  myPort.write("D");  
  myPort.write("1");   
  myPort.write("1");      
  delay(5);
  myPort.write("n"); 
  myPort.write("l");  
  myPort.write("e");   
  myPort.write("d");  
  myPort.write("9");   
  myPort.write("9");
  delay(5);  
  myPort.write(60); 
  myPort.write(1);   
  myPort.write(0); 
  println("PatchedChannels: "+PatchedChannels);
  myPort.write((PatchedChannels >> 8) & 0xFF); 
  myPort.write(PatchedChannels & 0xFF);     
  }
  catch(Exception e) { println("No COM Port open to send NLED Aurora Live Control CMD to"); }
}

  /*
  myPort.write("q"); 
  myPort.write("Q");  
  myPort.write("z");       
  delay(5);
  myPort.write("G"); 
  delay(5);  
  myPort.write(60); 
  myPort.write(1);   
  myPort.write(0); 
*/

//host sends to device -> q -> Q -> z -> device sends N -> host responds with G -> device sends n -> Host sends -> Command -> data1 -> data2


  //END ADDED =========================================


  InitializedWindowSize = true;
}//end setup()

//=========================================================

public void SendData()
{
  //To send lots of data efficiently it must be sent in a byte array, otherwise each byte will few mS space between them
  //  so it would be real slow, sending as an array[] sends it fast as possible, in large packets.

  //============== PREPARE DATA =====================
  //Color Conversions for nonstandard RGB and single color usage is done here

  int x = 0; //used in switch

  switch(Matrix.matrixPixelDataType)
  {
  case 0: //RGB
      for (int i=0; i != PatchedChannels; i++)  TransmissionArray[i] = PApplet.parseByte(MixedBuffer[i]); //transfer Mixed buffer into a byte array for faster transmission  
    break;
  case 1: //RGBW
    //NOT IMPLEMENTED
    break;  
  case 2: //GRB output, WS2812B, among others
    for (int i=0; i != PatchedChannels; i=i+3) 
    {
      TransmissionArray[i] = PApplet.parseByte(MixedBuffer[x+1]); //transfer Mixed buffer into a byte array for faster transmission
      TransmissionArray[i+1] = PApplet.parseByte(MixedBuffer[x]); //transfer Mixed buffer into a byte array for faster transmission
      TransmissionArray[i+2] = PApplet.parseByte(MixedBuffer[x+2]); //transfer Mixed buffer into a byte array for faster transmission    
      x+=3;
    }
    break;  
  case 3: //BRG output, 

    for (int i=0; i != PatchedChannels; i=i+3) 
    {
      TransmissionArray[i] = PApplet.parseByte(MixedBuffer[x+2]); //transfer Mixed buffer into a byte array for faster transmission
      TransmissionArray[i+1] = PApplet.parseByte(MixedBuffer[x]); //transfer Mixed buffer into a byte array for faster transmission
      TransmissionArray[i+2] = PApplet.parseByte(MixedBuffer[x+1]); //transfer Mixed buffer into a byte array for faster transmission    
      x+=3;
    }

    break;  

  case 4: //GBR output

    break;  

  case 5: //RBG output

    break; 

  case 6: //BGR output, 

    break;  

  case 7: //Single Use Red Channel
    for (int i=0; i != MaxPixels; i++) 
    {
      TransmissionArray[i] = PApplet.parseByte(MixedBuffer[x]); //pulls just the red out
      x+=3;
    } 
    break;  
  case 8: //Single Use Green Channel
    x = 1;
    for (int i=0; i != MaxPixels; i++) 
    {
      TransmissionArray[i] = PApplet.parseByte(MixedBuffer[x]); //pulls just the red out
      x+=3;
    }
    break;  
  case 9: //Single Use Blue Channel
    x = 2;
    for (int i=0; i != MaxPixels; i++) 
    {
      TransmissionArray[i] = PApplet.parseByte(MixedBuffer[x]); //pulls just the red out
      x+=3;
    }  
    break;
  }
  //============== Send Out =============================
  try { 
    if (Matrix.matrixCommMethod == 1)  myPort.write(TransmissionArray);  //sends as an array, much much faster than other methods, only works with bytes()
    else if (Matrix.matrixCommMethod == 2)  UDPclient.send(TransmissionArray); //netP5 UDP Connection
    else if (Matrix.matrixCommMethod == 3)  TCPclient.write(TransmissionArray); //Processing Net TCP Connection
  }
  catch(Exception e)
  {
    //if the communcation type errors, turn off and continue
    Matrix.matrixCommMethod = 0;
    CommunicationConnected = false;
    println("Cannot Send, Closing Communication Port");
  }

  TransmissionStatusCounter++;
}//end func


public void serialEvent(Serial myPort)
{
  //currently only reads the Serial Control data, no other use
  inByte = myPort.read();
  // println(int(inByte));
  int tempTime = (millis() - HoldMiliSec);
  println("Received: "+inByte+"/"+PApplet.parseChar(inByte)+" Time: "+tempTime);
  HoldMiliSec=millis();  

  if (tempTime > 20 && tempTime < 110)
  {
    RecievedCounter = 0; 
    FramedSerialFlag = true;
  }

  if (Matrix.softwareSerialConEnable == true && FramedSerialFlag == true)
  {
    //if receiving commands over serial and there has been a 10mSec Space since last byte, this is the first of the packet
    ReceivedSerialControl[RecievedCounter] =  inByte;
    RecievedCounter++;

    if (RecievedCounter == 11)
    {  
      FramedSerialFlag = false;  //clear flag
      //  println(ReceivedSerialControl); 
      HandleSerialFlag = true;
    }//end if
  } //end if &&
}//end func

public void movieEvent(Movie m) {
  try {
    m.read();
  }
  catch(Exception e)
  {
    println("MovieEvent() Error, can not read()");
  }
} //end func

//=============================================================

public void OpenConnection()
{
  //Matrix.matrixCommMethod = 1; //override if necassary

  if (CommunicationConnected == false) //checks if already connected
  {  
    switch(Matrix.matrixCommMethod) //switches to select the communcation type
    {
    case 0: //no communication
      println("No Communicaiton Opened");
      portName = "None";
      break;
    case 1: //serial on single COM port
      //Tries to connect to the serial port specified in the config.ini
      if (myPort != null) myPort.stop();

      try
      {
        println(Serial.list());
        portName = Serial.list()[Matrix.matrixCOM1];
        myPort = new Serial(this, portName, Matrix.matrixTXBaud);   // 1000000);
        CommunicationConnected = true;  
        println("Connected to: "+Serial.list()[Matrix.matrixCOM1]);
      }
      catch(Exception e)
      {
        println("Cannot Open Specified Port, Please Check config.ini");
      }
      break;
    case 2: //UDP
      try {
        UDPclient = new UdpClient(Matrix.matrixServerIP, Matrix.matrixServerPort);
        CommunicationConnected = true;  
        portName = "UDP";
        println("Attempting UDP Connecton to "+Matrix.matrixServerIP+" on port "+Matrix.matrixServerPort);
      }
      catch(Exception e)
      {
        println("Could Not Start UDP Transmission");
      }
      break;
    case 3: //TCP/IP
      try {
        //   TCPclient = new TcpClient(this, Matrix.matrixServerIP, Matrix.matrixServerPort, 3);

        TCPclient = new Client(this, Matrix.matrixServerIP, Matrix.matrixServerPort);
        CommunicationConnected = true;  
        portName = "TCP/IP";
        println("Connected to TCP Server at "+Matrix.matrixServerIP+" on port "+Matrix.matrixServerPort);
      }
      catch(Exception e)
      {
        println("Could Not Connect To TCP/IP Server");
      }
      break;
    }//end switch
  }//end Connected If()
}
public void InitializeMIDI(boolean actionFlag)
{
  //MidiBus.list(); //list all inputs and outputs
  // println(MidiBus.availableInputs()); //list just inputs

  //actionFlag = true, load from MIDIControl Port, False is it being enabled and display buttons
  try
  {  
    //  MidiBus.close();
  }
  catch(Exception e) {
  }

  if (actionFlag == true)
  {
    try
    {
      myBus = new MidiBus(this, Matrix.softwareMIDIport, 0); // Create a new MidiBus using the device index to select the Midi input and output devices respectively.
      println("Using MIDI Device: "+myBus);
    }
    catch(Exception e)
    {
      println("Cannot Connect To Specified MIDI Device, Check config.ini");
    }
  }//end if
  else
  {
    int tXpos = cTempGUI2X;//GUIMenus[2].xpos;//main menu location
    int tYpos = cTempGUI2Y;//GUIMenus[2].ypos;

    MIDIMenuButtons = new Button[MidiBus.availableInputs().length];
    for (int i = 0; i != MidiBus.availableInputs().length;i++)
    {
      MIDIMenuButtons[i] = new Button("MIDI IN "+i, round((410+tXpos)*SF), round((80+tYpos)*SF), round(70*SF), round(20*SF), color(200), ColButtonsHL, color(0), true, false, false);
    }//end for()
  }
}

// ============================== START MIDI ====================================================

public void noteOn(int channel, int pitch, int velocity) 
{
  // Receive a noteOn
  println();
  println("Note On:");
  println("--------");
  println("Channel:"+channel);
  println("Pitch:"+pitch);
  //  println("Velocity:"+velocity);

  MIDInumber = pitch; 
  HandleMIDINO = true;
}


public void HandleNoteOn()
{
  HandleMIDINO = false;
  switch(MIDInumber)
  {
  case 4://A - color max
    HandleFeedAButtons(7);
    break;
  case 5://B - Color Max
    HandleFeedBButtons(7);  
    break;    
  case 6://A - color scale
    HandleFeedAButtons(9);    
    break;
  case 7://B - Color Scale
    HandleFeedBButtons(9);  
    break;     
  case 8://A - tint
    HandleFeedAButtons(6);
    break;
  case 9://B - tint
    HandleFeedBButtons(6);  
    break;     
  case 10:
    HandleCommonButtons(0); //Hard Cut A
    break;    
  case 11:
    HandleCommonButtons(1); //Hard Cut B
    break;
  case 12:
    HandleQuickAButtons(0);
    break;
  case 13:
    HandleQuickBButtons(0);
    break; 
  case 14:
    HandleQuickAButtons(1);
    break;  
  case 15:
    HandleQuickBButtons(1);
    break;    
  case 16:
    HandleQuickAButtons(2);
    break;  
  case 17:
    HandleQuickBButtons(2);
    break;    
  case 18:
    HandleQuickAButtons(3);
    break; 
  case 19:
    HandleQuickBButtons(3);
    break;    
  case 20:
    HandleQuickAButtons(4);
    break; 
  case 21:
    HandleQuickBButtons(4);
    break;    
  case 22:
    HandleQuickAButtons(5);
    break;  
  case 23:
    HandleQuickBButtons(5);
    break;   
  case 24:
    HandleQuickAButtons(6);
    break;  
  case 25:
    HandleQuickBButtons(6);
    break;    
  case 26:
    HandleQuickAButtons(7);
    break;
  case 27:
    HandleQuickBButtons(7);
    break;    
  case 28:
    HandleQuickAButtons(8);
    break; 
  case 29:
    HandleQuickBButtons(8);
    break;    
  case 30:
    HandleBlendButtons(0); //blend
    break; 
  case 31:
    HandleBlendButtons(4); ///Maxim
    break;    
  case 32:
    HandleBlendButtons(3); ///minim
    break;
  }
}//end func

public void noteOff(int channel, int pitch, int velocity) {
  // Receive a noteOff
  println();
  println("Note Off:");
  println("--------");
  println("Channel:"+channel);
  println("Pitch:"+pitch);
  println("Velocity:"+velocity);
}

public void controllerChange(int channel, int number, int value) {
  // Receive a controllerChange
  //Knobs don't send a location they send an increment or deincrement with a value 1 or more
  //    so the cases with if/else on Sliders values is modifying them and check for minimum or maximum
  println();
  println("Controller Change:");
  println("--------");
  println("Channel:"+channel);
  println("Number:"+number);
  println("Value:"+value);
//Running the redraw functions from here caused graphical glitches, saving the data and running it during draw() worked correctly
  MIDIchan = channel;
  MIDInumber = number; 
  MIDIvalue = value;
  HandleMIDICC = true;
}

public void HandleControlChange()
{
  //Running the redraw functions from above event handler caused graphical glitches, saving the data and running it during draw() worked correctly
  int value = MIDIvalue;
  HandleMIDICC = false;
  
  switch(MIDInumber)//number)
  {
  case 9: //FeedB Red
   CommonSliders[3].selectSlider();
   SelectedSlider = 3;
    if (value < 64)  CommonSliders[3].setValue(CommonSliders[3].Value+value);
    else CommonSliders[3].setValue(CommonSliders[3].Value-(128-value));
    break;

  case 6://FeedB Green
   CommonSliders[4].selectSlider();
   SelectedSlider = 4;
    if (value < 64) CommonSliders[4].setValue(CommonSliders[4].Value+value); //CW rotation 
    else  CommonSliders[4].setValue(CommonSliders[4].Value-(128-value)); //CCW
    break;

  case 7://FeedB Blue
   CommonSliders[5].selectSlider();
    if (value < 64) CommonSliders[5].setValue(CommonSliders[5].Value+value);  //CW rotation 
    else CommonSliders[5].setValue(CommonSliders[5].Value-(128-value)); //CCW
    break;

  case 1: //FeedB Speed
   CommonSliders[7].selectSlider();
   SelectedSlider = 7;
    if (value < 64)  CommonSliders[7].setValue(CommonSliders[7].Value+value); //CW rotation 
    else  CommonSliders[7].setValue(CommonSliders[7].Value-(128-value)); //CCW
    break; 
    //=================================   

  case 10: //intesityA
    IntensitySliderA.selectSlider();
    IntensitySliderA.setValue(round(((float)value/127 ) * 100));
    break;

  case 11: //intesityB
    IntensitySliderB.selectSlider();
    IntensitySliderB.setValue(round(((float)value/127 ) * 100));
    break;

  case 12: //mixer
    MainMixerSlider.selectSlider();
    MainMixerSlider.setValue(round(( (float)value / 127) * 100));
    break;

  case 8: //FeedA Red
   CommonSliders[0].selectSlider();
   SelectedSlider = 0;
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[0].setValue(CommonSliders[0].Value+value);
    }
    else
    {
      CommonSliders[0].setValue(CommonSliders[0].Value-(128-value));
    }
    break;
  case 4://FeedA Green
   CommonSliders[1].selectSlider();
   SelectedSlider = 1;   
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[1].setValue(CommonSliders[1].Value+value);
    }
    else
    {
      CommonSliders[1].setValue(CommonSliders[1].Value-(128-value));
    }
    break;

  case 5://FeedA Blue
   CommonSliders[2].selectSlider();
   SelectedSlider = 2;   
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[2].setValue(CommonSliders[2].Value+value);
    }
    else
    {
      CommonSliders[2].setValue(CommonSliders[2].Value-(128-value));
    }
    break;

  case 0: //FeedA Speed
   CommonSliders[6].selectSlider();
   SelectedSlider = 6;   
    if (value < 64) //CW
    {
      //CW rotation 
      CommonSliders[6].setValue(CommonSliders[6].Value+value);
    }
    else
    {
      CommonSliders[6].setValue(CommonSliders[6].Value-(128-value));
    }
    break;
  }//end switch
  HandleSliders(false);
}//end func

//====================== START SERIAL CONTROL ===============

public void HandleSerialCmd()
{
  HandleSerialFlag = false;  

  for (int i = 0; i != 12;i++)
  {
    //check against previous, if not equal run the switch if not continue
    if (PrevReceivedSerialControl[i] != ReceivedSerialControl[i])
    {
      int value = ReceivedSerialControl[i];
      println("Updating from DMX: "+i);
      switch(i)
      {
      case 0: //Mixer
        controllerChange(0, 12, round((ReceivedSerialControl[i]/2)));
        break;
      case 1://intensity
        controllerChange(0, 10, round((ReceivedSerialControl[i]/2))); 
        break;
      case 2: //FeedA Quick
        if (ReceivedSerialControl[i] >= QuickAButtons.length) ReceivedSerialControl[i] = QuickAButtons.length -1;   
        HandleQuickAButtons(ReceivedSerialControl[i]);
        break;
      case 3: //FeedB Quick
        if (ReceivedSerialControl[i] >= QuickBButtons.length) ReceivedSerialControl[i] = QuickBButtons.length -1;   
        HandleQuickBButtons(ReceivedSerialControl[i]);
        break;
      case 4: //FeedA Color Mode
        //None, invert, tint, color max, color scale

        //reset to all off, then turn on the correct one rather than figuring out toggling
        FeedAButtons[5].Selected = false; //make sure invert turns off  
        FeedAButtons[6].Selected = false; //make sure invert turns off  
        FeedAButtons[7].Selected = false; //make sure invert turns off  
        FeedAButtons[9].Selected = false; //make sure invert turns off  
        QuickFeeds[FeedASelQuick].ColorState = 0;
        QuickFeeds[FeedASelQuick].EffectState = 0;

        if (ReceivedSerialControl[i] == 1) HandleFeedAButtons(5); 
        else if (ReceivedSerialControl[i] == 2) HandleFeedAButtons(6);  
        else if (ReceivedSerialControl[i] == 3) HandleFeedAButtons(7);  
        else if (ReceivedSerialControl[i] == 4) HandleFeedAButtons(9);  

        //   SetColorStateFunc(Button[] b, int effectNum)   
        break;
      case 5: //FeedB Color Mode
        //None, invert, tint, color max, color scale

        //reset to all off, then turn on the correct one rather than figuring out toggling
        FeedBButtons[5].Selected = false; //make sure invert turns off  
        FeedBButtons[6].Selected = false; //make sure invert turns off  
        FeedBButtons[7].Selected = false; //make sure invert turns off  
        FeedBButtons[9].Selected = false; //make sure invert turns off  
        QuickFeeds[FeedBSelQuick].ColorState = 0;
        QuickFeeds[FeedBSelQuick].EffectState = 0;

        if (ReceivedSerialControl[i] == 1) HandleFeedBButtons(5); 
        else if (ReceivedSerialControl[i] == 2) HandleFeedBButtons(6);  
        else if (ReceivedSerialControl[i] == 3) HandleFeedBButtons(7);  
        else if (ReceivedSerialControl[i] == 4) HandleFeedBButtons(9);      
        break;
      case 6: //FeedA Red
        //Knobs work different from this
        CommonSliders[0].Value = value; 
        break;               
      case 7: //FeedA Green
        CommonSliders[1].Value = value; 
        break;         
      case 8: //FeedA Blue
        CommonSliders[2].Value = value; 
        break; 
      case 9: //FeedB Red
        CommonSliders[3].Value = value;  
        break;               
      case 10: //FeedB Green
        CommonSliders[4].Value = value;    
        break;         
      case 11: //FeedB Blue
        CommonSliders[5].Value = value; 
        break;
      }//end switch  
      UpdateWorkspace = true;
    }//end Prev If
  }//end for   

  for (int i = 0; i != 12;i++) PrevReceivedSerialControl[i] = ReceivedSerialControl[i]; //update Prev Registers
} //end func
public void PreviewColorEffects(int PassedID)
{
 //apply color effects to CachedThumbnail buffer so the original thumbnail is not overwritten, prevents the need to 
 //    regenerate the preview when color effects are changed
  
    PreviewBuffer.loadPixels();
    for (int i=0; i != (MatrixHeight * MatrixWidth);i++)
   { 
    switch(QuickFeeds[PassedID].ColorState)
    {
    case 0:   //none
      break;    
    case 1://tint
        myColor = PreviewBuffer.pixels[i];    
        myRed = (myColor >> 16 & 0xFF) +QuickFeeds[PassedID].SliderRed;
        if(myRed > 255) myRed = 255;
        myGreen = (myColor >> 8 & 0xFF) + QuickFeeds[PassedID].SliderGreen;
        if(myGreen > 255) myGreen = 255; 
        myBlue = (myColor & 0xFF) + QuickFeeds[PassedID].SliderBlue;
        if(myBlue > 255) myBlue = 255;     
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);
      break; 
    case 2: //Color Maximum
      //if value is greater than color Maximium, Make it color Maximum
        myColor = PreviewBuffer.pixels[i];         
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;    
        
        if(myRed > QuickFeeds[PassedID].SliderRed) myRed =  QuickFeeds[PassedID].SliderRed;      
        if(myGreen > QuickFeeds[PassedID].SliderGreen) myGreen = QuickFeeds[PassedID].SliderGreen; 
        if(myBlue > QuickFeeds[PassedID].SliderBlue) myBlue = QuickFeeds[PassedID].SliderBlue;          
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);      
      break;
    case 3: //Color Scale
      //scale colors linearly based on sliders  
        myColor = PreviewBuffer.pixels[i];         
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;    
        
        myRed =  round(myRed * ((float)QuickFeeds[PassedID].SliderRed / 255));     
        myGreen = round(myGreen * ((float)QuickFeeds[PassedID].SliderGreen / 255));  
        myBlue = round(myBlue * ((float)QuickFeeds[PassedID].SliderBlue / 255));            
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);          
      break;    
    case 4: //Color Minim
        //if color is not at least the value of the slider, it is turned to 0
        myColor = PreviewBuffer.pixels[i];         
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;    
   
        if(myRed < QuickFeeds[PassedID].SliderRed) myRed =  0;      
        if(myGreen < QuickFeeds[PassedID].SliderGreen) myGreen = 0; 
        if(myBlue < QuickFeeds[PassedID].SliderBlue) myBlue = 0;          
        PreviewBuffer.pixels[i] = color(myRed, myGreen, myBlue);         
      break;           
    } //end switch
    
     switch(QuickFeeds[FeedASelQuick].EffectState)
    {
    case 0: //no Effect
      break; 
    case 1: //invert
       BufferA[i] = 255 - BufferA[i];
      break;
    case 2: //contrast
      
      break;
    case 3: //invert and contrast

      break;  
      
    } //end switch        
  }//end for()
   PreviewBuffer.updatePixels();
      
}//end func

public void MixFeeds()
{

//Color Effects ->  Apply Effects -> Individual FeedIntensity -> Blend

  for (int i=0; i != PatchedChannels;i++)
  { 
    switch(QuickFeeds[FeedASelQuick].ColorState)
    {
    case 0:   //none
      break;    
    case 1://tint
      switch(i%3)
      {  
      case 0:
        BufferA[i] = BufferA[i] + QuickFeeds[FeedASelQuick].SliderRed; //red
        if (BufferA[i] > 255) BufferA[i] = 255;
        break;
      case 1:
        BufferA[i] = BufferA[i] + QuickFeeds[FeedASelQuick].SliderGreen; //green
        if (BufferA[i] > 255) BufferA[i] = 255; 
        break;
      case 2:
        BufferA[i] = BufferA[i] + QuickFeeds[FeedASelQuick].SliderBlue; //blue
        if (BufferA[i] > 255) BufferA[i] = 255; 
        break;
      }//end switch
      break; 
    case 2:  //Color Maximum
      //if value is greater than FilterValue, Make it FilterValue
      switch(i%3)
      {
      case 0:
        if (BufferA[i] > QuickFeeds[FeedASelQuick].SliderRed) BufferA[i] = QuickFeeds[FeedASelQuick].SliderRed; //red
        break;
      case 1:
        if (BufferA[i] > QuickFeeds[FeedASelQuick].SliderGreen) BufferA[i] = QuickFeeds[FeedASelQuick].SliderGreen;  //green
        break;
      case 2:
        if (BufferA[i] > QuickFeeds[FeedASelQuick].SliderBlue) BufferA[i] = QuickFeeds[FeedASelQuick].SliderBlue;  //blue
        break;
      }//end switch
      break;
    case 3: //Color Scale
      //scale colors based on sliders
      switch(i%3)
      {
      case 0:
        BufferA[i] = round((float)BufferA[i] * ((float)QuickFeeds[FeedASelQuick].SliderRed / 255)); //red
        break;
      case 1:
        BufferA[i] = round((float)BufferA[i] * ((float)QuickFeeds[FeedASelQuick].SliderGreen / 255));  //green
        break;
      case 2:
        BufferA[i] = round((float)BufferA[i] * ((float)QuickFeeds[FeedASelQuick].SliderBlue / 255));  //blue
        break;
      }//end switch    
      break;    
   case 4: //Color Minim     
  //if color is not at least the value of the slider make it 0 
  switch(i%3)
      {
      case 0:
        if (BufferA[i] < QuickFeeds[FeedASelQuick].SliderRed) BufferA[i] = 0;
        break;
      case 1:
        if (BufferA[i] < QuickFeeds[FeedASelQuick].SliderGreen) BufferA[i] = 0;
        break;
      case 2:
        if (BufferA[i] < QuickFeeds[FeedASelQuick].SliderBlue) BufferA[i] = 0;
        break;
      }
      break;
    } //end switch
    
     switch(QuickFeeds[FeedASelQuick].EffectState)
    {
    case 0: //no Effect
      break; 
    case 1: //invert
       BufferA[i] = 255 - BufferA[i];
      break;
    case 2: //contrast
    if(BufferA[i] < QuickFeeds[FeedASelQuick].ContrastValue) BufferA[i] = 0;
      break;    
    case 3: //invert + contrast
      BufferA[i] = 255 - BufferA[i];  
      if(BufferA[i] < QuickFeeds[FeedASelQuick].ContrastValue) BufferA[i] = 0;
      break;        
    } //end switch        
    
    /// ================= END A ========= START B =========================
    
    switch(QuickFeeds[FeedBSelQuick].ColorState)
    {
    case 0:   //none
      break;    
    case 1://tint
      switch(i%3)
      {  
      case 0:
        BufferB[i] = BufferB[i] + CommonSliders[3].Value; //red
        if (BufferB[i] > 255) BufferB[i] = 255;
        break;
      case 1:
        BufferB[i] = BufferB[i] + CommonSliders[4].Value; //green
        if (BufferB[i] > 255) BufferB[i] = 255; 
        break;
      case 2:
        BufferB[i] = BufferB[i] + CommonSliders[5].Value; //blue
        if (BufferB[i] > 255) BufferB[i] = 255; 
        break;  
      }//end switch
      break; 
    case 2:  //Color Maximum
      //if value is greater than FilterValue, Make it FilterValue
      switch(i%3)
      {
      case 0:
        if (BufferB[i] > CommonSliders[3].Value) BufferB[i] = CommonSliders[3].Value; //red
        break;
      case 1:
        if (BufferB[i] > CommonSliders[4].Value) BufferB[i] = CommonSliders[4].Value;  //green
        break;
      case 2:
        if (BufferB[i] > CommonSliders[5].Value) BufferB[i] = CommonSliders[5].Value;  //blue
        break;
      }//end switch
      break;
    case 3: //Color Scale
      //scale colors based on sliders
      switch(i%3)
      {
      case 0:
        BufferB[i] = round((float)BufferB[i] * ((float)CommonSliders[3].Value / 255)); //red
        break;
      case 1:
        BufferB[i] = round((float)BufferB[i] * ((float)CommonSliders[4].Value / 255));  //green
        break;
      case 2:
        BufferB[i] = round((float)BufferB[i] * ((float)CommonSliders[5].Value / 255));  //blue
        break;
      }//end switch    
      break;          
      
    } //end switch
    
     switch(QuickFeeds[FeedBSelQuick].EffectState)
    {
    case 0: //no Effect
      break; 
    case 1: //invert
       BufferB[i] = 255 - BufferB[i];
      break;
    case 2: //contrast
    if(BufferB[i] < QuickFeeds[FeedBSelQuick].ContrastValue) BufferB[i] = 0;
      break;    
    case 3: //invert + contrast
      BufferB[i] = 255 - BufferB[i];  
      if(BufferB[i] < QuickFeeds[FeedBSelQuick].ContrastValue) BufferB[i] = 0;
      break;        
    } //end switch     
  }//end for


//Intensity Second
if(LockIntensity == false) //if not locked, do individualy, otherwise perform on MixedBuffer Last
{
  if(IntensityValueA != 1)
  {
  for (int i=0; i != PatchedChannels ;i++) 
  {
  PrevBufferA[i] = BufferA[i]; //copy to preview  
  BufferA[i] = round(BufferA[i] * IntensityValueA); //apply intensity
  }
  } //end IntensityValueA if()
  
  if(IntensityValueB != 1) 
  {
  for (int i=0; i != PatchedChannels ;i++)  
  {
  PrevBufferB[i] = BufferB[i]; //copy to preview  
  BufferB[i] = round(BufferB[i] * IntensityValueB); //apply intensity
  }
  } //end IntensityValueB if()
} // end LockIntensity if()

//Blend Modes and feed mixing Third
switch(BlendingMode)
{
  case 0:
  //normal blend, works!
  for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round((((float)BufferA[i] * (1-MixerValue)) +  (((float)BufferB[i]) * MixerValue)));
  break; 
  case 1://overlay A to B
   for (int i=0; i != PatchedChannels ;i++)  
   {
  //  MixedBuffer[i] = ((BufferB[i] - BufferA[i]) < 0) ?  (BufferB[i] - BufferA[i])*-1 : (BufferB[i] - BufferA[i]);
    MixedBuffer[i] = ((round(BufferB[i]*MixerValue) - BufferA[i]) < 0) ?  (round(BufferB[i]*MixerValue) - BufferA[i])*-1 : (round(BufferB[i]*MixerValue));// - BufferA[i]);
   }
  break;
  case 2://overlay B to A
   for (int i=0; i != PatchedChannels ;i++)  
   {
    MixedBuffer[i] = ((round(BufferA[i]*(1-MixerValue)) - BufferB[i]) < 0) ?  (round(BufferA[i]*MixerValue) - BufferB[i])*-1 : (round(BufferA[i]*(1-MixerValue)));// - BufferA[i]);
//   MixedBuffer[i] = (BufferA[i] < BufferB[i]) ? round((float)BufferA[i] * (1-MixerValue)) : BufferB[i];
   }
  break; 
  case 3://min
//    for (int i=0; i != PatchedChannels ;i++) MixedBuffer[i] = min(BufferA[i], BufferB[i]); //Orig, not controllable
    for (int i=0; i != PatchedChannels ;i++) MixedBuffer[i] = min(round(BufferA[i] * MixerValue), BufferB[i]);//doesn't matter which one is calculated ends up the same
  break;
  case 4://max
 //   for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = max(BufferA[i], BufferB[i]);
      for (int i=0; i != PatchedChannels ;i++) MixedBuffer[i] = max(round(BufferA[i] * MixerValue), BufferB[i]);
  break;
  case 5://add A to B
  //  for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferB[i]-BufferA[i]) * MixerValue, 0)); //max(B - A*factor, 0)
    for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferB[i]-BufferA[i]) * MixerValue, BufferA[i])); //max(B - A*factor, 0)  

  break; 
   case 6://add B to A
   // for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferA[i]-BufferB[i]) * MixerValue, 0)); //max(B - A*factor, 0)
   for (int i=0; i != PatchedChannels ;i++)  MixedBuffer[i] = round(max((float)(BufferA[i]-BufferB[i]) * MixerValue, BufferB[i])); //max(B - A*factor, 0)   

  break;  
}//end switch


if(LockIntensity == true)//if locked, do Intensity calculations once instead of on each Feed Buffer
{
  if(IntensityValueA != 1) 
  {
  for (int i=0; i != PatchedChannels ;i++) 
  {
  MixedBuffer[i] = round(MixedBuffer[i] * IntensityValueA); //apply intensity value to mixed feed
  PrevBufferA = BufferA; //copy un-intensity altered data to prevbuffers
  PrevBufferB = BufferB; //copy un-intensity altered data to prevbuffers
  }
  }
}

  //if intensity is has not been applied, the prevbuffer has not been updated yet, do it now
  if(IntensityValueA == 1)
  {
  arrayCopy(BufferA, PrevBufferA);
  } //end IntensityValueA if()
  if(IntensityValueB == 1) 
  {
  arrayCopy(BufferB, PrevBufferB);  
  }

 
  /*  
   //kind of cool, not really a normal one to my knowledge
   for(int i=0; i != MixedBuffer.length;i++)
   {
   MixedBuffer[i] = round(255 - (((float)BufferA[i] * (1-MixerValue))) + (255 - ((float)BufferB[i] * MixerValue)));
   if(MixedBuffer[i] > 255) MixedBuffer[i] = MixedBuffer[i] - 255;
   }
   
   
  BLEND - linear interpolation of colours: C = A*factor + B. This is the default blending mode.
   
   ADD - additive blending with white clip: C = min(A*factor + B, 255)
   
   SUBTRACT - subtractive blending with black clip: C = max(B - A*factor, 0)
   
   DARKEST - only the darkest colour succeeds: C = min(A*factor, B)
   
   LIGHTEST - only the lightest colour succeeds: C = max(A*factor, B)
   
   DIFFERENCE - subtract colors from underlying image.
   
   EXCLUSION - similar to DIFFERENCE, but less extreme.
   
   MULTIPLY - multiply the colors, result will always be darker.
   
   SCREEN - opposite multiply, uses inverse values of the colors.
   
   REPLACE - the pixels entirely replace the others and don't utilize alpha (transparency) values
   */
} //end Func




public void PackPixels(Movie m, QuickFeed f)
{
  // loadPixels();
  int Rows = m.height;//((myMovie.height - ActualRows) - myMovie.height)* -1;
  int Columns = m.width;  
  int RowDiff = 0;
  int ColumnDiff = 0;
  
  if(f.Method != 1)//if not Capture, capture adjusts the display so edges can be cropped
  {
  RowDiff = f.OffsetY; // m.height +
  ColumnDiff =  f.OffsetX; //m.width +
  }

//println(m.height+" : "+m.width);
//  println("Rows: "+Rows+" Columns: "+Columns+" RowDiff: "+RowDiff);//+" Pixels Length: "+pixels.length);

  int x = 0;
  int LocationX;
  int LocationY;

  //each PatchCoord Represents a pixel not a channel
  for (int i=0; i != MaxPixels;i++)
  {
    //int Location = ((PatchCoordY[i] + RowDiff) * Columns) + PatchCoordX[i]; //for use with get() pixels
    //println(PatchCoordX[i]+" : "+PatchCoordY[i]);
    //color myColor = pixels[Location];
    //println("Location: "+Location);

    LocationX = PatchCoordX[i]+ ColumnDiff;
    LocationY = (PatchCoordY[i] + RowDiff);
    
    if(f.Method == 0) 
    {
      try {
        myColor = m.get(LocationX, LocationY);
      }
      catch(Exception e) {
       println("Method 0 get() error"); 
       myColor = color(0);
      }
  }
  else 
  {   
      try
      {
         if(m ==myMovieA) myColor = GraphicsBufferA.get(LocationX, LocationY); 
         else myColor = GraphicsBufferB.get(LocationX, LocationY); 
      }
      catch(Exception e)
      {
      TestBars.resize(MatrixWidth, MatrixHeight);
       myColor = TestBars.get(LocationX, LocationY);
      }      
   }
        
    myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
    myGreen = myColor >> 8 & 0xFF;
    myBlue = myColor & 0xFF; 

    if (m == myMovieA)
    {
      BufferA[x] = (int)myRed;
      BufferA[x+1] = (int)myGreen;
      BufferA[x+2] = (int)myBlue;
    }
    else
    {
      BufferB[x] = (int)myRed;
      BufferB[x+1] = (int)myGreen;
      BufferB[x+2] = (int)myBlue;
    }
    x = x+3; 
  }//end for
  //println("--------------------------------------");
}//end func
public void draw() 
{
  //Maintains a consitent FrameRate as to much in the draw will lag the frame rate, since it maintaints the same speed between draws()
  //  regardless of how long the draw() takes so FPS drops when doing intensive draw() functions
  if (frameRate < Matrix.softwareFrameRate) frameRate(Matrix.softwareFrameRate+10);
  else frameRate(Matrix.softwareFrameRate);


 //scales display of buttons and other objects on screen to user selected size
 //  since just the display is scaled and not the objects, mouseX and mouseY events must be scaled to match
  scale(SF,SF);

  if (UpdateWorkspace == true)
  {
    //Only update the whole workspace when necassary, it does cause a slight delay
    println("Workspace Updated"); 
    UpdateWorkspace = false; 
    background(cBackgroundColor);
    for (int i=0; i != FeedAButtons.length;i++)  FeedAButtons[i].display();
    for (int i=0; i != FeedBButtons.length;i++)  FeedBButtons[i].display();   

    if (FeedAQuickPage == 0) for (int i=0; i != 15;i++)  QuickAButtons[i].displaySq(i);
    else if (FeedAQuickPage == 1)for (int i=15; i != 30;i++)  QuickAButtons[i].displaySq(i);
    else if (FeedAQuickPage == 2)for (int i=30; i != 45;i++)  QuickAButtons[i].displaySq(i);   
    else if (FeedAQuickPage == 3)for (int i=45; i != 60;i++)  QuickAButtons[i].displaySq(i); 

    if (FeedBQuickPage == 0) for (int i=0; i != 15;i++)  QuickBButtons[i].displaySq(i);
    else if (FeedBQuickPage == 1)for (int i=15; i != 30;i++)  QuickBButtons[i].displaySq(i);
    else if (FeedBQuickPage == 2)for (int i=30; i != 45;i++)  QuickBButtons[i].displaySq(i);   
    else if (FeedBQuickPage == 3)for (int i=45; i != 60;i++)  QuickBButtons[i].displaySq(i); 

    for (int i=0; i != CommonButtons.length;i++)  CommonButtons[i].display();
    for (int i=0; i != BlendButtons.length;i++)  BlendButtons[i].display();    
    MainMixerSlider.display();
    IntensitySliderA.display();
    IntensitySliderB.display();

    for (int i=0; i != CommonSliders.length;i++)  CommonSliders[i].display();   

    textSize(16);
    fill(0);
    text("Red:", CommonSliders[0].xpos-35, CommonSliders[0].ypos+CommonSliders[0].slHeight);
    text("Green:", CommonSliders[1].xpos-55, CommonSliders[1].ypos+CommonSliders[1].slHeight);  
    text("Blue:", CommonSliders[2].xpos-40, CommonSliders[2].ypos+CommonSliders[2].slHeight);

    text("Red:", CommonSliders[3].xpos-35, CommonSliders[3].ypos+CommonSliders[3].slHeight);
    text("Green:", CommonSliders[4].xpos-55, CommonSliders[4].ypos+CommonSliders[4].slHeight);  
    text("Blue:", CommonSliders[5].xpos-40, CommonSliders[5].ypos+CommonSliders[5].slHeight);

    textSize(14);    
    text("Speed:"+QuickFeeds[FeedASelQuick].Speed, CommonSliders[6].xpos-75, CommonSliders[6].ypos+CommonSliders[6].slHeight);
    text("Speed:"+QuickFeeds[FeedBSelQuick].Speed, CommonSliders[7].xpos-75, CommonSliders[7].ypos+CommonSliders[7].slHeight);

    text("Contrast:", CommonSliders[8].xpos, CommonSliders[8].ypos-CommonSliders[8].slHeight/3);
    text("Contrast:", CommonSliders[9].xpos, CommonSliders[9].ypos-CommonSliders[9].slHeight/3);
  } //end updateworkspace if()

  //============== DISPLAYS CONSTANTLY UPDATED USEFUL INFORMATION TO THE WORKSPACE ======================


  noStroke();
  fill(200, 200, 200);
  rect(275, 575, 265, 55); //draw a rect over the area to be redrawn

  if (TransmissionStatusCounter == 0)   fill(255, 0, 0); //toggles the indicator circle between green and red
  else if (TransmissionStatusCounter < 10)  fill(0, 255, 0);
  else fill(0, 0, 0);

  stroke(255, 255, 255);
  strokeWeight(1);
  ellipse(520, 585, 10, 10);
  if (TransmissionStatusCounter > 20) TransmissionStatusCounter = 0;

  textSize(14);
  fill(0);
  text("Connection: "+portName, 270, 590);
  text("Transmitting:", 420, 590);
  noStroke();

  
  //================ SERIAL CONTROL POLLING HANDLER ======================

  if (CommunicationConnected == true && Matrix.softwareSerialConEnable == true)
  {
    //if DMXSerial Control Is Enabled, Toggle DTR to request new packet
    if (DTRState == true) 
    {
      DTRState = false;
      myPort.setDTR(false);
    }
    else
    {
      DTRState = true;
      myPort.setDTR(true);
    }
    if (HandleSerialFlag == true) HandleSerialCmd();
  } 

  //=================HANDLE AUTOMATIC MODE - Mixes between feeds using data in the TXT file =================================

  if (AutoSequenceRunning == true)
  {
    DrawCount--;
    if (DrawCount == 0 && AutomaticMode == true) TransitionFlag = true;  //start blending every draw 

    if (TransitionFlag == true)
    {
      //blending convert BlendSpeed to float and add it to mixer value

      if (FeedID == true)  MixerValue = MixerValue - ((float)BlendSpeed / 1000);
      else MixerValue = MixerValue + ((float)BlendSpeed / 1000);

      MainMixerSlider.Value = PApplet.parseInt(MixerValue * 100);
      MainMixerSlider.display();  

      if (AutomaticMode == true)
      {
        if (MixerValue >= 1 && FeedID == false)
        {
          MixerValue = 1;
          TransitionFlag = false; //reset flag
          AutoLines++; //increment auto line variable
          //load next auto line
          LoadAutoFile();
        }
        if (MixerValue <= 0 && FeedID == true)
        {
          MixerValue = 0; //was 1 and it was working, works just hte same with 0
          TransitionFlag = false; //reset flag
          AutoLines++; //increment auto line variable
          //load next auto line
          LoadAutoFile();
        }
      } //end automatic mode if
      else
      {
        //just doing auto fade
        if (MixerValue >= 1 && FeedID == false)
        {
          MixerValue = 1;
          TransitionFlag = false; //reset flag
          AutoSequenceRunning = false;
        }
        if (MixerValue <= 0 && FeedID == true)
        {
          MixerValue = 0;
          TransitionFlag = false; //reset flag
          AutoSequenceRunning = false;
        }
      }//end else
    }
  }//end AutoSequenceRunning if()

  //===================== HANDLE SLIDERS N SUCH =======================================================================

  GUIMenus[OpenMenuID].display(); //display open menu if there is

  if (GlobalDragging == true)
  {
  HandleSliders(true);//true means to use mouse as move info
  }//end globaldragging if

  //=========================== These functions make it happen, Pack the Patched Pixels into the buffer arrays and Mix/Blend/Effects them ==========================================

  PackPixels(myMovieA, QuickFeeds[FeedASelQuick]); //put Feed A into its organized/patched buffer array
  PackPixels(myMovieB, QuickFeeds[FeedBSelQuick]); //put Feed B into its organized/patched buffer array
  MixFeeds(); //mix A and B

  //=========================== Run Each Feed Generating Functions ==========================================

  if (FeedAGenerating == true && QuickFeeds[FeedASelQuick].ControlState == 0) 
  {
    float TempSpeed = QuickFeeds[FeedASelQuick].Speed;
    ReverseFlag = false;

    if (TempSpeed < 0) 
    {
      ReverseFlag = true; //set flag to indicate reverse order
      TempSpeed = 0 - TempSpeed; //creates new variable, 0 is backwards regular speed
    }
    SpeedA = SpeedA+TempSpeed;

    while (SpeedA > 0)
    {
      DrawGenerated(GraphicsBufferA);
      SpeedA--;  //decf SpeedA
    }
  }//end if()


  if (FeedBGenerating == true && QuickFeeds[FeedBSelQuick].ControlState == 0) 
  {
    float TempSpeed = QuickFeeds[FeedBSelQuick].Speed;
    ReverseFlag = false;

    if (TempSpeed < 0) 
    {
      ReverseFlag = true; //set flag to indicate reverse order
      TempSpeed = 0 - TempSpeed; //creates new variable, 0 is backwards regular speed
    }
    SpeedB = SpeedB+TempSpeed;

    while (SpeedB > 0)
    {
      DrawGenerated(GraphicsBufferB);
      SpeedB--;
    }
  }//end if()

  //now The MixedBuffer is all updated for this frame, go ahead and send it out using the selected method
  if (CommunicationConnected == true)  SendData();  //sends the data packet

if(HandleMIDICC == true) HandleControlChange();
if(HandleMIDINO == true) HandleNoteOn();

  //=========================== START Pixel Preview Display ==========================================
  stroke(255);
  fill(0);
  strokeWeight(2);
  rect(5, 5, 260, 240);//FeedA BG
  rect(535, 5, 260, 240); //FeedB BG

  //============== MIXED PREVIEW or Full size Preview PANE =======================
  int x = 0;
  if (DisplayPreview == true)
  {
    stroke(255, 0, 0);  
    rect(275, 10, 250, 230); //output
    image(PreviewBuffer, 275, 10, 250, 230); //expands PGraphics array to larger size

    textSize(20);
    fill(0);
    text(QuickFeeds[DisplayThumbnail].UserID, 290, 230);
    fill(255);
    text(QuickFeeds[DisplayThumbnail].UserID, 288, 228);
  }
  else
  {
    stroke(128);
    strokeWeight(1);
    rect(270, 5, 260, 240); //output
    x = 0;
    for (int i=0; i != MaxPixels;i++)
    {
       if (Matrix.matrixPixelDataType < 7)  fill(MixedBuffer[x], MixedBuffer[x+1], MixedBuffer[x+2]);  //Use full color for RGB and RGBW
	   else    fill(MixedBuffer[x+(Matrix.matrixPixelDataType-7)]); //use only the selected color channel to display as grey scale
       
      MixedPixels[i].display();
      x = x+3;
    }
  }
  //============== FEED A PREVIEW PANE =======================
  stroke(128);
  strokeWeight(1);
  x = 0;
  for (int i=0; i != MaxPixels;i++)
  {
    if (Matrix.matrixPixelDataType < 7) fill(PrevBufferA[x], PrevBufferA[x+1], PrevBufferA[x+2]); //Use full color for RGB and RGBW
    else   fill(PrevBufferA[x+(Matrix.matrixPixelDataType-7)]); //use only the selected color channel to display as grey scale
    
    FeedAPixels[i].display();
    x = x+3;
  } 
  //============== FEED B PREVIEW PANE =======================
  x = 0;
  for (int i=0; i != MaxPixels;i++)
  {
    if (Matrix.matrixPixelDataType < 7)  fill(PrevBufferB[x], PrevBufferB[x+1], PrevBufferB[x+2]); //Use full color for RGB and RGBW
    else   fill(PrevBufferB[x+(Matrix.matrixPixelDataType-7)]); //use only the selected color channel to display as grey scale

    FeedBPixels[i].display();
    x = x+3;
  } 
  noStroke();

  //monitors if the user altered the screen size by dragging the window larger, and handles if resized
  if (PrevWidth != width || PrevHeight != height)
  {
    println("Window Resized to: "+width+" : "+height);    
    PrevHeight = height;  //used to watch if the grid window's size is changed
    PrevWidth = width;

    SF = (float)width / 800;
    UpdateWorkspace = true;   
    OpenMenuID = 0; //close all menus
    setup();
	
	//makes generated not error when resizing, restarts them
	FrameFirstRunA = true; 
  FrameFirstRunB = true; 
	
  }
  
  
   fill(255);
if(IntensityValueA != 1) text(PApplet.parseInt(IntensityValueA*100)+"%", 235, 240);
if(IntensityValueB != 1) text(PApplet.parseInt(IntensityValueB*100)+"%", 540, 240);
  
  
  /*
  		try {
		image(captureDSObj.updateImage(), 0, 0, MatrixWidth, MatrixHeight);
	
		}
		catch(Exception e)
		{
			println("No DShow capture avaialable.");
		} 
	*/	
}//end draw



public void RedrawSpeeds()
{
  //Easiest to make a seperate function for this
           //Redraws the Speed Value next to the slider without refreshing the whole workspace 
          textSize(14);    
          fill(cBackgroundColor);
          noStroke();
          rect(CommonSliders[6].xpos-30, CommonSliders[6].ypos, 25, CommonSliders[6].slHeight);
          rect(CommonSliders[7].xpos-30, CommonSliders[7].ypos, 25, CommonSliders[7].slHeight);
          fill(cMenuFontColor);
          text(nf(QuickFeeds[FeedASelQuick].Speed, 0, 1), CommonSliders[6].xpos-30, CommonSliders[6].ypos+CommonSliders[6].slHeight);
          text(nf(QuickFeeds[FeedBSelQuick].Speed, 0, 1), CommonSliders[7].xpos-30, CommonSliders[7].ypos+CommonSliders[7].slHeight);  
}
public void fileSelected(File selection) {
  //Taken from Processing examples, added a switch() to support future actions
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } 
  else 
  {
    println("User selected " + selection.getAbsolutePath());
    SelectedFile = selection.getAbsolutePath();

    String[] WorkStringA = split(SelectedFile, PApplet.parseChar(92)); //split up by backslash
    SelectedFile = WorkStringA[WorkStringA.length-1]; //get just the filename and extension

    String[] WorkString = new String[10]; //used to divide the lines into tab
    WorkString = split(SelectedFile, '.'); //strip off file extension so it can be added later
    WorkString[1].toLowerCase();

    switch(LoadFileMethod)
    {
    case 0:
      if (FeedFlag == true) //A
      {
        QuickFeeds[FeedASelQuick].FileName = SelectedFile.toLowerCase();

        if (WorkString[1].equals("dat")) QuickFeeds[FeedASelQuick].Method = 3; //set to 3 if loaded file was a .dat
        else if (WorkString[1].equals("png") || WorkString[1].equals("jpg")) QuickFeeds[FeedASelQuick].Method = 2; 
        else QuickFeeds[FeedASelQuick].Method = 0;  //otherwise it is considered a Movie(even images), so set it to 0   

          LoadQuickFeed(myMovieA, QuickFeeds[FeedASelQuick]);
      }
      else
      {
        QuickFeeds[FeedBSelQuick].FileName = SelectedFile.toLowerCase(); 

        if (WorkString[1].equals("dat")) QuickFeeds[FeedBSelQuick].Method = 3; //set to 100 if loaded file was a .dat
        else if (WorkString[1].equals("png") || WorkString[1].equals("jpg")) QuickFeeds[FeedBSelQuick].Method = 2; 
        else QuickFeeds[FeedBSelQuick].Method = 0;  //otherwise it is considered a Movie(even images), so set it to 0   

          LoadQuickFeed(myMovieB, QuickFeeds[FeedBSelQuick]);
      }
      break;
    case 1:    //save device config 

    SaveQuickFeedsFile();
      break;
    case 2: //load device config
      OpenMenuID = 0;
      //write the config.ini file with new path
      String[] clines = loadStrings("config.ini"); //load current config for header comments
      clines[1] = "configs/"+WorkString[0]+".txt"; //get absolute path, and add extension back on

      saveStrings("config.ini", clines);     
      stop(); //since it will crash the software anyway, just stop() and reopen
      //     InitializedWindowSize = false;
      //      setup();  
      break;
    }
  }//end else
}//end func

//========================================================================================================

public void LoadAutoFile()
{
  SelectedFile = Matrix.matrixAutomaticFileName.toLowerCase();  
  String[] lines = loadStrings(SelectedFile); //divides the lines
  String[] WorkString = new String[12]; //used to divide the lines into tab

  // Line: Fader Position(0=A, 100=B) - Feed ID - QuickFeed Variable - Draw Counts - Blend Mode(0 - 6) - Blend Speed(100 instant, 1+ = increment on dra
  println("LoadAutoFile() , AutoLines="+AutoLines);

  try {
    WorkString = split(lines[AutoLines], '\t');
  }
  catch(Exception e) {
    println("AutoFile Start Over");
    AutoLines = 1;
    WorkString = split(lines[AutoLines], '\t');
  }
  //set starting Mixer Position
  MixerValue = PApplet.parseInt(WorkString[0]) / 100;
  MainMixerSlider.Value = PApplet.parseInt(WorkString[0]);

  FeedID = PApplet.parseBoolean(WorkString[1]);

  //used in final commands
  //if(FeedID == true) FeedASelQuick = int(WorkString[2]);
  //else FeedBSelQuick = int(WorkString[2]);

  DrawCount = PApplet.parseInt(WorkString[3]);

  //BlendingMode = 
  HandleBlendButtons(PApplet.parseInt(WorkString[4])); //CHECK THIS FOR SURE
  BlendSpeed = PApplet.parseInt(WorkString[5]);

  if (FeedID == true) HandleQuickAButtons(PApplet.parseInt(WorkString[2]));//LoadQuickFeed(myMovieA, QuickFeeds[FeedASelQuick]);
  else HandleQuickBButtons(PApplet.parseInt(WorkString[2]));  //LoadQuickFeed(myMovieB, QuickFeeds[FeedBSelQuick]);
} //end func

//==================================================================================================================

public void SaveQuickFeedsFile()
{
  //Saves QuickFeed Objects to a txt file using an ArrayList
  SelectedFile = Matrix.matrixQuickFeedFileName;
  String[] WorkString = new String[2]; //used to divide the lines into tab
  WorkString = split(SelectedFile, '.'); //strip off file extension so it can be added later

  SelectedFile = WorkString[0];
  println(SelectedFile); 

  strs = new ArrayList(); // reset array list.... 
  int sLines=0;       
  String BuildLine = "";

  for (int i=0;i != QuickFeeds.length;i++)
  {   
    BuildLine = QuickFeeds[i].UserID+"\t"+QuickFeeds[i].Method+"\t"+QuickFeeds[i].FileName+"\t"+QuickFeeds[i].Speed+"\t"+QuickFeeds[i].SliderRed+"\t"+QuickFeeds[i].SliderGreen
      +"\t"+QuickFeeds[i].SliderBlue+"\t"+QuickFeeds[i].OffsetX+"\t"+QuickFeeds[i].OffsetY+"\t"+QuickFeeds[i].ColorState+"\t"+QuickFeeds[i].ControlState+"\t"+QuickFeeds[i].EffectState
      +"\t"+QuickFeeds[i].ContrastValue+"\t"+QuickFeeds[i].GenSlider1+"\t"+QuickFeeds[i].GenSlider2+"\t"+QuickFeeds[i].GenSlider3+"\t"+QuickFeeds[i].GenSlider4;
    strs.add(BuildLine);
    BuildLine = "";
  }   

  String[] lines = new String[strs.size()]; 

  for (int q=0; q != strs.size();q++)  
  {
    lines[q]=(String) strs.get(q);
  } 

  saveStrings(SelectedFile+".txt", lines);     
  println("File Generated");
}

//================================================================================================================

public void LoadQuickFeedsFile()
{
  //Loads data from Quickfeeds file into the objects
  SelectedFile = Matrix.matrixQuickFeedFileName; 
  String[] lines = loadStrings(SelectedFile); //divides the lines
  int sLines=0;  
  String[] WorkString = new String[12]; //used to divide the lines into tab

  for (int i=0; i != QuickFeeds.length;i++)
  {
    try { //try to read the lines of the QuickFeeds file and if there are missing lines or missing file it will recreate them with default
      WorkString = split(lines[i], '\t');
      QuickFeeds[i] = new QuickFeed(WorkString[0], PApplet.parseInt(WorkString[1]), WorkString[2], PApplet.parseFloat(WorkString[3]), PApplet.parseInt(WorkString[4]), PApplet.parseInt(WorkString[5]), 
      PApplet.parseInt(WorkString[6]), PApplet.parseInt(WorkString[7]), PApplet.parseInt(WorkString[8]), PApplet.parseInt(WorkString[9]), PApplet.parseInt(WorkString[10]), PApplet.parseInt(WorkString[11]), PApplet.parseInt(WorkString[12]), 
      PApplet.parseInt(WorkString[13]), PApplet.parseInt(WorkString[14]), PApplet.parseInt(WorkString[15]), PApplet.parseInt(WorkString[16]));
    }
    catch(Exception e)
    {
      println("Quick Feed Load Exception, filling with Blank");
      QuickFeeds[i] = new QuickFeed("Exception"+i, 0, "", 1, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    }
  }//end for

  //try to load thumbnails.dat if its not there, create them, if it is fill PGraphics arrays
  SelectedFile = DeviceFileID+"-thumbnails.dat";  //file name
  int x = 0;
  byte bb[];//create empty byte array  

 println("looking for "+ SelectedFile);
  
  
//  try 
//  {

    //try to loadBytes() if found, it will build new PGraphics arrays containting the thumbnails, if the file is not found
    bb = loadBytes(DeviceFileID+"-thumbnails.dat"); //load the thumbnail data bytes into the byte array
    x = 0;
    for (int q=0; q != cMaxQuickFeeds; q++)
    {
      CachedThumbnails[q] = createGraphics(MatrixWidth, MatrixHeight);
	  
	  CachedThumbnails[q].beginDraw(); //required for Processing 3.0
	  CachedThumbnails[q].endDraw();   //otherwise it errors(NullPointer) on loadPixels()
	  
      CachedThumbnails[q].loadPixels();      

      for (int i = 0; i != (MatrixWidth*MatrixHeight); i++) 
      {
        CachedThumbnails[q].pixels[i]=color(PApplet.parseInt(bb[x]), PApplet.parseInt(bb[x+1]), PApplet.parseInt(bb[x+2]));
        x+=3;
      } // end i for()
      CachedThumbnails[q].updatePixels(); 
	  
    }//end q for()
    println("Loaded Thumbnails");
 // }
//  catch(Exception e)
 // {
  
//  println("EXCEPTION REBUILDING THUMBS");
 // 
//   BuildAndSaveThumbnails();
 // }
 
 
 
}//end func

//==========================================================================================

public void GeneratePreview(int PassedID)
{
  //uses the methods to run the quickfeed and grab the first frame of a movie/.dat or the 30th iteration of a generated
  int i = PassedID;

  if (QuickFeeds[i].Method == 0) //if any supported video file
  {  
    try {
      PreviewMovie = new Movie(this, Matrix.matrixAbsoluteFootagePath+QuickFeeds[i].FileName);
      PreviewMovie.play(); //start the movie playing
      PreviewMovie.jump(0); //play first frame of movie
      PreviewMovie.pause(); //pause the movie
      //put updated pixels into PGraphics array
      CachedThumbnails[i].beginDraw();
      CachedThumbnails[i].image(PreviewMovie, 0, 0, MatrixHeight, MatrixWidth);
      CachedThumbnails[i].endDraw();

      PreviewMovie.stop();
      PreviewMovie.dispose();
      println("Preview Cached "+QuickFeeds[i].FileName+" : "+i);
    }
    catch(Exception f) {          
      PreviewMovie = new Movie(this, "testbars.png");
      CachedThumbnails[i].beginDraw();
      CachedThumbnails[i].image(PreviewMovie, 0, 0, MatrixHeight, MatrixWidth);
      CachedThumbnails[i].endDraw();  

      PreviewMovie.stop();
      PreviewMovie.dispose();    
      println("Preview Exception");
    }
  }
  else if (QuickFeeds[i].Method == 3) //if .dat file
  {
    println(".dat File Method Preview "+i);
    DataFrameFeedA = 0;
    ByteBufferA = new byte[1]; //shrink just in case
    ByteBufferA = loadBytes(Matrix.matrixAbsoluteFootagePath+QuickFeeds[i].FileName);
    LoadVideoDataFrame(GraphicsBufferA); //Loads first frame of a .dat file

    CachedThumbnails[i].beginDraw();
    CachedThumbnails[i].image(GraphicsBufferA, 0, 0, MatrixHeight, MatrixWidth);
    CachedThumbnails[i].endDraw();
  }
  else
  {
    //else it can be created through the DrawGenerated() function
    println("Generated Preview "+i+" : Method:"+QuickFeeds[i].Method);

    FrameFirstRunB = true;    //made B instead of A because of below line......
    FrameMethodB = QuickFeeds[i].Method; //set MethodB because of the if/else

    for (int q = 0; q != 30;q++) //run for 30 frames
    {
      DisplayThumbnail = i; //used for something else, but will work as a temp register for here
      DrawGenerated(CachedThumbnails[i]); //run the Generated Quickfeed 30 times so the thumbnail is accurate
    }
  } //end else
} //end func

//=================================================================================================================

public void BuildAndSaveThumbnails()
{
  //Builds thumbnail .dat files and saves it
  SelectedFile = DeviceFileID+"thumbnails.dat";  //file name
  int x = 0;
  byte bb[];//create empty byte array  
  
   //thumbnails.dat file not found, so create a new one
    for (int i=0; i != QuickFeeds.length;i++)  //generate Thumbnails, that are full size not pixel amount
    {
      CachedThumbnails[i] = createGraphics(MatrixWidth, MatrixHeight);
      GeneratePreview(i);//Generate the Preview Function
    } //end for()

    //save the thumnail preview 
    x = 0;
    bb = new byte[MaxChannels*cMaxQuickFeeds];

    for (int q=0; q != cMaxQuickFeeds; q++)
    {
      CachedThumbnails[q].loadPixels();

      for (int i = 0; i != (MatrixHeight * MatrixWidth); i++) 
      {
        myColor = CachedThumbnails[q].pixels[i];
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;   

        bb[x] = PApplet.parseByte(PApplet.parseInt(myRed));
        x++;
        bb[x] = PApplet.parseByte(PApplet.parseInt(myGreen));  
        x++;
        bb[x] = PApplet.parseByte(PApplet.parseInt(myBlue));  
        x++;
      } // end i for()
      CachedThumbnails[q].updatePixels(); //need this???
    }//end q for()   

    saveBytes(DeviceFileID+"-thumbnails.dat", bb);
    println("Thumbnails .dat file saved");
    }//end func()

//=================================================================================================================

public void LoadConfigFile()
{
   //loads config.ini to get the path to the device configuration file, each matrix will most likley require their own device config file 
  println("LoadConfigFile()");
  
  Matrix = new MatrixObj();
  
  SelectedFile = "config.ini";  //load the file that holds the path to the device config file

  String[] clines = loadStrings(SelectedFile); //divides the lines
  int sLines = 1;  
  String[] WorkString = new String[15]; //used to divide the lines into tab

  SelectedFile = clines[1]; //now SelectedFile holds the path to the device config file
  DeviceFileID = split(SelectedFile, '.')[0]; //save it for use with thumbnails, strip of extension
  String[] lines = loadStrings(SelectedFile); //divides the lines

  
 //printArray(lines); 
  
//start reading file
  WorkString = split(lines[sLines], '\t');
  Matrix.matrixCOM1 = PApplet.parseInt(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixTXBaud = PApplet.parseInt(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixWidth  = PApplet.parseInt(WorkString[1]);
  MatrixWidth = Matrix.matrixWidth;
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixHeight = PApplet.parseInt(WorkString[1]);
  MatrixHeight = Matrix.matrixHeight;
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixPixelDataType  = PApplet.parseInt(WorkString[1]);
   println("Matrix.matrixPixelDataType:"+Matrix.matrixPixelDataType); 
  sLines++; 
  
  
  WorkString = split(lines[sLines], '\t');
  Matrix.matrixCommMethod = 1;//int(WorkString[1]);
  
  println("Matrix.matrixCommMethod:"+Matrix.matrixCommMethod);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixServerIP = WorkString[1];
  sLines++; 

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixServerPort = PApplet.parseInt(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareAuroraCMD = PApplet.parseBoolean(WorkString[1]);
  sLines++;  
  
 //end hardware, start software configs for hardware 
  
  WorkString = split(lines[sLines], '\t');
  Matrix.matrixPatchFileName  = WorkString[1];
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixQuickFeedFileName = WorkString[1];
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixAbsoluteFootagePath = WorkString[1];
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixAutomaticFileName = WorkString[1];
  sLines++;
 
//start software  
  
  WorkString = split(lines[sLines], '\t');
  Matrix.softwareFrameRate = PApplet.parseInt(WorkString[1]);
  sLines++;
  
  WorkString = split(lines[sLines], '\t');
  int TempW = PApplet.parseInt(WorkString[1]);
  sLines++;
  WorkString = split(lines[sLines], '\t');
  int TempH = PApplet.parseInt(WorkString[1]);
  sLines++;
  surface.setSize(TempW, TempH); //no need to place into object
 
  
//end gui setup, setup software control communication
  WorkString = split(lines[sLines], '\t');
  Matrix.softwareMIDIenable = PApplet.parseBoolean(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareMIDIport = PApplet.parseInt(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareSerialConEnable = PApplet.parseBoolean(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareSerialConPort = PApplet.parseInt(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareSerialConBaud = PApplet.parseInt(WorkString[1]);
  sLines++; 
  
//end software control, setup gui functionality  
  
  WorkString = split(lines[sLines], '\t');
  Matrix.softwareEnableDSVideoFeed = PApplet.parseBoolean(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareEnableThumbnails = PApplet.parseBoolean(WorkString[1]);
  sLines++;  

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareLrgPreviewEnable = PApplet.parseBoolean(WorkString[1]);
  sLines++; 
  
  SF = (float)width / 800; //set scale factor
}


//======================================================================================================

public void BuildCustom()
{
  //loads a coordinate patch file, find min and mix point in both directions and scales the overall size to fit within the preview areas
  // creates the Pixel objects to display during draw and fills the Coordinate Arrays for Pixel Patching
  println("BuildCustom()");

  String[] lines = loadStrings(Matrix.matrixPatchFileName); //divides the lines
  int sLines=0;  
  String[] WorkString = new String[3]; //used to divide the lines into tab

  WorkString = split(lines[0], '\t');

  MaxPixels = PApplet.parseInt(WorkString[0]);
  
  int tempTransArraySize = 0;

  switch(Matrix.matrixPixelDataType)
  {
  case 0: //RGB
  case 2:
  case 3:
  case 4:
  case 5:
  case 6:
    PatchedChannels = MaxPixels *3; //not the same as MaxChannels, incase of non-square matrixes
    MaxChannels = (MatrixWidth * MatrixHeight) * 3;
    tempTransArraySize = PatchedChannels;
    break;
    
  case 1: //RGBW
    PatchedChannels = MaxPixels *4; //not the same as MaxChannels, incase of non-square matrixes
    MaxChannels = (MatrixWidth * MatrixHeight) * 4;
    tempTransArraySize = PatchedChannels;
    break;

  case 7: //Single Color, color used is dealt with later
  case 8:
  case 9:
    PatchedChannels = MaxPixels * 3; //not the same as MaxChannels, incase of non-square matrixes
    MaxChannels = (MatrixWidth * MatrixHeight)*3; //still has 3 channels per pixel to help with compatibility, single channel extratracted in SendData()
    tempTransArraySize = MaxPixels;//(MatrixWidth * MatrixHeight); //single color only one channel per pixel
    break;
  }

  println("PatchedChannels: "+PatchedChannels);
  println("MaxChannels: "+MaxChannels);
  println("MaxPixels: "+MaxPixels); 

  //resizes arrays to match the amount 
  TransmissionArray = new byte[1]; //must resize the Array so it is exactly the same size as channels
  TransmissionArray = expand(TransmissionArray, tempTransArraySize);//PatchedChannels);

  BufferA = new int[1]; //must resize the Array so it is exactly the same size as channels
  BufferA = expand(BufferA, PatchedChannels);



  BufferB = new int[1]; //must resize the Array so it is exactly the same size as channels
  BufferB = expand(BufferB, PatchedChannels);

  MixedBuffer = new int[1]; //must resize the Array so it is exactly the same size as channels
  MixedBuffer = expand(MixedBuffer, PatchedChannels);

//added 2b
  PrevBufferA = new int[1]; //must resize the Array so it is exactly the same size as channels
  PrevBufferA = expand(PrevBufferA, PatchedChannels);
  PrevBufferB = new int[1]; //must resize the Array so it is exactly the same size as channels
  PrevBufferB = expand(PrevBufferB, PatchedChannels);
  
  int MinX=1000;
  int MinY=1000;
  int MaxX=0;
  int MaxY=0;

  for (int i=1;i != lines.length;i++)
  {
    WorkString = split(lines[i], '\t');
    if (PApplet.parseInt(WorkString[0]) > MaxX) MaxX = PApplet.parseInt(WorkString[0]);
    if (PApplet.parseInt(WorkString[0]) < MinX) MinX = PApplet.parseInt(WorkString[0]);

    if (PApplet.parseInt(WorkString[1]) > MaxY) MaxY = PApplet.parseInt(WorkString[1]);
    if (PApplet.parseInt(WorkString[1]) < MinY) MinY = PApplet.parseInt(WorkString[1]);
  }
  // println("X: "+MinX+" : "+MaxX);
  // println("Y: "+MinY+" : "+MaxY);

  Xdifference = MaxX - MinX;
  Ydifference = MaxY - MinY;
  println(Xdifference+" : "+Ydifference);

  PatchCoordX = new int[PatchedChannels]; //resize the patch arrays based on PatchedChannels
  PatchCoordY = new int[PatchedChannels];

  //file created was incremented method channel numbers
  for (int i=0;i != MaxPixels;i++)
  {
    WorkString = split(lines[i+1], '\t');      
    PatchCoordX[i] = PApplet.parseInt(WorkString[0]) - MinX;
    PatchCoordY[i] = PApplet.parseInt(WorkString[1]) - MinY;
  }

  //int LargestCoord = (MaxX > MaxY) ? MaxX : MaxY;// figure which direction is largest to create the scale val

  int LargestCoord;
  int BaseSize;

  if (MaxX > MaxY)
  {
    LargestCoord = MaxX;
    BaseSize = 240 / LargestCoord; //can't be 0, right?
  }
  else
  {
    LargestCoord = MaxY;
    BaseSize = 210 / LargestCoord; //can't be 0, right?
  }

  int YCenter = floor((220 - (BaseSize * MaxY)) / 2);
  int XCenter = floor((250 - (BaseSize * MaxX)) / 2);  

  for (int i=0; i != MaxPixels;i++)
  { 
    FeedAPixels[i] = new PixelDisplay((5+(PatchCoordX[i]*BaseSize)+XCenter), (10+(PatchCoordY[i]*BaseSize)+YCenter), BaseSize, BaseSize);
    FeedBPixels[i] = new PixelDisplay((535+(PatchCoordX[i]*BaseSize)+XCenter), (10+(PatchCoordY[i]*BaseSize)+YCenter), BaseSize, BaseSize);
    MixedPixels[i] = new PixelDisplay((270+(PatchCoordX[i]*BaseSize)+XCenter), (10+(PatchCoordY[i]*BaseSize)+YCenter), BaseSize, BaseSize);
  }
}//end func
public void PreviewQuickFeed(int PassedID)
{ 
  //Loads the Thumbnails into the Preview Graphics array which is displayed
  println("PreviewQuickFeed() "+PassedID);
  PreviewBuffer.beginDraw();
  PreviewBuffer.image(CachedThumbnails[PassedID], 0, 0, MatrixHeight, MatrixWidth);
  PreviewBuffer.endDraw();
  PreviewColorEffects(PassedID); //fill color Effects to PreviewBuffer
  DisplayThumbnail = PassedID;  
  DisplayPreview = true;
} //end PreviewQuickFeed()

//====================================================================================================

public void SetControlStateFunc(Movie m, Button[] b, int controlState)
{
  println("SetControlStateFunc "+controlState);

  b[0].Selected = false;
  b[1].Selected = false;  
  b[2].Selected = false;  

  switch(controlState)
  {
  case 0: //Play
    try {
      m.loop();
    }
    catch(Exception e) {
    }
    b[0].Selected = true;
    b[0].display();
    break;
  case 1: //pause
    try {
      m.play(); //will display the first frame when open a paused QuickFeed, but will not remember where it was paused
      //     m.jump(0);
      //   m.read();
      m.pause();
    }
    catch(Exception e) {
    }
    b[1].Selected = true;
    b[1].display();
    break;
  case 2: //stop
    try {
      m.stop();
    }
    catch(Exception e) {
    }
    b[2].Selected = true;
    b[2].display();    
    break;
  }//end switch
  b[0].display();
  b[1].display();
  b[2].display();
} //end func

public void SetEffectStateFunc(Button[] b, int effectNum)
{
  println("SetEffectStateFunc "+effectNum);

  b[5].Selected = false;
  b[11].Selected = false;  

  switch(effectNum)
  {
    //0 is none
  case 1:
    b[5].Selected = true; //invert
    break;
  case 2:
    b[11].Selected = true; //contrast
    break;    
  case 3:
    b[5].Selected = true; //invert
    b[11].Selected = true;  //contrast    
    break;
  }

  b[5].display();
  b[11].display();
} //end func

public void SetColorStateFunc(Button[] b, int colorEffectNum)
{
  b[6].Selected = false;
  b[7].Selected = false;  
  b[9].Selected = false;   
  b[10].Selected = false;   

  switch(colorEffectNum)
  {
    //0 is none
  case 1:
    b[6].Selected = true;
    break;
  case 2:
    b[7].Selected = true;
    break;    
  case 3:
    b[9].Selected = true;
    break; 
  case 4:
    b[10].Selected = true;
    break;
  }

  if (b == FeedAButtons)
  {
    QuickFeeds[FeedASelQuick].SliderRed = CommonSliders[0].Value;
    QuickFeeds[FeedASelQuick].SliderGreen = CommonSliders[1].Value;
    QuickFeeds[FeedASelQuick].SliderBlue =CommonSliders[2].Value;
    CommonSliders[0].display();
    CommonSliders[1].display();    
    CommonSliders[2].display();
  }
  else
  {
    QuickFeeds[FeedBSelQuick].SliderRed = CommonSliders[3].Value;
    QuickFeeds[FeedBSelQuick].SliderGreen = CommonSliders[4].Value;
    QuickFeeds[FeedBSelQuick].SliderBlue = CommonSliders[5].Value;  
    CommonSliders[3].display();
    CommonSliders[4].display();
    CommonSliders[5].display();
  }
  b[6].display();
  b[7].display();
  b[9].display();
  b[10].display();
} //end func


public void LoadQuickFeed(Movie m, QuickFeed qf)
{ 
  //All QuickFeed Loads come through here, regardless of method

  //Have to set a flag for Feed A or B now, before the object is disposed, checking m after that won't work right
  if (m == myMovieA) FeedFlag = true; 
  else FeedFlag = false;

  if (qf.Method == 0)
  {
    println("Method 0, Loading: "+Matrix.matrixAbsoluteFootagePath+qf.FileName);    
    if (m == myMovieA)
    {
      try {
        myMovieA.stop();
        myMovieA.dispose(); //tested as not necassary to prevent CPU usage bloating
      }
      catch(Exception e) {
        println("FeedA Movie Null, stop() not executed");
      }
      try {   
        myMovieA = new Movie(this, Matrix.matrixAbsoluteFootagePath+qf.FileName);
      }
      catch(Exception e) {
        myMovieA = new Movie(this, "testbars.png");
        println("Load Exception FeedA");
      }
      FeedAGenerating = false; 
      arrayCopy(cNotUsedLabels, GenSliderLabelsA); //make the generated sliders say Not Used
      SetControlStateFunc(myMovieA, FeedAButtons, qf.ControlState);
    } //end MovieA
    else //start MovieB
    {
      try { //could merge  the try and catch to stop and dispose
        myMovieB.stop();
        myMovieB.dispose();
      }
      catch(Exception e) {
        println("FeedB Movie Null, stop() not executed");
      }

      try { 
        myMovieB = new Movie(this, Matrix.matrixAbsoluteFootagePath+qf.FileName);
      }
      catch(Exception e) {
        myMovieB = new Movie(this, "testbars.png");
        println("Load Exception FeedB ");
      }
      FeedBGenerating = false;
      arrayCopy(cNotUsedLabels, GenSliderLabelsB); //make the generated sliders say Not Used      
      SetControlStateFunc(myMovieB, FeedBButtons, qf.ControlState);
    }
  }
  else if (qf.Method == 2) //Image for now
  {  
    PImage tImg = loadImage(""+Matrix.matrixAbsoluteFootagePath+qf.FileName+"");    
    if (FeedFlag == true)
    {    
      GraphicsBufferA.beginDraw();
      GraphicsBufferA.image(tImg, 0, 0);
      GraphicsBufferA.endDraw();
    }
    else
    {
      GraphicsBufferB.beginDraw();
      GraphicsBufferB.image(tImg, 0, 0);
      GraphicsBufferB.endDraw();
    }

    qf.ControlState = 1; //pause it
  }
  else
  {
    //not a Movie or Image it is generated
    println("Generated");


    if (m == myMovieA) 
    {
    FrameFirstRunA = true;    //forst time DrawGenerated is ran it will allow the initialization switch() to run	
      FeedAGenerating = true;
      FrameMethodA = qf.Method; 
      DataFrameFeedA = 0;
      DrawGenerated(GraphicsBufferA);//this will setup the generated content


      SetControlStateFunc(myMovieA, FeedAButtons, qf.ControlState);

      try {
        myMovieA.stop();
        myMovieA.dispose();
      }
      catch(Exception e)
      {
        println("FeedA Movie Null, stop() not executed");
      }
    }
    else
    {
	  FrameFirstRunB = true;    //forst time DrawGenerated is ran it will allow the initialization switch() to run
      FeedBGenerating = true;
      FrameMethodB = qf.Method; 
      DataFrameFeedB = 0;      
      DrawGenerated(GraphicsBufferB); //this will setup the generated content  

      SetControlStateFunc(myMovieB, FeedBButtons, qf.ControlState);
      try {
        myMovieB.stop();
        myMovieB.dispose();
      }
      catch(Exception e)
      {
        println("FeedB Movie Null, stop() not executed");
      }
    }
  }

  //============== ALL METHODS RUN THIS ====================================
  if (FeedFlag == true)
  {
    println("Load FeedA, Speed: "+qf.Speed);
    if (qf.Speed > 0) CommonSliders[6].Value = round((qf.Speed * 10)+cDefaultSpeed);
    else CommonSliders[6].Value = round(cDefaultSpeed - ( (qf.Speed*-1) * 10));

    CommonSliders[0].Value = qf.SliderRed; //displayed in SetColorState
    CommonSliders[1].Value = qf.SliderGreen;
    CommonSliders[2].Value = qf.SliderBlue;
    CommonSliders[8].Value = qf.ContrastValue;   

    CommonSliders[6].display();      
    CommonSliders[8].display();   
    RedrawSpeeds();
    
    SetColorStateFunc(FeedAButtons, qf.ColorState); //sets the colorMode and button state based on variable
    SetEffectStateFunc(FeedAButtons, qf.EffectState);   //sets effect Mode and button states based on variable
  }
  else
  {
    println("Load FeedB, Speed: "+qf.Speed);
    if (qf.Speed > 0) CommonSliders[7].Value = round((qf.Speed * 10)+cDefaultSpeed);
    else CommonSliders[7].Value = round(cDefaultSpeed - ( (qf.Speed*-1) * 10));  

    CommonSliders[3].Value = qf.SliderRed;
    CommonSliders[4].Value = qf.SliderGreen;
    CommonSliders[5].Value = qf.SliderBlue;
    CommonSliders[9].Value = qf.ContrastValue;       

    CommonSliders[7].display();
    CommonSliders[9].display(); 
    RedrawSpeeds();

    SetColorStateFunc(FeedBButtons, qf.ColorState);
    SetEffectStateFunc(FeedBButtons, qf.EffectState);
  }
} //end LoadQuickFeed()


public void stop()
{
  myMovieA.stop();
  myMovieB.stop(); 
  myMovieA.dispose();
  myMovieB.dispose();  
  myPort.stop();
  try {
    TCPclient.dispose();
    //   UDPclient.dispose(); //not stop, dispose or close
  }
  catch(Exception e)
  {
  }
  myBus.stop();
}

/*
//UNCOMMENT TO ENABLE FULLSCREEN
 boolean sketchFullScreen() {
 return true;
 }
 */
class ggObjAudioCircles
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method

	public void ggObjAudioCircles()
	{
		ggName = "Audio Reactive Circles"; //force name
		ggIDnumber = 200;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);
	
		selBuffer.noStroke();
		selBuffer.fill(255, 0, 0, 0);
		selBuffer.stroke(255);
		selBuffer.strokeWeight(1);
		selBuffer.ellipseMode(CENTER);	
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		selBuffer.background(0);
		selBuffer.noFill();
		selBuffer.strokeWeight(1);
		selBuffer.stroke(255);
		for (int i = 0; i < AudioIn.bufferSize() - 1; i=i+(AudioIn.bufferSize()/11))
		{  
			selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 1+(AudioIn.left.get(i)*35), 1+(AudioIn.right.get(i)*35));
		}		

		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjAudioSine
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method
	float FadeOutFactor;
	float[] AverageByte = new float[512]; //sine wave


	public void ggObjAudioSine()
	{
		ggName = "Audio Reactive Sine Wave"; //force name
		ggIDnumber = 201;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cSineWave, passedBuf);
	
		selBuffer.noStroke();    
		selBuffer.fill(255);       	
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		FadeOutFactor =  (float)HoldGenSlider2 / 255; //Decay

		if (HoldGenSlider3 == 0) selBuffer.background(0); 
		else  DecayBuffer(FadeOutFactor, selBuffer); //run Decay Function
		
		selBuffer.noStroke();
		selBuffer.fill(255);
		
		//standard Sine  wave
		int xx = 0;
		for (int i = 0; i < AudioIn.bufferSize() - 1; i=i+(AudioIn.bufferSize()/MatrixWidth))
		{  
			AverageByte[i]  = (AverageByte[i] + AudioIn.left.get(i));
			selBuffer.rect(xx, (MatrixHeight/2), (HoldGenSlider3/16), round(1+(AudioIn.left.get(i)*(HoldGenSlider1/2))));
			xx++;
		}
	
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjAudioBars
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method
	float FadeOutFactor;
	float[] AverageByte = new float[512]; //sine wave
		
	public void ggObjAudioBars()
	{
		ggName = "Audio Reactive Bars"; //force name
		ggIDnumber = 202;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cReactiveBars, passedBuf);
	
		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.fill(255);  	
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		FadeOutFactor = (float)HoldGenSlider3 / 255; //Decay

		if (HoldGenSlider3 == 0) selBuffer.background(0); 
		else   DecayBuffer(FadeOutFactor, selBuffer); //run Decay Function

		selBuffer.fill(255);

		int xy = 0;
		for (int i = 0; i < AudioIn.bufferSize() - 1; i=i+(AudioIn.bufferSize()/MatrixWidth))
		{  
			AverageByte[i]  = ((AverageByte[i] * -1) + AudioIn.left.get(i)) / 2;    //was 2
			selBuffer.rect(0+((HoldGenSlider4/16)*xy), MatrixHeight, (HoldGenSlider2/16), 1+(AverageByte[i]*(HoldGenSlider1*3))); //was 25
			xy++;
		} 
			
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================
//Forgot where this code was from, figure it out so I can give credit
//but monitors a DShow capture, such as ManyCam or webcams, good for patching in Milkdrop or similair visiuals


//MAC AND LINUX USAGE REMOVE FROM HERE
class DCapture implements java.beans.PropertyChangeListener {

	private DSCapture capture;
	public int width, height;

	DCapture() {
		DSFilterInfo[][] dsi = DSCapture.queryDevices();
		capture = new DSCapture(DSFiltergraph.DD7, dsi[0][0], false, 
		DSFilterInfo.doNotRender(), this);
		width = capture.getDisplaySize().width;
		height = capture.getDisplaySize().height;
	}

	public PImage updateImage() {
		PImage img = createImage(width, height, RGB);
		BufferedImage bimg = capture.getImage();
		bimg.getRGB(0, 0, img.width, img.height, img.pixels, 0, img.width);
		img.updatePixels();
		return img;
	}

	public void propertyChange(java.beans.PropertyChangeEvent e) {
		switch (DSJUtils.getEventType(e)) {
		}
	}
}
//TO HERE


public void DrawGenerated(PGraphics buf)
{
	//All Generated/.DAT/Non-Video feeds come through here
	//The first time through for a Feed, The FrameFirstRun should be set so it can initilize using the switch()

	//Then it will run whenever called, the speed is a float, so really slow and really fast frame rates are supported and called from draw()

	//Many of the generated graphics were taken from the internet from various websites and programmers. Each should have a linkback to the orignal
	//  project it was taken from. If more are added please ensure to give credit back to the original programmer.

	int BufferIDNum = IdentifyBufferID(buf);
	
	//remove this and use BufferIDNum, make global?
	if (buf == GraphicsBufferA) FrameMethod = FrameMethodA;
	else  FrameMethod = FrameMethodB; //generation also else's and uses frameB

	if (FrameFirstRunA == true || FrameFirstRunB == true)
	{
		if (FrameFirstRunA == true) FrameFirstRunA = false;
		else FrameFirstRunB = false;

		println("Method Init, FirstRun "+FrameMethod+" using "+BufferIDNum);

		//First Initialize the generated content
		buf.beginDraw();
		
		//some defaults
		buf.colorMode(RGB, 255); //required or wierd things happen
		buf.rectMode(CORNER);       
		buf.strokeWeight(1);

		switch(FrameMethod)
		{
		case 1: //capture from input
			//MAC AND LINUX USERS COMMENT OUT FROM HERE
			if (captureDSObj == null && Matrix.softwareEnableDSVideoFeed == true)
			{
				captureDSObj = new DCapture();
				println("Capture: "+captureDSObj.width+" : "+captureDSObj.height);
			}   
			//TO HERE
			
			arrayCopy(cNotUsedLabels, GenSliderLabelsB); //copy labels from constants
			break;
		case 2: //image
			genGraphicImage[BufferIDNum] = new ggObjImage();		
			genGraphicImage[BufferIDNum].ggInitilaize(buf);		
			break;
		case 3: // .dat file
			genGraphicDATFile[BufferIDNum] = new ggObjDATFile();		
			genGraphicDATFile[BufferIDNum].ggInitilaize(buf);			
			break;
		case 4: //Text	
			genGraphicText[BufferIDNum] = new ggObjText();		
			genGraphicText[BufferIDNum].ggInitilaize(buf);
			break;    

		
		case 101://star field
			genGraphicStarField[BufferIDNum] = new ggObjStarField();		
			genGraphicStarField[BufferIDNum].ggInitilaize(buf);
			break;
		case 102: //spinning square
			genGraphicSpinningSquare[BufferIDNum] = new ggObjSpinningSquare();		
			genGraphicSpinningSquare[BufferIDNum].ggInitilaize(buf);
			break;
		case 103: //circle ripples
 			genGraphicRipples[BufferIDNum] = new ggObjRipples();		
			genGraphicRipples[BufferIDNum].ggInitilaize(buf);
			break;
		case 104: //metaballs
 			genGraphicMetaBalls[BufferIDNum] = new ggObjMetaBalls();		
			genGraphicMetaBalls[BufferIDNum].ggInitilaize(buf); 
			break;
		case 105: //strange plasma
 			genGraphicPlasma[BufferIDNum] = new ggObjPlasma();		
			genGraphicPlasma[BufferIDNum].ggInitilaize(buf);
			break;	
		case 106: //spiral
 			genGraphicSpiral[BufferIDNum] = new ggObjSpiral();		
			genGraphicSpiral[BufferIDNum].ggInitilaize(buf);
			break; 	
		case 109: //falling blocks
  			genGraphicFallingBlocks[BufferIDNum] = new ggObjFallingBlocks();		
			genGraphicFallingBlocks[BufferIDNum].ggInitilaize(buf);  
			break;
		case 123: //test step through
     		genGraphicTestStepThrough[BufferIDNum] = new ggObjTestStepThrough();		
			genGraphicTestStepThrough[BufferIDNum].ggInitilaize(buf);       
			break;	

			
		case 200: //audio reactive cirlce
       		genGraphicAudioCircles[BufferIDNum] = new ggObjAudioCircles();		
			genGraphicAudioCircles[BufferIDNum].ggInitilaize(buf);         
			break;			
		case 201: //Audio Sine Wave
        	genGraphicAudioSine[BufferIDNum] = new ggObjAudioSine();		
			genGraphicAudioSine[BufferIDNum].ggInitilaize(buf);    
			break;
		case 202: //audio bars
        	genGraphicAudioBars[BufferIDNum] = new ggObjAudioBars();		
			genGraphicAudioBars[BufferIDNum].ggInitilaize(buf);            
			break;
		}//end switch
	}//end if

	//======================================== END SETUP ========================================

	if (buf == GraphicsBufferA) //moves QuickFeed stored Generation variables into hold registers
	{
		HoldGenSlider1 = QuickFeeds[FeedASelQuick].GenSlider1;
		HoldGenSlider2 = QuickFeeds[FeedASelQuick].GenSlider2;
		HoldGenSlider3 = QuickFeeds[FeedASelQuick].GenSlider3;
		HoldGenSlider4 = QuickFeeds[FeedASelQuick].GenSlider4;
	}
	else  if (buf == GraphicsBufferB)
	{
		HoldGenSlider1 = QuickFeeds[FeedBSelQuick].GenSlider1;
		HoldGenSlider2 = QuickFeeds[FeedBSelQuick].GenSlider2;
		HoldGenSlider3 = QuickFeeds[FeedBSelQuick].GenSlider3;
		HoldGenSlider4 = QuickFeeds[FeedBSelQuick].GenSlider4;
	}
	else
	{
		//generating previews thumbnails
		HoldGenSlider1 = QuickFeeds[DisplayThumbnail].GenSlider1;
		HoldGenSlider2 = QuickFeeds[DisplayThumbnail].GenSlider2;
		HoldGenSlider3 = QuickFeeds[DisplayThumbnail].GenSlider3;
		HoldGenSlider4 = QuickFeeds[DisplayThumbnail].GenSlider4;
	}
	//========================== START DRAW ==========================================

	
	switch(FrameMethod)
	{
	case 0: //Movie, so nothing happens here

		break;
	case 1: //DShow capture
		//MAC AND LINUX USERS COMMENT OUT FROM HERE
		buf.beginDraw();
		try {
	
			if (buf == GraphicsBufferA) buf.image(captureDSObj.updateImage(), 0+QuickFeeds[FeedASelQuick].OffsetX, 0+QuickFeeds[FeedASelQuick].OffsetY, MatrixWidth+(MatrixWidth/4), MatrixHeight+(MatrixHeight/4));  
			else  
			{
				buf.image(captureDSObj.updateImage(), 0, 0, MatrixWidth+(MatrixWidth/4), MatrixHeight+(MatrixHeight/4));
			}

		}
		catch(Exception e)
		{
			println("No DShow capture avaialable.");
		} 
		//TO HERE
		break; 
	case 2: //image
		//never gets here
		break;    
	case 3: // .dat video files
		genGraphicDATFile[BufferIDNum].ggFillBuffer();	
		break;  
	case 4: //Text 
		genGraphicText[BufferIDNum].ggFillBuffer();
		break;        	
	//============  start generated methods, end System methods     ======================================
	case 101://star field
		genGraphicStarField[BufferIDNum].ggFillBuffer();
		break;		
	case 102: //spinning cube
		genGraphicSpinningSquare[BufferIDNum].ggFillBuffer();	
		break;  		
	case 103: //ripples
		genGraphicRipples[BufferIDNum].ggFillBuffer();	
		break;  		
	case 104: //metaballs
		genGraphicMetaBalls[BufferIDNum].ggFillBuffer();	
		break;		
	case 105: //plasma
		genGraphicPlasma[BufferIDNum].ggFillBuffer();		
		break;
	case 106: //spiral
		genGraphicSpiral[BufferIDNum].ggFillBuffer();	
		break;
	//7
	//8	
		
	case 109: //falling blocks
		genGraphicFallingBlocks[BufferIDNum].ggFillBuffer();
		break;	
	case 123: //test Step Through
		genGraphicTestStepThrough[BufferIDNum].ggFillBuffer();	
		break;		
	
	//============  start audio generated methods ======================================
	case 200: //Sound Reactive Circle
		genGraphicAudioCircles[BufferIDNum].ggFillBuffer();	
		break;		
	case 201: //Audio Sine Wave
		genGraphicAudioSine[BufferIDNum].ggFillBuffer();	
		break;
	case 202: //Sound Reactive Bars, best at low framerate
		genGraphicAudioBars[BufferIDNum].ggFillBuffer();	
		break;	
	}//end switch
	buf.endDraw();
}//end function


public void DecayBuffer(float passedValue, PGraphics buf)
{
	//multi use function for decay/trail effect
	buf.loadPixels();
	for (int i = 0;i != buf.pixels.length; i++) //decay/ fade out entire pixel[] array
	{
		myColor = buf.pixels[i];
		myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
		myGreen = myColor >> 8 & 0xFF;
		myBlue = myColor & 0xFF; 
		buf.pixels[i] = color(round(myRed*passedValue), round(myGreen*passedValue), round(myBlue*passedValue));
		//buf.pixels[i] = color(hue(buf.pixels[i]), 100, brightness(buf.pixels[i])-1); //didn't work to adjust brightness
	}
	buf.updatePixels();  
}

//================================ END BUFFER DRAW =====================================

public void LoadVideoDataFrame(PGraphics buf)
{ 
	//Buffer Arrays are defined and filled elsewhere and this function just moves data from the byte buffer array to the PGraphics array
	//   for reading the whole .dat file should be already cached to a ByteBuffer array of the exact size

	int HoldFrame  = 0;
	int HoldBufferLen = 0;

	if (buf == GraphicsBufferA) 
	{
		HoldFrame  = DataFrameFeedA;
		HoldBufferLen = ByteBufferA.length;
	}
	else 
	{
		HoldFrame = DataFrameFeedB;
		HoldBufferLen = ByteBufferB.length;
	}

	if (ReverseFlag == true)   
	{
		HoldFrame--; //decrease frame var, if it is belo 0, make it Maximum + -number = new frame value
		if (HoldFrame < 0) HoldFrame = round(HoldBufferLen/MaxChannels) + HoldFrame; //A and B are the same size
	}
	else
	{
		HoldFrame++;
		if ((HoldFrame*MaxChannels) >= HoldBufferLen) HoldFrame = 0;
	}

	int TempBC = HoldFrame * MaxChannels;
	int TempEnd = TempBC + MaxChannels; //should be ok since it is checked before leaving, what about scratching?

	int x = 0;
	buf.loadPixels();
	try {
		if (buf == GraphicsBufferA) 
		{
			for (int i = TempBC; i < TempEnd; i+=3) 
			{
				buf.pixels[x]=color(PApplet.parseInt(ByteBufferA[i]), PApplet.parseInt(ByteBufferA[i+1]), PApplet.parseInt(ByteBufferA[i+2]));
				x++;
			} 
			DataFrameFeedA = HoldFrame;
		}
		else 
		{
			for (int i = TempBC; i < TempEnd; i+=3) 
			{
				buf.pixels[x]=color(PApplet.parseInt(ByteBufferB[i]), PApplet.parseInt(ByteBufferB[i+1]), PApplet.parseInt(ByteBufferB[i+2]));
				x++;
			} 
			DataFrameFeedB = HoldFrame;
		}
	}
	catch(Exception e)
	{
		println("Something, Somewhere went wrong!!!");
	}
	buf.updatePixels();
} //end func

public int IdentifyBufferID(PGraphics passedBuf)
{
	if (passedBuf == GraphicsBufferA) return 0;
	else if (passedBuf == GraphicsBufferB) return 1;
	//2 more......

	return 0;
}

public void SetGenSliderText(String[] passedStr, PGraphics passedBuf)
{
	switch(IdentifyBufferID(passedBuf))
	{
	case 0:
		arrayCopy(passedStr, GenSliderLabelsA);
		break;
	case 1:
		arrayCopy(passedStr, GenSliderLabelsB);
		break;
	}//end switch

} //end func

//=============================================================================================================

class ggObjText
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	int textNested = 0; 
	int textPosition = 0;


	public void ggObjText()
	{
		ggName = "Text Scroll"; //force name
		ggIDnumber = 4;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		selBuffer.fill(255);
		selBuffer.noStroke();
		
		SetGenSliderText(cTextLabels, passedBuf);
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		selBuffer.beginDraw();
		//some defaults
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);


		selBuffer.background(0);
		HoldGenSlider3 = PApplet.parseInt(MatrixHeight*((float)HoldGenSlider3 / 255));
		HoldGenSlider2 = HoldGenSlider2/16;
		String holdStr;

		if (selBuffer == GraphicsBufferA)  holdStr = QuickFeeds[FeedASelQuick].UserID;
		else if (selBuffer == GraphicsBufferB) holdStr = QuickFeeds[FeedBSelQuick].UserID;
		else holdStr = QuickFeeds[DisplayThumbnail].UserID; 

		
		if (HoldGenSlider1 == 0) HoldGenSlider1 = 1; //fixes preview generation for now

		selBuffer.textSize(ceil((float)(MatrixHeight*((float)HoldGenSlider1/255))));

		if (textNested >= HoldGenSlider2)     
		{
			textNested = 0;

			if (ReverseFlag == true)
			{
				if (textPosition > MatrixWidth)  textPosition = PApplet.parseInt(-textWidth(holdStr));
				else textPosition += 1;
			}
			else
			{
				if (textPosition < -textWidth(holdStr)) textPosition = MatrixWidth;
				else textPosition -= 1;
			}
		}
		textNested++;
		selBuffer.text(holdStr, textPosition, HoldGenSlider3);   
		selBuffer.endDraw();		
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================
class ggObjImage
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;


	public void ggObjImage()
	{
		ggName = "Image"; //force name
		ggIDnumber = 2;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjDATFile
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method

	public void ggObjDATFile()
	{
		ggName = "DAT File"; //force name
		ggIDnumber = 3;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		
		SetGenSliderText(cNotUsedLabels, passedBuf);
		
		try 
		{ //try to load from selected .dat file, but if not found create empty array  
			if (selBuffer == GraphicsBufferA)
			{
				ByteBufferA = new byte[1]; //shrink just in case
				ByteBufferA = loadBytes(Matrix.matrixAbsoluteFootagePath+QuickFeeds[FeedASelQuick].FileName);
				println(".dat file  method setup A: "+ByteBufferA.length);
			}
			else {  
				ByteBufferB = new byte[1]; //shrink just in case
				ByteBufferB =  loadBytes(Matrix.matrixAbsoluteFootagePath+QuickFeeds[FeedBSelQuick].FileName);
				println(".dat file  method setup B: "+ByteBufferB.length);
			}
		}
		catch(Exception e)
		{
			if (selBuffer == GraphicsBufferA)
			{
				ByteBufferA = new byte[1]; //shrink just in case
				ByteBufferA = new byte[MaxChannels];
			}
			else
			{
				ByteBufferB = new byte[1]; //shrink just in case
				ByteBufferB = new byte[MaxChannels];
			}
		}    
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		LoadVideoDataFrame(selBuffer);	
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjStarField
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int reps = 255; //starfield
	float [] ypos = new float[reps]; //starfield
	float [] xpos = new float[reps]; //starfield
	int instance = 0; //starfield
	int refreshPoint = 100; //starfield


	public void ggObjStarField()
	{
		ggName = "Star Field"; //force name
		ggIDnumber = 101;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cStarFieldLabels, passedBuf);
		
		selBuffer.fill(255);
		selBuffer.rectMode(CENTER);  
		selBuffer.ellipseMode(CENTER);     
		for (instance = 0; instance < reps; instance ++) 
		{
			xpos[instance] = PApplet.parseInt(random(-(MatrixWidth/2), (MatrixWidth/2)));
			ypos[instance] = PApplet.parseInt(random(-(MatrixHeight/2), (MatrixHeight/2)));
		}  	//end for()
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		//Where was this from??
		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.pushMatrix();
		selBuffer.translate(MatrixWidth/2, MatrixHeight/2);
		for (instance = 0; instance < HoldGenSlider4; instance ++) {
			selBuffer.stroke(255, instance);

			selBuffer.strokeWeight(1);  //would like to control this as well but its not worth additional effort

			int sSize = round(HoldGenSlider2 / 8);
			if (sSize == 0) sSize = 1;

			if (HoldGenSlider3 > 128) selBuffer.fill(0, 0, 0, 0);
			else  selBuffer.fill(255);

			if (HoldGenSlider1 < 85)  selBuffer.point(PApplet.parseInt(xpos[instance]), PApplet.parseInt(ypos[instance]));
			else if (HoldGenSlider1 < 170) selBuffer.ellipse(PApplet.parseInt(xpos[instance]), PApplet.parseInt(ypos[instance]), sSize, sSize);
			else selBuffer.rect(PApplet.parseInt(xpos[instance]), PApplet.parseInt(ypos[instance]), sSize, sSize);

			xpos[instance]= xpos[instance]+(xpos[instance])/100.0f;
			ypos[instance]= ypos[instance]+(ypos[instance])/100.0f;

			if ((xpos[instance] < -MatrixWidth) || (xpos[instance] > MatrixWidth) ||
					(ypos[instance] < -MatrixHeight) || ( ypos[instance] > MatrixHeight)) 
			{
				xpos[instance] = random(-refreshPoint, refreshPoint);
				ypos[instance] = random(-refreshPoint, refreshPoint);
			}
		}
		selBuffer.popMatrix(); 
		selBuffer.endDraw();		
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjSpinningSquare
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int TempRotation = 45; //spinning cube
	int TempScale = 10; //spinning cube
	int ScaleEndPoint =20; //spinning cube

	public void ggObjSpinningSquare()
	{
		ggName = "Spinning Square"; //force name
		ggIDnumber = 102;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cSpinningSquare, passedBuf);	
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		selBuffer.rectMode(CENTER);  
		selBuffer.colorMode(HSB, 255);

		if (HoldGenSlider1 == 0)     selBuffer.fill(0, 0, 255);
		else  selBuffer.fill(HoldGenSlider1, 255, 255);

		if (HoldGenSlider2 == 0)     selBuffer.stroke(0, 0, 255);
		else  selBuffer.stroke(HoldGenSlider2, 255, 255);

		selBuffer.strokeWeight(round(HoldGenSlider3/32));           
		selBuffer.background(0);    
		selBuffer.pushMatrix();
		selBuffer.translate(MatrixWidth/2, MatrixHeight/2);
		selBuffer.rotate(radians(TempRotation));
		selBuffer.scale((float)TempScale/100);
		//    selBuffer.rectMode(CENTER);      //Mysteriously stopped working and would only do (CORNERS) so I calculate it below instead
		//    selBuffer.rect(-(HoldGenSlider4/2), -(HoldGenSlider4/2), HoldGenSlider4, HoldGenSlider4);    //switch these two lines for the one below if it is fixed in future Processing Releases
		selBuffer.rect(-(HoldGenSlider4/2)+(HoldGenSlider4/2), -(HoldGenSlider4/2)+(HoldGenSlider4/2), HoldGenSlider4, HoldGenSlider4);
		selBuffer.popMatrix();

		if (ReverseFlag == true) TempRotation+=10;
		else TempRotation-=10;

		if (TempRotation >= 360) TempRotation = 0;
		else if (TempRotation < 0) TempRotation = 360 + TempRotation;

		if (TempScale != ScaleEndPoint) 
		{
			if (ScaleEndPoint > TempScale) TempScale = TempScale + 1;
			else TempScale = TempScale - 1;
		} 
		else if (ScaleEndPoint == TempScale) 
		{
			ScaleEndPoint = PApplet.parseInt(random(0, MatrixWidth*10)); //CHANGERD FROM 200, CHECK!!
		} 
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText


//=============================================================================================================

class ggObjRipples
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	float genCircleX1 = 0; //circle ripple generation
	float genCircleX2 = 0;
	float genCircleX3 = 0;

	public void ggObjRipples()
	{
		ggName = "Ripples"; //force name
		ggIDnumber = 103;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cRipplesLabels, passedBuf);

		genCircleX1 =0.0f;
		genCircleX2 = 0.45f;
		genCircleX3 = 0.95f;
		selBuffer.fill(0, 0, 0, 0); //fill transparent
		selBuffer.ellipseMode(CENTER);
		selBuffer.rectMode(CENTER);    
		selBuffer.stroke(255);
		
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
	//	selBuffer.rectMode(CENTER);       
		selBuffer.strokeWeight(1);
		//end defaults

    selBuffer.background(0);  
    selBuffer.strokeWeight(HoldGenSlider2/32);
        
    if (HoldGenSlider1 <128)  
    {
      selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX1, 25*genCircleX1);      
      selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX2, 25*genCircleX2);           
      selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX3, 25*genCircleX3);
    }
    else 
    {
      selBuffer.rect(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX1, 25*genCircleX1);      
      selBuffer.rect(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX2, 25*genCircleX2);           
      selBuffer.rect(round(MatrixWidth/2), round(MatrixHeight/2), 25*genCircleX3, 25*genCircleX3);
    }

    if (ReverseFlag == false)    
    {
      genCircleX1 +=0.05f;
      genCircleX2 +=0.05f;
      genCircleX3 +=0.05f;
      if (genCircleX1 >= 1) genCircleX1 = 0;
      if (genCircleX2 >= 1) genCircleX2 = 0;
      if (genCircleX3 >= 1) genCircleX3 = 0;
    }
    else
    {
      genCircleX1 -=0.05f;
      genCircleX2 -=0.05f;
      genCircleX3 -=0.05f;
      if (genCircleX1 <= 0) genCircleX1 = 1 + genCircleX1;
      if (genCircleX2 <= 0) genCircleX2 = 1 + genCircleX2;
      if (genCircleX3 <= 0) genCircleX3 = 1 + genCircleX3;
    }



		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjMetaBalls
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int numBlobs = 8; //metaballs
	int blobSize = 100;   //metaballs
	Blob b[] = new Blob[25];//metaballs
	int TempMetalBalls = 0; //metaballs temp

	public void ggObjMetaBalls()
	{
		ggName = "Meta Balls"; //force name
		ggIDnumber = 104;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cMetaBallsLabels, passedBuf);	
		
		for (int i=0; i< 25; i++) { //create blob objects
			b[i] = new Blob(random(MatrixWidth), random(MatrixHeight), random(-1, 1), random(-1, 1));
		}  
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		/* Taken from OpenProcessing.org and modified to suit    
	/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/10275*@* */
		/* !do not delete the line above, required for linking your tweak if you re-upload */
		/**
	* Rick Companje's version of the Metaball demo
	* Heavily insprired by Metaball Demo Effect by luis2048. 
	*/
		float frequency = (float)HoldGenSlider3 / 255;
		numBlobs = round(HoldGenSlider1/10);
		blobSize = round(HoldGenSlider2*10);

		TempMetalBalls++; //variable for the color cycling
		if (TempMetalBalls > 127) TempMetalBalls = 0;

		for (int q=0; q < numBlobs; ++q) {
			b[q].update();
		}

		//colorMode, 0 is color cycle, 1 is white, 2 is red, 3 green, 4 blue, 5 yellow, 6 purple, 7 turquoise,
		int MetaColorMode = round(HoldGenSlider4 / 32);
		int red = 255;
		int green = 255;
		int blue = 255;

		//reduntant other than switching between color cycle and white since all the colors could be done with the color effects
		switch(MetaColorMode)
		{
		case 0:
			red = round(sin(frequency*TempMetalBalls+ 0) * 255);
			green = round(sin(frequency*TempMetalBalls + 2) * 255);
			blue =round(sin(frequency*TempMetalBalls + 4) * 255);   
			break;
		case 1:
			//stays at 255
			break;
		case 2: //red
			red = 255;
			green = 0;
			blue = 0;
			break;  
		case 3: //green
			red = 0;
			green = 255;
			blue = 0;
			break;    
		case 4: //blue
			red = 0;
			green = 0;
			blue = 255;
			break;    
		case 5: //yellow
			red = 255;
			green = 255;
			blue = 0;
			break;  
		case 6: //purple
			red = 255;
			green = 0;
			blue = 255;
			break;   
		case 7: //turquoise
			red = 0;
			green = 255;
			blue = 255;
			break;
		}

		// Output into a buffered image for reuse
		selBuffer.loadPixels();    
		for (int y=0; y<MatrixHeight; y++) {
			for (int x=0; x<MatrixWidth; x++) {
				int m = 1;
				for (int i=0; i < numBlobs; i++) {
					// Increase this number to make your blobs bigger
					m += blobSize/(b[i].bx[x] + b[i].by[y] + 1); //was 20k
				}
				selBuffer.pixels[x+y*MatrixWidth] =color(round((((float)red/255)*(m-x))/2), round((((float)green/255)*(m-x))/2), round((((float)blue/255)*(m-x))/2));
			}
		}
		selBuffer.updatePixels();
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjPlasma
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int[][] waves = new int[1000][3]; // sine waves
	int[] luma = new int[1024]; // brightness curve
	int[][][] pos = new int[3][2][3]; // positions RGB,XY,123
	float[][][] velocity = new float[3][2][3]; // velocity RGB,XY,123
	int[][][] cWaves = new int[300][3][2]; // pos,RGB,XY
	int ix;
	int iy;
	int iz;

	public void ggObjPlasma()
	{
		ggName = "Plasma"; //force name
		ggIDnumber = 105;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);	
		
		/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/7035*@* */
		/* !do not delete the line above, required for linking your tweak if you re-upload */
		// PLASMA - Will Birtchnel 2010

		// randomize positions
		for (ix=0;ix<3;ix++) {
			for (iy=0;iy<2;iy++) {
				for (iz=0;iz<3;iz++) {
					pos[iz][iy][ix]=PApplet.parseInt(random(512));
					velocity[iz][iy][ix]=random(-3, 3);
				}
			}
		}

		// make sine waves
		for (ix=0;ix<100;ix++) {
			waves[ix][0]= (int)(100+ (sin(ix*TWO_PI/MatrixWidth)*100));
			waves[ix][1]= (int)(50+  (sin(ix*2*TWO_PI/MatrixWidth)*50));
			waves[ix][2]= (int)(25+  (sin(ix*3*TWO_PI/MatrixWidth)*25));
		}

		// make luma wave
		for (ix=0;ix<1024;ix++) {
			iy=ix;
			while ( (iy>255)||(iy<0)) {
				if (iy>255) iy=511-iy;
				if (iy<0) iy=abs(iy);
			}
			if (iy>201) iy=((iy*4)-(201*3));
			iy=(int)((iy*255)/((255*4)-(201*3)));
			luma[ix]=iy;
		}	
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		// PLASMA - Will Birtchnel 2010
		//From http://www.openprocessing.org/sketch/7035
		// update velocity
		for (ix=0;ix<3;ix++) {
			for (iy=0;iy<2;iy++) {
				for (iz=0;iz<3;iz++) {
					velocity[iz][iy][ix]+=random(-0.1f, 0.1f); 
					if (velocity[iz][iy][ix]>(3-ix)) velocity[iz][iy][ix]=(3-ix);
					if (velocity[iz][iy][ix]<(-3+ix)) velocity[iz][iy][ix]=(-3+ix);
				}
			}
		} 
		// update positions
		for (ix=0;ix<3;ix++) {
			for (iy=0;iy<2;iy++) {
				for (iz=0;iz<3;iz++) {
					pos[iz][iy][ix]+=PApplet.parseInt(velocity[iz][iy][ix]); 
					if (pos[iz][iy][ix]>=MatrixWidth) pos[iz][iy][ix]-=MatrixWidth*2;
					if (pos[iz][iy][ix]<0) pos[iz][iy][ix]+=MatrixWidth*2;
				}
			}
		}   
		// make composite waves
		for (ix=0;ix<MatrixWidth;ix++) {  
			for (iy=0;iy<3;iy++) {
				for (iz=0;iz<2;iz++) {
					cWaves[ix][iy][iz]= waves[ix+pos[iy][iz][0]][0]  + waves[ix+pos[iy][iz][1]][1] + waves[ix+pos[iy][iz][2]][2];
				}
			}
		}
		//draw pixels
		selBuffer.loadPixels();
		for (iy = 0; iy < MatrixHeight; iy++) {
			int xOff=iy*MatrixWidth;
			for (ix = 0; ix < MatrixWidth; ix++) {       
				selBuffer.pixels[xOff+ix]=(luma[cWaves[ix][0][0]+cWaves[iy][0][1]]<<16)+(luma[cWaves[ix][1][0]+cWaves[iy][1][1]]<<8)+luma[cWaves[ix][2][0]+cWaves[iy][2][1]];
			}
			selBuffer.updatePixels();
		}
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjSpiral
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	float rotation;// = 0; //for spiral
	float hue;//=0; //for spiral coloring
	//float FadeOutFactor;// = 0;


	public void ggObjSpiral()
	{
		ggName = "Spiral"; //force name
		ggIDnumber = 106;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cSpiralLabels, passedBuf);
		selBuffer.colorMode(HSB, 100);
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		// Learning Processing - Daniel Shiffman
		// http://www.learningprocessing.com
		// Exercise 13-5: Using Example 13-5, draw a spiral path.   
		int chord = 1;  //spacing between LEDs
		float thetaMax = round((HoldGenSlider1/25) * 2 * PI); //up to 10 coils
		float awayStep = 0; 
		int LocalColorMode = round((HoldGenSlider3/84)); //0 - 3
		float SpiralFadeOutFactor = (float)HoldGenSlider4 / 255;

		DecayBuffer(SpiralFadeOutFactor, selBuffer); //run Decay Function
		selBuffer.colorMode(RGB, 255);
		selBuffer.colorMode(HSB, 100);
		selBuffer.strokeWeight(1);

		if (MatrixWidth > MatrixHeight)  awayStep = (MatrixWidth/2) / thetaMax;
		else awayStep = (MatrixHeight/2) / thetaMax;

		for (float theta = chord / awayStep; theta <= thetaMax; ) 
		{
			float away = awayStep * theta;    // How far away from center
			float around = theta + rotation;    // How far around the center.
			// Convert 'around' and 'away' to X and Y.
			int xpos = (int)round((MatrixWidth/2) + cos( around ) * away);
			int ypos = (int)round((MatrixHeight/2) + sin( around ) * away);

			switch(LocalColorMode) 
			{
			default:// 0 or 3 or 4 
				selBuffer.stroke(0, 0, 100); //HSB color white
				break;
			case 1:
				selBuffer.stroke(hue, 100, 100);  //use hue    
				break;
			case 2:
				hue+=(float)HoldGenSlider2 / 64;
				if (hue>=100) {
					hue=hue-100;
				}    
				selBuffer.stroke(hue, 100, 100);  //use hue    
				break;
			}
			selBuffer.point(xpos, ypos); 
			theta += chord / away;
		}//end for()

		if (LocalColorMode == 1)
		{
			hue+=(float)HoldGenSlider2 / 64; //cycle through
			if (hue>=100) {
				hue=hue-100;
			}
		}
		else if (LocalColorMode == 2)  hue=0; //reset if in colormode offset

		if (ReverseFlag == true) rotation += 0.5f; //rotate spiral
		else rotation -= 0.5f; //rotate spiral
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjFallingBlocks
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method
	int[] fallingBlocksArray;// = new int[1]; //for falling blocks
	float FallingBlocksFadeOutFactor;


	public void ggObjFallingBlocks()
	{
		ggName = "Falling Blocks"; //force name
		ggIDnumber = 109;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cFallingBlocks, passedBuf);

		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.fill(255);  
		selBuffer.stroke(255);   


		fallingBlocksArray = new int[MatrixHeight];


		//randomly fill stating up to MatrixHeight
		for (int i = 0; i != MatrixWidth; i++)   fallingBlocksArray[i] = (int)random(0, MatrixHeight);
	} //end ggInitilaize()


	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		FallingBlocksFadeOutFactor = (float)HoldGenSlider3 / 255; //calculates the decay factor
		DecayBuffer(FallingBlocksFadeOutFactor, selBuffer); //run Decay Function

//println("===="+MatrixHeight+" : "+MatrixWidth

		if (ReverseFlag == true)
		{
			if ((HoldGenSlider4/128) == 0)
			{ //fall Up
				for (int i = 0;i != MatrixWidth; i++)   
				{
					fallingBlocksArray[i]--;
					if (fallingBlocksArray[i] < 0) fallingBlocksArray[i] =  (int)random((HoldGenSlider2*2)+MatrixHeight, MatrixHeight+1);
					selBuffer.rect(i, fallingBlocksArray[i], HoldGenSlider1/16, HoldGenSlider1/16);
				} //end for()
			} //end if()
			else
			{ //fall to the left
				for (int i = 0;i != MatrixHeight; i++) 
				{
					fallingBlocksArray[i]--;
					if (fallingBlocksArray[i] < 0) fallingBlocksArray[i] =  (int)random((HoldGenSlider2*2), MatrixWidth-1);
					selBuffer.rect(fallingBlocksArray[i], i, HoldGenSlider1/16, HoldGenSlider1/16);
				} //end for()
			}//end else
		} //end reverse if()
		else
		{ 
			if ((HoldGenSlider4/128) == 0)
			{ //Fall down
				for (int i = 0;i != MatrixWidth; i++) 
				{
					fallingBlocksArray[i]++;
					if (fallingBlocksArray[i] > MatrixHeight) fallingBlocksArray[i] =  (int)random(-(HoldGenSlider2*2), -1);
					selBuffer.rect(i, fallingBlocksArray[i], HoldGenSlider1/16, HoldGenSlider1/16);
				} //for()
			}
			else
			{ //fall to the right
				for (int i = 0;i != MatrixHeight; i++) 
				{
					fallingBlocksArray[i]++;
					if (fallingBlocksArray[i] > MatrixWidth) fallingBlocksArray[i] =  (int)random(-(HoldGenSlider2*2), -1);
					selBuffer.rect(fallingBlocksArray[i], i, HoldGenSlider1/16, HoldGenSlider1/16);
				} //for()
			}
		}  
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjTestStepThrough
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;

	//added for this gen method

	public void ggObjTestStepThrough()
	{
		ggName = "Test Step Through"; //force name
		ggIDnumber = 123;
	}

	public void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);

		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.fill(255);  
		StepThroughVar = 0;
	} //end ggInitilaize()

	public void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		selBuffer.background(0);
		selBuffer.set(PatchCoordX[StepThroughVar], PatchCoordY[StepThroughVar], color(255));
		selBuffer.endDraw();	 	
	} //end ggFillBuffer()
} //end genGraphicText
public void mouseReleased()
{
  GlobalDragging = false;
  //  for (int i=0; i != FeedAButtons.length;i++)  FeedAButtons[i].display();
  //  for (int i=0; i != FeedBButtons.length;i++)  FeedBButtons[i].display();   
  if (OpenMenuID == 0)
  {
    for (int i=0; i != CommonButtons.length;i++)  CommonButtons[i].display();
    for (int i=0; i != BlendButtons.length;i++)  BlendButtons[i].display();   

    FeedAButtons[12].display();
    FeedAButtons[13].display();    
    FeedBButtons[12].display();
    FeedBButtons[13].display();
  }
  if(OpenMenuID == 2) GUIMenus[2].display();
}

public void keyPressed()
{
  if (key == 'r') UpdateWorkspace = true;
  
  if (key == 'x') 
  {
   StepThroughVar++;
    if(StepThroughVar >= MaxPixels) 
    {
      println("Reset");
    StepThroughVar = 0;
    }  
  }


  if (key == CODED) 
  {
    switch(keyCode)
    {
    case UP:
//      println("Up on "+SliderPointer);
      SliderPointer.Value--;
      SliderPointer.setValue(SliderPointer.Value);
      break;

    case DOWN:
//      println("Down on "+SliderPointer); 
      SliderPointer.Value++;    
      SliderPointer.setValue(SliderPointer.Value);
      break;
    case RIGHT:
//      println("Right on "+SliderPointer);
      SliderPointer.Value++;
      SliderPointer.setValue(SliderPointer.Value);
      break;

    case LEFT:
//      println("Left on "+SliderPointer); 
      SliderPointer.Value--;    
      SliderPointer.setValue(SliderPointer.Value);
      break;
    }
    HandleSliders(false); //false means don't use mouse location for move()
  }


}//end keyPressed()

public void mousePressed()
{
  if (mouseButton == RIGHT) println("X: "+mouseX+" - Y: "+mouseY); 

  //This has to be first since the Common buttons can be pressed regardless of menu states
  for (int i=7; i != CommonButtons.length;i++)
  {
    if (CommonButtons[i].over())
    {
      HandleCommonButtons(i);
    }//end over() if
  }//end for() 

  if (OpenMenuID != 0)
  {
    for (int i=1; i != GUIMenus.length;i++) 
    {
      if (GUIMenus[i].over() && i == OpenMenuID)
      {
        println("This "+i+" has been pressed");

        switch(i)
        {
        case 1: //offset Menu
          for (int x=0; x != OffsetButtons.length;x++) 
          {
            if (OffsetButtons[x].over())
            {
              if (FeedFlag == true) //A
              {
                switch(x)
                {
                  //These all should reference the object
                case 0: //up
                  QuickFeeds[FeedASelQuick].OffsetY++; 
                  break;
                case 1: //down
                  QuickFeeds[FeedASelQuick].OffsetY--; 
                  break;              
                case 2: //right
                  QuickFeeds[FeedASelQuick].OffsetX--;
                  break;            
                case 3: //left
                  QuickFeeds[FeedASelQuick].OffsetX++;
                  break;    
                case 4: //reset
                  QuickFeeds[FeedASelQuick].OffsetY = 0;
                  QuickFeeds[FeedASelQuick].OffsetX = 0;  
                  break;
                }//end switch
              }//end if
              else
              {
                switch(x)
                {
                case 0:
                  QuickFeeds[FeedBSelQuick].OffsetY++; 
                  break;
                case 1: //down
                  QuickFeeds[FeedBSelQuick].OffsetY--; 
                  break;              
                case 2: //right
                  QuickFeeds[FeedBSelQuick].OffsetX--;
                  break;            
                case 3: //left
                  QuickFeeds[FeedBSelQuick].OffsetX++;
                  break;    
                case 4: //reset
                  QuickFeeds[FeedBSelQuick].OffsetY = 0;
                  QuickFeeds[FeedBSelQuick].OffsetX = 0; 
                  break;
                }//end switch
              }//end else
              return; //don't check for anything else
            } //end offset over()
          }//end for
          break;        
        case 2: //Main Menu

        for (int q=0; q != MainMenuButtons.length;q++)
          {
            if (MainMenuButtons[q].over())
            {
              if(q > 5 && q != 10)
             {
             MainMenuButtons[6].Selected = false;
             MainMenuButtons[6].display();
             MainMenuButtons[7].Selected = false; 
             MainMenuButtons[7].display();             
             MainMenuButtons[8].Selected = false;   
             MainMenuButtons[8].display();             
             MainMenuButtons[9].Selected = false;               
             MainMenuButtons[9].display();
             }              
              
              MainMenuButtons[q].Selected =! MainMenuButtons[q].Selected;
              MainMenuButtons[q].display();
              
              switch(q)
              {
                case 0: // Save to config
                //currently not needed since most configuration settings can't be changed in software, do it in a text editor
                LoadFileMethod = 1;
                //selectOutput("Select a Device INI file to Save To:", "fileSelected");
                break;
                case 1: // Load Config File
                LoadFileMethod = 2;
                //selectInput("Select a Device Config file to Load:", "fileSelected");
                break;
                case 2: // Enable Serial Control
                Matrix.softwareSerialConEnable = MainMenuButtons[q].Selected;
                break;              
                case 3: // Enable DShow     
                Matrix.softwareEnableDSVideoFeed = MainMenuButtons[q].Selected;      
                break;         
                case 4: // Large Previews
                Matrix.softwareLrgPreviewEnable = MainMenuButtons[q].Selected;                      
                break;                       
                case 5: // Enable Midi     
                Matrix.softwareMIDIenable = MainMenuButtons[q].Selected;
                if(Matrix.softwareMIDIenable == true)
                {
               InitializeMIDI(true);
               InitializeMIDI(false);      
               GUIMenus[OpenMenuID].display();
                }             
                break;
                // Communication Types
                case 6: // None     
                CommunicationType = 0;
                OpenConnection();
                break;         
                 case 7: //Serial     
                CommunicationType = 1; 
                OpenConnection();
                break;
                case 8: //TCP
                CommunicationType = 3;
                OpenConnection();
                break;        
                case 9: //UDP
                CommunicationType = 2;
                OpenConnection();
                break;   
                case 10: //EULA
                link("http://creativecommons.org/licenses/by/4.0/legalcode");
                break;     
               case 11: //Rebuild Thumbnails
                BuildAndSaveThumbnails();
                break;                   
              }                
            }//end over() if
          }//end for()        
        
        //===============================================================================
        
          println(GUIMenus[2].xpos+" : "+GUIMenus[2].ypos);
          if (round(mouseX / SF) >=  GUIMenus[2].xpos+320 && round(mouseX / SF) <= GUIMenus[2].xpos+400)
          {
            if (round(mouseY / SF) >= GUIMenus[2].ypos+85  && round(mouseY / SF) <= GUIMenus[2].ypos+100) 
            {    
              println("At least here 1 ");
              surface.setSize(640, 480+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+100  && round(mouseY / SF) <= GUIMenus[2].ypos+115) 
            {    
              println("At least here 2");
              surface.setSize(800, 600+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+115  && round(mouseY / SF) <= GUIMenus[2].ypos+130) 
            {    
              println("At least here 3");
              surface.setSize(1024, 768+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+130  && round(mouseY / SF) <= GUIMenus[2].ypos+145) 
            {    
              println("At least here 4");
              surface.setSize(1400, 1050+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+145  && round(mouseY / SF) <= GUIMenus[2].ypos+160) 
            {    
              println("At least here 5");
              launch("data/config.ini");
            }
          }
          break;
        case 3: //Configure Menu

          break;
        case 4: //Gen Menu  A
          for (int q = 0; q !=GenerationSliders.length;q++) 
          {
            if (GenerationSliders[q].over())
            {
              println("Selected "+q);
              SelectedSlider = q;
              GenerationSliders[q].selectSlider();
            }
          }
          break;
        case 5: //Gen Menu  B
          for (int q = 0; q !=GenerationSliders.length;q++) 
          {
            if (GenerationSliders[q].over())
            {
              println("Selected "+q);
              SelectedSlider = q;
              GenerationSliders[q].selectSlider();
            }
          }        
          break;
        }//end i switch
      } //end if
    }//end for
    
    
        if(FeedAButtons[8].over() && OpenMenuID == 1)
        {
          println("Pressed Offset Button on FeedA");
          FeedAButtons[8].Selected = false;
          OpenMenuID = 0;   
          UpdateWorkspace = true;
        }

        
         if(FeedBButtons[8].over() && OpenMenuID == 1)
        {
          println("Pressed Offset Button on FeedB");          
          FeedBButtons[8].Selected = false;
          OpenMenuID = 0;   
          UpdateWorkspace = true;        
        }      
    
    return; //prevent any buttons that are not focused from being clicked
  }//end if

  //=============== END GUI START BUTTONS ==============================
  for (int i=0; i != FeedAButtons.length;i++)
  {
    if (FeedAButtons[i].over())
    {
      HandleFeedAButtons(i);
    }
  }
  //=============== END FEED A ========  START COMMON ==============
  for (int i=0; i != FeedBButtons.length;i++)
  {
    if (FeedBButtons[i].over())
    {
      HandleFeedBButtons(i);
    } //end over if()
  }
  //====================== END FEED B ====================================== 
  for (int i=0; i !=BlendButtons.length;i++)
  {
    if (BlendButtons[i].over())
    {
      HandleBlendButtons(i);
    }//end over() if
  }//end for() 
  //============================================================ 


  for (int i=0; i != 7;i++)
  {
    if (CommonButtons[i].over())
    {
      HandleCommonButtons(i);
    }//end over() if
  }//end for() 

  //============== QUICK FEED BUTTONS =================================================

  for (int i=0; i != QuickAButtons.length;i++)
  {
    if (QuickAButtons[i].over() && FeedAQuickPage == 0 && i < 15)  HandleQuickAButtons(i);
    else if (QuickAButtons[i].over() && FeedAQuickPage == 1 && i > 14 && i < 30) HandleQuickAButtons(i);
    else if (QuickAButtons[i].over() && FeedAQuickPage == 2 && i > 29 && i < 45) HandleQuickAButtons(i);
    else if (QuickAButtons[i].over() && FeedAQuickPage == 3 && i > 44 && i < 60) HandleQuickAButtons(i);
  }//end for

  for (int i=0; i != QuickBButtons.length;i++)
  {
    if (QuickBButtons[i].over() && FeedBQuickPage == 0 && i < 15)  HandleQuickBButtons(i);
    else if (QuickBButtons[i].over() && FeedBQuickPage == 1 && i > 14 && i < 30) HandleQuickBButtons(i);
    else if (QuickBButtons[i].over() && FeedBQuickPage == 2 && i > 29 && i < 45) HandleQuickBButtons(i);
    else if (QuickBButtons[i].over() && FeedBQuickPage == 3 && i > 44 && i < 60) HandleQuickBButtons(i);
  }//end for()

  //============ START SLIDERS ================================

  for (int i=0; i != CommonSliders.length;i++)
  {
    if (CommonSliders[i].over())
    {
      SelectedSlider = i;
      CommonSliders[i].selectSlider();
    }
  }//end for

  if (MainMixerSlider.over())
  {   
    SelectedSlider = 0;
    MainMixerSlider.selectSlider();
  }

  if (IntensitySliderA.over())
  {   
    SelectedSlider = 0;
    IntensitySliderA.selectSlider();
  }
  
  if (IntensitySliderB.over())
  {   
    SelectedSlider = 0;
    IntensitySliderB.selectSlider();
  }
}//end func

//================================= START BUTTON HANDLERS =================================

public void HandleSliders(boolean bMoveEnable)
{
  //println("Dragging "+SliderPointer.SetNumber);
  int mX = round((float)mouseX / SF);
  int mY = round((float)mouseY / SF);     

  if (bMoveEnable == true)
  {
    //when doing a mousewheel or arrow key don't want it to move()
    SliderPointer.move(mX, mY);
  }
  else GlobalDragging = false;
  
   SliderPointer.display(); //moved from here since some sliders draw to different buffer
  
  switch(SliderPointer.SetNumber)
  {
  case 0: //mixer
    MixerValue = (float)MainMixerSlider.Value / 100;  
    break;
  case 1: //intensityA
    IntensityValueA = (float)IntensitySliderA.Value / 100;  
    if (LockIntensity == true) 
    {
      IntensityValueB = (float)IntensitySliderA.Value / 100;  
      IntensitySliderB.Value = IntensitySliderA.Value;
      IntensitySliderB.display();  //display new position
    }
    break;
  case 2: //intensityB
    IntensityValueB = (float)IntensitySliderB.Value / 100;  
    if (LockIntensity == true)
    {
      IntensityValueA = (float)IntensitySliderB.Value / 100;  
      IntensitySliderA.Value = IntensitySliderB.Value;
      IntensitySliderA.display();  //display new position
    }
    break;     
    
  case 3: //CommonButtons
    switch(SelectedSlider)
    {
      case 0: //FeedA Red
        QuickFeeds[FeedASelQuick].SliderRed = CommonSliders[SelectedSlider].Value;
      break;
      case 1: //FeedA Green
        QuickFeeds[FeedASelQuick].SliderGreen= CommonSliders[SelectedSlider].Value;
      break;   
      case 2: //FeedA Blue
        QuickFeeds[FeedASelQuick].SliderBlue = CommonSliders[SelectedSlider].Value;
      break;      
      case 3:
        QuickFeeds[FeedBSelQuick].SliderRed = CommonSliders[SelectedSlider].Value;
        break;   
      case 4:
        QuickFeeds[FeedBSelQuick].SliderGreen = CommonSliders[SelectedSlider].Value;
        break;  
      case 5:
        QuickFeeds[FeedBSelQuick].SliderBlue = CommonSliders[SelectedSlider].Value;
        break;
      case 6:
      println("This handled");
          try {
            if (QuickFeeds[FeedASelQuick].Speed < 0) myMovieA.speed(0.1f); //prevents the movie object from going in reverse or 0
            else myMovieA.speed(QuickFeeds[FeedASelQuick].Speed);
          }
          catch(Exception e) {
          }   
          QuickFeeds[FeedASelQuick].Speed = (((float)CommonSliders[6].Value-100) /10);
          RedrawSpeeds();
        break;
      case 7://handle SpeedB
        QuickFeeds[FeedBSelQuick].Speed = (((float)CommonSliders[7].Value-100) / 10);
        try {
          if (QuickFeeds[FeedBSelQuick].Speed < 0) myMovieB.speed(0.1f);  //prevents the movie object from going in reverse or 0
          else myMovieB.speed(QuickFeeds[FeedBSelQuick].Speed);
        }
        catch(Exception e) {
        } //if no Movie object is there, then nothing happens as the other methods read Quckfeeds[].Speed 
        QuickFeeds[FeedBSelQuick].Speed = (((float)CommonSliders[7].Value-100) /10);    
        RedrawSpeeds();
        break;          
      case 8: //contrast Feed A   
        QuickFeeds[FeedASelQuick].ContrastValue = CommonSliders[SelectedSlider].Value;
        break;
      case 9: //contrast Feed B   
        QuickFeeds[FeedBSelQuick].ContrastValue = CommonSliders[SelectedSlider].Value;
        break;      
    } //end switch
    break;
  case 4: 
    //move the slider values into their respective QuickFeed Object variable
    if (FeedFlag == true) //A, set when the button is pressed to open the menu
    {
      QuickFeeds[FeedASelQuick].GenSlider1 = GenerationSliders[0].Value;
      QuickFeeds[FeedASelQuick].GenSlider2 = GenerationSliders[1].Value;
      QuickFeeds[FeedASelQuick].GenSlider3 = GenerationSliders[2].Value;
      QuickFeeds[FeedASelQuick].GenSlider4 = GenerationSliders[3].Value;
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      QuickFeeds[FeedBSelQuick].GenSlider1 = GenerationSliders[0].Value;
      QuickFeeds[FeedBSelQuick].GenSlider2 = GenerationSliders[1].Value;
      QuickFeeds[FeedBSelQuick].GenSlider3 = GenerationSliders[2].Value;
      QuickFeeds[FeedBSelQuick].GenSlider4 = GenerationSliders[3].Value;
      GUIMenus[OpenMenuID].display();      
    }
    break;
  }//end switch()
} //end func

//========================== END HANDLE SLIDERS =========================================

public void HandleBlendButtons(int PassedID)
{
  println("Blend Button: "+PassedID);  
  //unselects all buttons then sets the pressed one
  for (int y=0; y != BlendButtons.length;y++)  BlendButtons[y].Selected = false;
  BlendButtons[PassedID].Selected =! BlendButtons[PassedID].Selected;
  BlendingMode = PassedID;
  for (int i=0; i != BlendButtons.length;i++)  BlendButtons[i].display();
}

public void HandleCommonButtons(int PassedID)
{
  int i = PassedID;
  println("HandleCommonButtons() "+i);

  CommonButtons[i].Selected =! CommonButtons[i].Selected;
  CommonButtons[i].display();   

  switch(i)
  {
  case 0://A
    MainMixerSlider.Value = 0;
    MixerValue = (float)MainMixerSlider.Value / 100;     
    MainMixerSlider.display();    
    break;        
  case 1: //B
    MainMixerSlider.Value = 100;    
    MixerValue = (float)MainMixerSlider.Value / 100;          
    MainMixerSlider.display();
    break;   
  case 2: //AutoFade
    AutoSequenceRunning = true;
    TransitionFlag = true;
    if (MixerValue > 0.5f) FeedID = true;
    else FeedID = false;
    BlendSpeed = cDefaultAutoFadeSpeed;
    break;    
  case 3: //Enable Automatic Mode
    if (CommonButtons[i].Selected == true)
    {
      AutoSequenceRunning = true;
      AutomaticMode = true;
      LoadAutoFile();
    }
    else
    {
      AutoSequenceRunning = false; 
      AutomaticMode = false;
    }
    break;    
  case 4: //Lock Intensity
    if (CommonButtons[i].Selected == true) LockIntensity = true;
    else  LockIntensity = false;
    break;         
  case 5: //save QuickFeeds
    SaveQuickFeedsFile();
    break;  
  case 6: //Load QuickFeeds
    LoadQuickFeedsFile();
    break;
  case 7: //open Main Menu
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[8].Selected = false;
      CommonButtons[8].display();          
      GUIMenus[OpenMenuID].Opened = false;       
      OpenMenuID = 2;
      GUIMenus[OpenMenuID].Opened = true;     
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[2].Opened = false;    
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }
    break;
  case 8: //Configure Menu
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[7].Selected = false;
      CommonButtons[7].display();    
      GUIMenus[OpenMenuID].Opened = false; 
      OpenMenuID = 3;
      GUIMenus[OpenMenuID].Opened = true;    
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[3].Opened = false; 
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }  
    break;    
  case 9: //Gen Menu A
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[10].Selected = false;
      CommonButtons[10].display();    
      FeedFlag = true; //A
      GenerationSliders[0].Value =  QuickFeeds[FeedASelQuick].GenSlider1; //initialize the slider values with the saved values
      GenerationSliders[1].Value =  QuickFeeds[FeedASelQuick].GenSlider2; //initialize the slider values with the saved values
      GenerationSliders[2].Value =  QuickFeeds[FeedASelQuick].GenSlider3; //initialize the slider values with the saved values
      GenerationSliders[3].Value =  QuickFeeds[FeedASelQuick].GenSlider4; //initialize the slider values with the saved values  

      GUIMenus[OpenMenuID].Opened = false; 
      OpenMenuID = 4;
      GUIMenus[OpenMenuID].Toggle();
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[OpenMenuID].Toggle();
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }  
    break;       
  case 10: //Gen Menu B
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[9].Selected = false;
      CommonButtons[9].display();
      FeedFlag = false; //B
      GenerationSliders[0].Value =  QuickFeeds[FeedBSelQuick].GenSlider1; //initialize the slider values with the saved values
      GenerationSliders[1].Value =  QuickFeeds[FeedBSelQuick].GenSlider2; //initialize the slider values with the saved values
      GenerationSliders[2].Value =  QuickFeeds[FeedBSelQuick].GenSlider3; //initialize the slider values with the saved values
      GenerationSliders[3].Value =  QuickFeeds[FeedBSelQuick].GenSlider4; //initialize the slider values with the saved values            

      GUIMenus[OpenMenuID].Opened = false; 
      OpenMenuID = 5;
      GUIMenus[OpenMenuID].Toggle();
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[OpenMenuID].Toggle();      
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }    
    break;
  }//end switch
}//end func


public void HandleQuickAButtons(int PassedID)
{
  println("HandleQuickAButtons Pressed: "+PassedID);
  int i = PassedID;
  //check, highlight and display the preview
  if (QuickAButtons[i].Focused == false && QuickAButtons[i].Selected == false && AutomaticMode == false && Matrix.softwareLrgPreviewEnable == true)
  {
    //will highlight and open the full size preview 
    QuickAButtons[PrevFocusA].Focused = false;
    QuickAButtons[PrevFocusA].displaySq(PrevFocusA);  

    QuickAButtons[i].Focused = true;
    QuickAButtons[i].displaySq(i);
    PrevFocusA = i;
    PreviewQuickFeed(i);
    return;
  }
  //else it will select the quickfeed normally

  DisplayPreview = false;
  QuickAButtons[FeedASelQuick].Selected = false;  
  QuickAButtons[FeedASelQuick].Focused = false;  
//  QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick); //display previously selected button as unselected
    //don't want to display when its not on the page
    if (FeedAQuickPage == 0 && FeedASelQuick < 15)  QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);
    else if ( FeedAQuickPage == 1 && FeedASelQuick > 14 && FeedASelQuick < 30) QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);
    else if (FeedAQuickPage == 2 && FeedASelQuick > 29 && FeedASelQuick < 45) QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);
    else if ( FeedAQuickPage == 3 && FeedASelQuick > 44 && FeedASelQuick < 60) QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);

  //save slider values before switching QuickFeeds
  QuickFeeds[FeedASelQuick].SliderRed = CommonSliders[0].Value;
  QuickFeeds[FeedASelQuick].SliderGreen = CommonSliders[1].Value;
  QuickFeeds[FeedASelQuick].SliderBlue = CommonSliders[2].Value;
  QuickFeeds[FeedASelQuick].ContrastValue = CommonSliders[8].Value;

  FeedASelQuick = i;
  QuickAButtons[FeedASelQuick].Selected = true;
  QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick); //highlight recently selected button

  LoadQuickFeed(myMovieA, QuickFeeds[FeedASelQuick]);
}


public void HandleQuickBButtons(int PassedID)
{
  println("QuickFeedB Pressed: "+PassedID);
  int i = PassedID;
  //check, highlight and display the preview
  if (QuickBButtons[i].Focused == false && QuickBButtons[i].Selected == false && AutomaticMode == false && Matrix.softwareLrgPreviewEnable == true)
  {
    //will highlight and open the full size preview 
    QuickBButtons[PrevFocusB].Focused = false;
    QuickBButtons[PrevFocusB].displaySq(PrevFocusB);  
    QuickBButtons[i].Focused = true;
    QuickBButtons[i].displaySq(i);
    PrevFocusB = i;
    PreviewQuickFeed(i);
    return;
  }
  //else it will select the quickfeed normally

  DisplayPreview = false;
  QuickBButtons[FeedBSelQuick].Selected = false;  
  QuickBButtons[FeedBSelQuick].Focused = false;  
//  QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick); //display previously selected button as unselected
    //don't want to display when its not on the page
    if (FeedBQuickPage == 0 && FeedBSelQuick < 15)  QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);
    else if ( FeedBQuickPage == 1 && FeedBSelQuick > 14 && FeedBSelQuick < 30) QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);
    else if (FeedBQuickPage == 2 && FeedBSelQuick > 29 && FeedBSelQuick < 45) QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);
    else if ( FeedBQuickPage == 3 && FeedBSelQuick > 44 && FeedBSelQuick < 60) QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);

  //save slider values before switching QuickFeeds
  QuickFeeds[FeedBSelQuick].SliderRed = CommonSliders[3].Value;
  QuickFeeds[FeedBSelQuick].SliderGreen = CommonSliders[4].Value;
  QuickFeeds[FeedBSelQuick].SliderBlue = CommonSliders[5].Value;
  QuickFeeds[FeedBSelQuick].ContrastValue = CommonSliders[9].Value;

  FeedBSelQuick = i;
  QuickBButtons[FeedBSelQuick].Selected = true;
  QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick); //highlight recently selected button

  LoadQuickFeed(myMovieB, QuickFeeds[FeedBSelQuick]);
}

//======================================================================================

public void HandleFeedAButtons(int PassedID)
{
  int i = PassedID; //move passedID into i, since it was already written using i
  FeedAButtons[i].Selected =! FeedAButtons[i].Selected;
  FeedAButtons[i].display();   
  println("FeedA Button: "+i);

  switch(i)
  {
  case 0://Play
    QuickFeeds[FeedASelQuick].ControlState = 0;        
    SetControlStateFunc(myMovieA, FeedAButtons, QuickFeeds[FeedASelQuick].ControlState);            
    break;
  case 1: //Pause
    QuickFeeds[FeedASelQuick].ControlState = 1;              
    SetControlStateFunc(myMovieA, FeedAButtons, QuickFeeds[FeedASelQuick].ControlState);            
    break;
  case 2: //Stop
    QuickFeeds[FeedASelQuick].ControlState = 2;               
    SetControlStateFunc(myMovieA, FeedAButtons, QuickFeeds[FeedASelQuick].ControlState);            
    break;
  case 3: //Load File
    LoadFileMethod = 0;
    FeedFlag = true; //A
    selectInput("Select a file to process:", "fileSelected");
    break; 
  case 4: //reset speed
 	FeedAButtons[i].Selected = false;
	FeedAButtons[i].display();   

  SetControlStateFunc(myMovieA, FeedAButtons, 0); 
  SetEffectStateFunc(FeedAButtons, 0);  
  QuickFeeds[FeedASelQuick].ColorState = 0;  
  SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState);  
  
  
    CommonSliders[6].Value = cDefaultSpeed;  
    HandleSliders(false); //handle SpeedA
	SliderPointer = CommonSliders[6];
    break;        
  case 5: //invert
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedAButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 2) QuickFeeds[FeedASelQuick].EffectState = 3;
      else  QuickFeeds[FeedASelQuick].EffectState = 1;
    }
    else 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 2 || QuickFeeds[FeedASelQuick].EffectState == 3) QuickFeeds[FeedASelQuick].EffectState = 2; 
      else QuickFeeds[FeedASelQuick].EffectState = 0;
    } 
    break;  
  case 6: //tint
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 1;
      CommonSliders[0].Value = 0; //intialize color sliders
      CommonSliders[1].Value = 0;
      CommonSliders[2].Value = 0; 
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    else QuickFeeds[FeedASelQuick].ColorState = 0;  
    break;     
  case 7://color max
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 2;
      CommonSliders[0].Value = 255; //intialize color sliders
      CommonSliders[1].Value = 255;
      CommonSliders[2].Value = 255;   
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    else QuickFeeds[FeedASelQuick].ColorState = 0;
    break; 
  case 8: //offset
    FeedFlag = true; //A
    if (FeedAButtons[8].Selected == true)  OpenMenuID = 1;
    else OpenMenuID = 0;
    break;
  case 9: //Color Scale
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 3;
      CommonSliders[0].Value = 255; //intialize color sliders
      CommonSliders[1].Value = 255;
      CommonSliders[2].Value = 255;   
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    else QuickFeeds[FeedASelQuick].ColorState = 0;
    break;     
  case 10: //Color Min
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 4;
      CommonSliders[0].Value = 0; //intialize color sliders
      CommonSliders[1].Value = 0;
      CommonSliders[2].Value = 0; 
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    break;       
  case 11: //Contrast
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedAButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 1) QuickFeeds[FeedASelQuick].EffectState = 3;
      else  QuickFeeds[FeedASelQuick].EffectState = 2;
    }
    else 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 1 || QuickFeeds[FeedASelQuick].EffectState == 3) QuickFeeds[FeedASelQuick].EffectState = 1; 
      else QuickFeeds[FeedASelQuick].EffectState = 0;
    }
    break;      
  case 12: //Pg Up
    if (FeedAQuickPage == 3) FeedAQuickPage = 0;
    else FeedAQuickPage++;
    for (int x=0; x != 15;x++)   QuickAButtons[x+(FeedAQuickPage*15)].displaySq(x+(FeedAQuickPage*15));
    break;   
  case 13: //Pg Down
    if (FeedAQuickPage == 0) FeedAQuickPage = 3;
    else FeedAQuickPage--;  
    for (int x=0; x != 15;x++)   QuickAButtons[x+(FeedAQuickPage*15)].displaySq(x+(FeedAQuickPage*15));
    break;
  } //end switch
}//end func

//======================================================================================

public void HandleFeedBButtons(int PassedID)
{
  int i = PassedID; //move passedID into i, since it was already written using i
  FeedBButtons[i].Selected =! FeedBButtons[i].Selected;
  FeedBButtons[i].display();   
  println("FeedB Button: "+i);

  switch(i)
  {
  case 0://Play
    QuickFeeds[FeedBSelQuick].ControlState = 0;        
    SetControlStateFunc(myMovieB, FeedBButtons, QuickFeeds[FeedBSelQuick].ControlState);            
    break;
  case 1: //Pause
    QuickFeeds[FeedBSelQuick].ControlState = 1;              
    SetControlStateFunc(myMovieB, FeedBButtons, QuickFeeds[FeedBSelQuick].ControlState);            
    break;
  case 2: //Stop
    QuickFeeds[FeedBSelQuick].ControlState = 2;               
    SetControlStateFunc(myMovieB, FeedBButtons, QuickFeeds[FeedBSelQuick].ControlState);            
    break;
  case 3: //Load File
    LoadFileMethod = 0;
    FeedFlag = false; //B
    selectInput("Select a file to process:", "fileSelected");
    break; 
  case 4: //reset speed
  	FeedBButtons[i].Selected = false;
	FeedBButtons[i].display();   
	
  SetControlStateFunc(myMovieB, FeedBButtons, 0); 
  SetEffectStateFunc(FeedBButtons, 0);  
  QuickFeeds[FeedBSelQuick].ColorState = 0;  
  SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState);  
  
    CommonSliders[7].Value = cDefaultSpeed;  
	SliderPointer = CommonSliders[7];
    HandleSliders(false); //handle SpeedB
    break;        
  case 5: //invert
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedBButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 2) QuickFeeds[FeedBSelQuick].EffectState = 3;
      else  QuickFeeds[FeedBSelQuick].EffectState = 1;
    }
    else 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 2 || QuickFeeds[FeedBSelQuick].EffectState == 3) QuickFeeds[FeedBSelQuick].EffectState = 2; 
      else QuickFeeds[FeedBSelQuick].EffectState = 0;
    } 
    break;  
  case 6: //tint
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 1;
      CommonSliders[3].Value = 0; //intialize color sliders
      CommonSliders[4].Value = 0;
      CommonSliders[5].Value = 0; 
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    else QuickFeeds[FeedBSelQuick].ColorState = 0;  
    break;     
  case 7://color max
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 2;
      CommonSliders[3].Value = 255; //intialize color sliders
      CommonSliders[4].Value = 255;
      CommonSliders[5].Value = 255;   
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    else QuickFeeds[FeedBSelQuick].ColorState = 0;
    break; 
  case 8: //offset
    FeedFlag = false; //B
    if (FeedBButtons[8].Selected == true)  OpenMenuID = 1;
    else OpenMenuID = 0;
    break;
  case 9: //Color Scale
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 3;
      CommonSliders[3].Value = 255; //intialize color sliders
      CommonSliders[4].Value = 255;
      CommonSliders[5].Value = 255;   
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    else QuickFeeds[FeedBSelQuick].ColorState = 0;
    break;     
  case 10: //Color Min
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 4;
      CommonSliders[3].Value = 0; //intialize color sliders
      CommonSliders[4].Value = 0;
      CommonSliders[5].Value = 0; 
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    break;       
  case 11: //Contrast
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedBButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 1) QuickFeeds[FeedBSelQuick].EffectState = 3;
      else  QuickFeeds[FeedBSelQuick].EffectState = 2;
    }
    else 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 1 || QuickFeeds[FeedBSelQuick].EffectState == 3) QuickFeeds[FeedBSelQuick].EffectState = 1; 
      else QuickFeeds[FeedBSelQuick].EffectState = 0;
    }
    break;      
  case 12: //Pg Up
    if (FeedBQuickPage == 3) FeedBQuickPage = 0;
    else FeedBQuickPage++;
    for (int x=0; x != 15;x++)   QuickBButtons[x+(FeedBQuickPage*15)].displaySq(x+(FeedBQuickPage*15));
    break;   
  case 13: //Pg Down
    if (FeedBQuickPage == 0) FeedBQuickPage = 3;
    else FeedBQuickPage--;  
    for (int x=0; x != 15;x++)   QuickBButtons[x+(FeedBQuickPage*15)].displaySq(x+(FeedBQuickPage*15));
    break;
  } //end switch
}//end func
class MatrixObj
{
String matrixName;

int matrixCOM1;
int matrixTXBaud;

int matrixWidth;
int matrixHeight;
int matrixPixelDataType;

int matrixCommMethod;
String matrixServerIP;
int matrixServerPort;

String matrixPatchFileName;

String matrixQuickFeedFileName;
String matrixAbsoluteFootagePath;

String matrixAutomaticFileName;

boolean matrixEnable;

int softwareFrameRate;

int softwareGUIWidth;
int softwareGUIHeight;

boolean softwareMIDIenable;
int softwareMIDIport;

boolean softwareSerialConEnable;
int softwareSerialConPort;
int softwareSerialConBaud;

boolean softwareEnableDSVideoFeed;
boolean softwareEnableThumbnails;
boolean softwareLrgPreviewEnable;

boolean softwareAuroraCMD;

/*
COMPORT1	1
TransmissionBaud	1000000

MatrixW	68
MatrixH	24
PixelDataType	3

CommunicationMethod	1 //was type
ServerIP	192.168.1.50
ServerPort	9750
AuroraCMD	true

PatchFileName	patches/sphere-patch.txt
QuickFeedFileName	UserQuickFeeds.txt
AbsoluteFootagePath	C:\NLED\Projects\NLEDMatrix\footage\
AutomaticFileName	Auto-1.txt

//end matrix start software
FrameRate	24
GUIWidth	1024
GUIHeight	768

MIDIEnable	false
MIDIPort	0

SerialControlEnable	false
SerialControlPort	1
SerialConBaud

EnableDSVideoFeed	true
EnableThumbnails	true
ConfigPreviewEnable	false

*/

  MatrixObj()
  {

  }
} //end object
class ButtonSq extends Button {
  // Variables are inherited from the parent.
  // We could also add variables unique to the Square class if we so desire

  ButtonSq(String Label, int xpos, int ypos, int bWidth, int bHeight, int ColBG, int ColHL, int ColOut, boolean Toggle, boolean Selected, boolean Focused)
  {
    // If the parent constructor takes arguments then super() needs to pass in those arguments.
    super(Label, xpos, ypos, bWidth, bHeight, ColBG, ColHL, ColOut, Toggle, Selected, Focused);
  }

  public void displaySq(int PassedID)
  {
    strokeWeight(2);

    if(Matrix.softwareEnableThumbnails == true)
    {
      PreviewBuffer.beginDraw();
      PreviewBuffer.image(CachedThumbnails[PassedID], 0, 0, MatrixWidth, MatrixHeight);
      PreviewBuffer.endDraw();
      PreviewColorEffects(PassedID); //fill color Effects to PreviewBuffer
      image(PreviewBuffer, xpos, ypos, bWidth, bHeight);

      noFill();
      if (Selected==true)
      {
        stroke(ColHL); 
        fill(ColHL, 128);
      }
      else if (Focused == true)
      {
        stroke(cFocusedColor); 
        fill(cFocusedColor, 128);
      }
      else       
      {
        stroke(ColBG);
      }
      rect(xpos, ypos, bWidth, bHeight); //display overlay color with stroke
    }//end if()
    else
    {
      stroke(ColOut);

      if (Selected==true)  fill(ColHL);
      else if (Focused == true)   fill(cFocusedColor);
      else  fill(ColBG);
     
      rect(xpos, ypos, bWidth, bHeight);
    }

    noStroke();    
    //adjust stroke to on higlight and invert text color
    textSize((bHeight/1.75f));
    fill(0);   
    text(Label, xpos+((bWidth - textWidth(Label))/2)+2, ypos+((bHeight-(textAscent()+textDescent()))/2)+2, bWidth, bHeight);        
    fill(255);
    text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/2), bWidth, bHeight);

    if (Toggle==false) Selected = false;
  }
}


//Copied From:
/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/10275*@* */
/* !do not delete the line above, required for linking your tweak if you re-upload */
/**
 * Rick Companje's version of the Metaball demo
 * Heavily insprired by Metaball Demo Effect by luis2048. 
 */

class Blob {
  float x, y;
  float vx, vy; 
  int[] bx, by;

  Blob(float x, float y, float vx, float vy) {
    this.x = x;
    this.y = y;
    this.vx = vx;
    this.vy = vy;
    this.bx = new int[MatrixWidth];
    this.by = new int[MatrixHeight];
  }

  public void update() {
    x+=vx;
    y+=vy;

    if (x<0 || x>MatrixWidth) vx=-vx;
    if (y<0 || y>MatrixHeight) vy=-vy;

    for (int i=0; i<MatrixWidth; i++) bx[i] = PApplet.parseInt(sq(x-i));
    for (int i=0; i<MatrixHeight; i++) by[i] = PApplet.parseInt(sq(y-i));
  }
}

//================== End Copied ==============

class QuickFeed
{
  String UserID;
  int Method;
  String FileName;
  float Speed;
  int SliderRed;
  int SliderGreen;
  int SliderBlue;
  int OffsetX;
  int OffsetY;
  int ColorState; //0 regular, 
  int ControlState; //0 is play, 1 is pause, 2 is stop
  int EffectState; //0 regular, 1 invert, 2 contrast, 3 invert+contrast  
  int ContrastValue;
  int GenSlider1;
  int GenSlider2;
  int GenSlider3;
  int GenSlider4;
  /*
Methods:
   0 = Load Video
   1 = Capture Device
   
   Color State:
   0 = None
   1= Tint?? Check these
   2 = Filter??
   */

  QuickFeed(String iUserID, int iMethod, String iFileName, float iSpeed, int iSliderRed, int iSliderGreen, int iSliderBlue, int iOffsetX, int iOffsetY, 
  int iColorState, int iControlState, int iEffectState, int iContrastValue, int iGenSlider1, int iGenSlider2, int iGenSlider3, int iGenSlider4)
  {
    UserID = iUserID;
    Method = iMethod;
    FileName = iFileName;
    Speed = iSpeed;
    SliderRed = iSliderRed;
    SliderGreen = iSliderGreen;
    SliderBlue = iSliderBlue;
    OffsetX = iOffsetX;
    OffsetY = iOffsetY;
    ColorState = iColorState;
    EffectState = iEffectState;   
    ControlState = iControlState;
    ContrastValue = iContrastValue;
    GenSlider1 = iGenSlider1;
    GenSlider2 = iGenSlider2;
    GenSlider3 = iGenSlider3;
    GenSlider4 = iGenSlider4;
  }
}//end class

//============================================================================================

class GUIMenu
{
  String Label;
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int bWidth;
  int bHeight;
  int MenuID;
  boolean Opened;

  GUIMenu(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iMenuID, boolean iOpened)
  {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    MenuID = iMenuID;    
    Opened = iOpened;
  }

  public void display()
  {
    switch(MenuID)
    {
    case 0: //no menu

      break;
    case 1: //OffsetMenu
      image(OffsetMenuBG, xpos, ypos);    
      break;        
    case 2: //Main Menu
      this.displayBG();        
      fill(cMenuBGColor); 
      stroke(cMenuFontColor);
      strokeWeight(1);
      rectMode(CENTER);
      rect(xpos+360, ypos+90, 80, 15);
      rect(xpos+360, ypos+105, 80, 15);     
      rect(xpos+360, ypos+120, 80, 15);
      rect(xpos+360, ypos+135, 80, 15);   
      rect(xpos+360, ypos+150, 80, 15);          
      rectMode(CORNER);    

      fill(cMenuFontColor);
      textSize(16);
      text(this.Label+":", xpos+10, ypos+20);

      for (int i = 0; i !=MainMenuButtons.length;i++) MainMenuButtons[i].display();

      textSize(12);
      fill(0); 
      textAlign(CENTER);
      text("GUI Size:\n640x480\n800x600\n1024x768\n1400x1050\nSet in Config", xpos+360, ypos+80);

      int strSize =Matrix.matrixAbsoluteFootagePath.length();
      String tempString = Matrix.matrixAbsoluteFootagePath;
      if (strSize > 18)  tempString = Matrix.matrixAbsoluteFootagePath.substring(0, 10) + "......"+Matrix.matrixAbsoluteFootagePath.substring(strSize-12);

      textAlign(LEFT);
      fill(cMenuFontColor);    
      text("Footage Path: "+tempString, xpos+10, ypos+80);
      text("Patch File: "+Matrix.matrixPatchFileName, xpos+10, ypos+100);        
      text("QuickFeed File: "+Matrix.matrixQuickFeedFileName, xpos+10, ypos+120);     
      text("Automatic File: "+Matrix.matrixAutomaticFileName, xpos+10, ypos+140);              
      text("Communication: ", xpos+10, ypos+160);        
      textSize(12);      
      text("Set Port Number & Baud Rate or\nServer IP & Server Port in device config file", xpos+40, ypos+180);             

      if (Matrix.softwareMIDIenable == true)
      {
        for (int i = 0; i != MIDIMenuButtons.length;i++)  MIDIMenuButtons[i].display();
      }
      break;    
    case 3: //Configure Menu
      this.displayBG();
      text(this.Label, xpos, 20+ypos);
      break;    
    case 4: //gen menu A
      this.displayBG();   
      textSize(16);
      for (int i = 0; i !=GenerationSliders.length;i++) //display each of the genration sliders, with the info above them
      {
        GenerationSliders[i].display();
        fill(cMenuFontColor);  
        text(GenSliderLabelsA[i]+":", GenerationSliders[i].xpos, GenerationSliders[i].ypos-(GenerationSliders[i].ypos/100));
      }
      break;
    case 5: //gen menu B
      this.displayBG();   
      textSize(16);
      for (int i = 0; i !=GenerationSliders.length;i++) 
      {
        GenerationSliders[i].display();
        fill(cMenuFontColor);  
        text(GenSliderLabelsB[i]+":", GenerationSliders[i].xpos, GenerationSliders[i].ypos-(GenerationSliders[i].ypos/100));
      }
      break;
    }
  }

  public void displayBG()
  {
    stroke(cMenuStrokeColor);
    strokeWeight(2);
    fill(cMenuColor);
    rectMode(CORNER);
    rect(xpos, ypos, bWidth, bHeight, 10);
    noStroke();
  }

  public void Toggle()
  {
    println("GUIMenu.Toggle()" + MenuID);

    if (Opened == true) 
    {
      GUIMenus[OpenMenuID].Opened=false;
      OpenMenuID = 0;
      Opened = false; 
      return;
    }
    else 
    {
      GUIMenus[OpenMenuID].Opened=false;
      Opened =! Opened;
      OpenMenuID = MenuID;
    }
  }

  public boolean over() 
  { //checks of the mouse is over the slider, doesn't have to be on the handle
    int mX = round(mouseX / SF);
    int mY = round(mouseY / SF);      
  
    if ( mX >= xpos && mX <= xpos+bWidth && mY >= ypos && mY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
}//end class

//==================================================================

class PixelDisplay
{
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int bWidth;
  int bHeight;

  PixelDisplay(int ixpos, int iypos, int ibWidth, int ibHeight)//, color iTheColor)
  {
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
  }

  public void display()
  {
    rect(xpos, ypos, bWidth, bHeight);
  }
}//end class

//==========================================
class Button
{
  String Label;
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int bWidth;
  int bHeight;
  int ColBG;
  int ColHL;
  int ColOut;  
  boolean Toggle;
  boolean Selected;
  boolean Focused;

  Button(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iToggle, boolean iSelected, boolean iFocused)
  {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    ColBG = iColBG;
    ColHL = iColHL;
    ColOut = iColOut;
    Toggle = iToggle;
    Selected = iSelected;
    Focused = iFocused;
  }

  public void display()
  {
    strokeWeight(1);
    stroke(ColOut);

    if (Selected==true) fill(ColHL); 
    else if (Focused == true)   fill(cFocusedColor); 
    else fill(ColBG);

    rect(xpos, ypos, bWidth, bHeight, bHeight/6);  

    fill(cButtonTextColor);
    textSize((bHeight/1.75f));
    text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
    noStroke();

    if (Toggle==false) Selected = false; //if not suppose to toggle, unhighlight
  }

  public boolean over() 
  {
    int mX = round(mouseX / SF);
    int mY = round(mouseY / SF);    

    if ( mX >= xpos && mX <= xpos+bWidth && mY >= ypos && mY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
} 

//=====================================================================================

class SliderBar
{
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int slWidth; // single bar slWidthth
  int slHeight; // rect height
  int Value; 
  int Minimum; 
  int Maximum;
  int BgColor;
  int slHandleColor;
  int slSelectColor; 
  int slStrokeColor;
  boolean CircleHandle;  //ture circle, false rectangle
  boolean HorizVertToggle;
  int  SetNumber;
  

  //gotta move the int variables into float variables
  float temp1=slWidth;
  float temp2=Maximum;
  float temp3=Value;
  float temp4=Minimum;
  float MathVar=0;

  SliderBar(int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, int iBgColor, int islHandleColor, int islSelectColor, int islStrokeColor, boolean iCircleHandle, boolean iHorizVertToggle, int  iSetNumber)   
  {   
    xpos = ixp;
    ypos = iyp;  
    slWidth = iw;
    slHeight = ih;
    Value=iValue;
    Maximum=iMax;
    Minimum=iMin;
    BgColor=iBgColor;
    slHandleColor=islHandleColor;
    slSelectColor=islSelectColor;
    slStrokeColor=islStrokeColor;
    CircleHandle=iCircleHandle;     
    HorizVertToggle=iHorizVertToggle;
    SetNumber = iSetNumber;
  }

  public void move(int uX, int uY) 
  {
    //this function handles position of the slider's handle
    temp1 = slWidth;   
    temp3 = Value;
    temp4 = Minimum;

    MathVar = (((uX-xpos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
    MathVar = Maximum - (MathVar*(Maximum-Minimum));       //relative to slider position

    if (MathVar > Maximum) { //check so it doesn't drag off the end
      MathVar=Maximum;
    }
    if (MathVar < Minimum) { //check so it doesn't drag off the end
      MathVar=Minimum;
    }  
    Value=PApplet.parseInt(MathVar); //set the value based on mouse movement
  }

  public void display() 
  {
    if (this == MainMixerSlider || this == IntensitySliderA || this == IntensitySliderB)
    {
      temp1=slWidth-(slWidth/20);
      temp2=Maximum;  //move variables into float
      temp3=Value;    //or do they don't compute correctly
      temp4 = Minimum;
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 

      if (this == IntensitySliderA || this == IntensitySliderB) 
      {
        fill(cBackgroundColor);
        noStroke();
        rect(xpos-(slWidth/20), ypos-(slWidth/40), slWidth+(slWidth/8), slHeight+(slHeight/2)); 

        image(IntensityBG, xpos-(slWidth/20), ypos, slWidth+(slWidth/10), IntensityBG.height);
        image(MixerHandle, (xpos+MathVar), ypos-(slHeight/8), MixerHandle.width, MixerHandle.height/2);  
        return;
      }
      else   fill(cBackgroundColor);

      rect(xpos-(slWidth/20), ypos-(slWidth/35), slWidth+(slWidth/8), slHeight+(slHeight/3));

      image(MainMixerBG, xpos-(slWidth/20), ypos, slWidth+(slWidth/10), slHeight); //slHeight and width already scaledu sing SF
      image(MixerHandle, (xpos+MathVar), ypos-(slHeight/6), MixerHandle.width, MixerHandle.height);  
      return;
    }

    stroke(slStrokeColor);
    strokeWeight(1);

    //circle handles are displayed differently so there are if/else statements to set it correctly
    fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
    rect(xpos, ypos, slWidth, slHeight);   

    if (CircleHandle==true) temp1 = slWidth - slHeight;
    else temp1=slWidth-(slWidth/20);

    temp2=Maximum;  //move variables into float
    temp3=Value;    //or do they don't compute correctly
    temp4 = Minimum;

    float MathVar;

    if (CircleHandle==true)
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2;
    else  
      MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 

    fill(color(slSelectColor)); //draws the Selcolor over the selected area
    rect(xpos, ypos, MathVar, slHeight);

    fill(slHandleColor); //places the slider handle
    if (CircleHandle==true)   ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-1, slHeight-1); //Circle instead of rectangle
    else   rect((xpos+MathVar), ypos, slWidth/20, slHeight); //and comment this line for circle
  }


   public void setValue(int passedVal)
  {
    Value = passedVal;
    println(Value);
    if (Value > Maximum) { //check so it doesn't drag off the end
      Value = Maximum;
    }
    if (Value < Minimum) { //check so it doesn't drag off the end
      Value=Minimum;
    }
  }//end setValue() 


  public void selectSlider()
  {
  SliderPointer = this;
  GlobalDragging = true;
  }//end selectSlider



  public boolean over() 
  {
    int mX = round(mouseX / SF);
    int mY = round(mouseY / SF);    
    
    if (mX >= xpos && mX <= xpos+slWidth && mY >= ypos && mY <= ypos+slHeight) 
    {          
      return true;
    } 
    else {
      return false;
    }
  }
}

//=========================================
/*
class VertSliderBar
 {
 int xpos; // rect xposition  
 int ypos ; // rect yposition
 int slWidth; // single bar slWidthth
 int slHeight; // rect height
 int Value; 
 int Minimum; 
 int Maximum;
 color BgColor;
 color HandleColor;
 color SelectColor; 
 color StrokeColor;
 boolean CircleHandle;  
 boolean Dragging;
 
 
 //local variables 
 boolean over = false;
 
 //gotta move the int variables into float variables
 float temp1=slWidth;
 float temp2=Maximum;
 float temp3=Value;
 float temp4=Minimum;
 float MathVar=0;
 
 
 VertSliderBar(int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, color iBgColor, color iHandleColor, color iSelectColor, color iStrokeColor, boolean iCircleHandle, boolean iDragging) 
 {   
 xpos = ixp;
 ypos = iyp;  
 slWidth = iw;
 slHeight = ih;
 Value=iValue;
 Maximum=iMax;
 Minimum=iMin;
 BgColor=iBgColor;
 HandleColor=iHandleColor;
 SelectColor=iSelectColor;
 StrokeColor=iStrokeColor;
 CircleHandle=iCircleHandle;     
 Dragging=iDragging;
 }
 
 void move () //VERTICLE
 {
 //this function handles position of the slider's handle
 
 temp1 = slHeight;   
 temp3 = Value;
 temp4 = Minimum;
 
 MathVar = (((mouseY-ypos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
 //relative to slider position
 MathVar = Maximum - (MathVar*(Maximum-Minimum));   
 
 if (MathVar > Maximum) { //check so it doesn't drag off the end
 MathVar=Maximum;
 }
 
 if (MathVar < Minimum) { //check so it doesn't drag off the end
 MathVar=Minimum;
 }  
 
 Value=int(MathVar); //set the value based on mouse movement
 }
 
 void move(int uX, int uY) 
 {
 //this function handles position of the slider's handle
 
 temp1 = slWidth;   
 temp3 = Value;
 temp4 = Minimum;
 
 MathVar = (((uX-xpos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
 //relative to slider position
 MathVar = Maximum - (MathVar*(Maximum-Minimum));   
 
 if (MathVar > Maximum) { //check so it doesn't drag off the end
 MathVar=Maximum;
 }
 
 if (MathVar < Minimum) { //check so it doesn't drag off the end
 MathVar=Minimum;
 }  
 
 Value=int(MathVar); //set the value based on mouse movement
 }
 
 
 
 void display() //VERTICLE
 {
 stroke(StrokeColor);
 strokeWeight(1);
 
 //circle handles are displayed differently so there are if/else statements to set it correctly
 
 fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
 rect(xpos, ypos, slWidth, slHeight);   
 
 temp1 = slHeight - slWidth;
 
 temp2= Maximum;  //move variables into float
 temp3= Value;    //or do they don't compute correctly
 temp4 = Minimum;
 
 float MathVar;
 MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slWidth/2;
 fill(color(SelectColor)); //draws the Selcolor over the selected area
 rect(xpos, ypos, slWidth, MathVar);
 fill(HandleColor); //places the slider handle
 ellipse(xpos+(slWidth/2), ypos+MathVar, slWidth, slWidth); //Circle instead of rectangle
 }
 
 boolean over() 
 { //checks of the mouse is over the slider, doesn't have to be on the handle
  int mX = round(mouseX / SF);
  int mY = round(mouseY / SF);    

 if ( mX >= xpos && mX <= xpos+slWidth && mY >= ypos && mY <= ypos+slHeight) 
 {      
 Dragging=true;
 over = true;
 return true;
 } 
 else {
 over = false;
 return false;
 }
 }
 }
 */
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "NLEDMatrix" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
